/*
   Copyright 2018 Jason R. Grant

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.


   See the source repository for more information:
   https://github.com/stothard-group/cgview-js
*/
var CGV=function(t,e){"use strict";function s(t){if(t&&t.__esModule)return t;var e=Object.create(null);return t&&Object.keys(t).forEach((function(s){if("default"!==s){var i=Object.getOwnPropertyDescriptor(t,s);Object.defineProperty(e,s,i.get?i:{enumerable:!0,get:function(){return t[s]}})}})),e.default=t,Object.freeze(e)}var i=s(e),r="1.6.0";class n extends Array{constructor(...t){let e=t;if(1===t.length&&Array.isArray(t[0])&&(e=t[0]),1===e.length)super(),this.push(e[0]);else if(e.length>2e4){super();for(let t=0,s=e.length;t<s;t++)this.push(e[t])}else super(...e)}toString(){return"CGArray"}present(){return this.length>0}empty(){return 0===this.length}remove(t){return this.filter((e=>e!==t))}get first(){return this[0]}get last(){return this[this.length-1]}filter(t,e){if("Function"!=typeof t&&"function"!=typeof t||!this)throw new TypeError;let s=this.length>>>0,i=new Array(s),r=this,o=0,a=-1;if(void 0===e)for(;++a!==s;)a in this&&t(r[a],a,r)&&(i[o++]=r[a]);else for(;++a!==s;)a in this&&t.call(e,r[a],a,r)&&(i[o++]=r[a]);return i.length=o,new n(i)}flat(){var t=this,e=isNaN(arguments[0])?1:Number(arguments[0]);return e?Array.prototype.reduce.call(this,(function(s,i){return Array.isArray(i)?s.push.apply(s,t.flat.call(i,e-1)):s.push(i),s}),[]):Array.prototype.slice.call(this)}map(...t){return 0===this.length?this:super.map(...t)}move(t,e){if(e>=this.length){let t=e-this.length;for(;1+t--;)this.push(void 0)}return this.splice(e,0,this.splice(t,1)[0]),this}get(t){return void 0===t?this:Number.isInteger(t)?this[t-1]:"string"==typeof t?this.filter((e=>e.name&&e.name.toLowerCase()===t.toLowerCase()))[0]:Array.isArray(t)?this.filter((e=>t.some((t=>e.name===t)))):new n}unique(){return n.from(new Set(this))}attr(t){if(1===arguments.length&&"object"==typeof t){const e=Object.keys(t),s=e.length;for(let i=0,r=this.length;i<r;i++)for(let r=0;r<s;r++)this[i][e[r]]=t[e[r]]}else if(2===arguments.length)for(let t=0,e=this.length;t<e;t++)this[t][arguments[0]]=arguments[1];else if(void 0!==t)throw new Error("attr(): must be 2 arguments or a single object");return this}each(t){for(let e=0,s=this.length;e<s;e++)t.call(this[e],e,this[e]);return this}asArray(){return Array.from(this)}static arrayerize(t){return"CGArray"===t.toString()?t:new n(t)}}const o={defaultFor:function(t,e){return void 0===t?e:t},validate:function(t,e){const s=(t=n.arrayerize(t)).filter((function(t){return e.indexOf(t)<0}));return 0===s.length||(console.error(`The value(s) '${s.join(",")}' is/are not one of the following valid options: ${e.join(", ")}`),!1)},booleanify:function(t){return"false"!==t&&"False"!==t&&void 0!==t&&!1!==t},capitalize:function(t){return t.replace(/^\w/,(t=>t.toUpperCase()))},getPixelRatio:function(t){const e=t.getContext("2d");return(window.devicePixelRatio||1)/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)},scaleResolution:function(t,e){if(1!==e){const s=t.width,i=t.height;t.width=s*e,t.height=i*e,t.style.width=`${s}px`,t.style.height=`${i}px`,t.getContext("2d").scale(e,e)}},elapsedTime:function(t){return`${(new Date).getTime()-t} ms`},angleFromPosition:function(t,e){let s=.5*Math.PI;return 0!==t&&(s=Math.atan(Math.abs(e/t))),e>=0&&t>=0?s=0-s:e<0&&t>=0||(e<0&&t<0?s=Math.PI-s:e>=0&&t<0&&(s=Math.PI+s)),s},clockPositionForAngle:function(t){let e=Math.round((t+Math.PI/2)*(6/Math.PI));return e>12?e-=12:e<1&&(e+=12),e},rectOriginForAttachementPoint:function(t,e,s,i){let r,n;switch(e){case 1:case 2:r=t.x-s,n=t.y;break;case 3:r=t.x-s,n=t.y-i/2;break;case 4:case 5:r=t.x-s,n=t.y-i;break;case 6:r=t.x-s/2,n=t.y-i;break;case 7:case 8:r=t.x,n=t.y-i;break;case 9:r=t.x,n=t.y-i/2;break;case 10:case 11:r=t.x,n=t.y;break;case 12:r=t.x-s/2,n=t.y}return{x:r,y:n}},round:function(t,e){return e=e||2,Number(t.toFixed(e))},commaNumber:function(t){return i.format(",")(t)},dotProduct:function(t,e){let s=0;for(let i=0,r=t.length;i<r;i++)s+=t[i]*e[i];return s},pointsAdd:function(t,e){const s=[0,0];return s[0]=t[0]+e[0],s[1]=t[1]+e[1],s},pointsSubtract:function(t,e){const s=[0,0];return s[0]=t[0]-e[0],s[1]=t[1]-e[1],s},circleAnglesFromIntersectingLine:function(t,e,s,i,r){const n=o.pointsSubtract([i,r],[e,s]),a=[e,s],h=o.dotProduct(n,n),l=2*o.dotProduct(a,n);let c=l*l-4*h*(o.dotProduct(a,a)-t*t);const d={};if(c>=0){c=Math.sqrt(c);const t=(-l-c)/(2*h),n=(-l+c)/(2*h);if(t>=0&&t<=1){const n=e+t*(i-e),a=s+t*(r-s);d.t1=o.angleFromPosition(n,a)}if(n>=0&&n<=1){const t=e+n*(i-e),a=s+n*(r-s);d.t2=o.angleFromPosition(t,a)}}return d},circleAnglesFromIntersectingRect:function(t,e,s,i,r){let n=[];if(n.push(o.circleAnglesFromIntersectingLine(t,e,s,e+i,s)),n.push(o.circleAnglesFromIntersectingLine(t,e+i,s,e+i,s-r)),n.push(o.circleAnglesFromIntersectingLine(t,e+i,s-r,e,s-r)),n.push(o.circleAnglesFromIntersectingLine(t,e,s-r,e,s)),n=n.filter((t=>Object.keys(t).length>0)),n.length>0){const t=Object.keys(n[0]);1===t.length&&"t1"===t[0]&&n.push(n.shift()),2===t.length&&(n.push({t1:n[0].t1}),n[0].t1=void 0),n=n.map((t=>{const e=[];return void 0!==t.t1&&e.push(t.t1),void 0!==t.t2&&e.push(t.t2),e})),n=[].concat(...n)}return n},indexOfValue:function(t,e,s){let i,r,n=0,o=t.length-1;if(t[n]>=e)return n;if(t[o]<=e)return o;for(;o-n>1;)if(i=(n+o)/2|0,r=t[i],r<e)n=i;else{if(!(r>e))return i;o=i}return s?o:n},oppositeSigns:function(t,e){return t*e<0},base2:function(t){return Math.pow(2,Math.ceil(Math.log(t)/Math.log(2)))},constrain:function(t,e,s){return Math.max(Math.min(s,t),e)},merge:function(...t){const e={};let s,i,r;for(let n=0,o=arguments.length;n<o;n++)if(s=t[n],"object"==typeof s){i=Object.keys(s);for(let t=0,n=i.length;t<n;t++)r=i[t],e[r]=s[r]}return e},scaleValue:function(t,e={min:0,max:1},s={min:0,max:1}){return(s.max-s.min)*(t-e.min)/(e.max-e.min)+s.min},uniqueName:function(t,e){return e.includes(t)?o.uniqueId(`${t}-`,2,e):t},uniqueId:function(t,e,s){let i;do{i=t+e,e++}while(s.indexOf(i)>-1);return i},randomHexString:function(t){let e="";const s="abcdef0123456789";for(let i=0;i<t;i++)e+=s.charAt(Math.floor(Math.random()*s.length));return e},getOffset:function(t){let e=0,s=0;for(;t&&!isNaN(t.offsetLeft)&&!isNaN(t.offsetTop);)e+=t.offsetLeft-t.scrollLeft,s+=t.offsetTop-t.scrollTop,t=t.offsetParent;return{top:s,left:e}},isNumeric:function(t){return isFinite(t)&&parseFloat(t)===t},colors:function(t,e,s,i,r,n,o,a,h,l){const c=[];void 0===t&&(t=50),void 0===e&&(e=200),void 0===s&&(s=30),void 0===i&&(i=1),void 0===r&&(r=2.4),void 0===n&&(n=2.4),void 0===o&&(o=2.4),void 0===a&&(a=0),void 0===h&&(h=2),void 0===l&&(l=4);for(let d=0;d<t;++d){const t=Math.round(Math.sin((r*d+a)*s)+e),g=Math.round(Math.sin((n*d+h)*s)+e),u=Math.round(Math.sin((o*d+l)*s)+e);c.push(`rgba(${t},${g},${u},${i})`)}return c},testColors:function(t){t.forEach((function(t){document.write(`<font style="color:${t}">&#9608;</font>`)})),document.write("<br/>")}};class a{constructor(t,e){this._viewer=t,this.value=e}toString(){return"Position"}static get names(){return["top-left","top-center","top-right","middle-left","middle-center","middle-right","bottom-left","bottom-center","bottom-right"]}static percentsFromName(t){const[e,s]=t.split("-");let i,r;return"top"===e?r=0:"middle"===e?r=50:"bottom"===e&&(r=100),"left"===s?i=0:"center"===s?i=50:"right"===s&&(i=100),{xPercent:i,yPercent:r}}static nameFromPercents(t,e){const s=[0,50,100];if(s.includes(t)&&s.includes(e)){let s="";return 0===e?s+="top":50===e?s+="middle":100===e&&(s+="bottom"),0===t?s+="-left":50===t?s+="-center":100===t&&(s+="-right"),s}}get viewer(){return this._viewer}get canvas(){return this.viewer.canvas}get x(){return this._x}get y(){return this._y}get point(){return{x:this.x,y:this.y}}get value(){return this._value}set value(t){return this._processValue(t)}get type(){return this._type}get name(){return a.names.includes(this.value)&&this.value||a.nameFromPercents(this.xPercent,this.yPercent)}get xPercent(){return this._xPercent}get yPercent(){return this._yPercent}get on(){return this._on}set on(t){"map"===t?this.convertToOnMap():"canvas"===t&&this.convertToOnCanvas()}get onMap(){return"map"===this.on}get onCanvas(){return"canvas"===this.on}get offsetType(){return this._offsetType}get offsetPositive(){if(this.onMap){const{bbOffsetPercent:t,mapOffset:e}=this.value;return("map"===this.offsetType?e:t)>=0}}formatNumber(t,e=0,s=100,i=1){return o.round(o.constrain(t,e,s),i)}_processValue(t){if("string"==typeof t)this._value=o.validate(t,a.names)?t:"middle-center",this._on="canvas",this._type="name";else if("object"==typeof t){const e=Object.keys(t);if(e.includes("xPercent")&&e.includes("yPercent")){const{xPercent:e,yPercent:s}=t;this._xPercent=this.formatNumber(e),this._yPercent=this.formatNumber(s),this._value={xPercent:this.xPercent,yPercent:this.yPercent},this._on="canvas",this._type="percent"}else if(e.includes("lengthPercent")){const{lengthPercent:e}=t;this._value={lengthPercent:this.formatNumber(e,0,100,6)},this._on="map",this._type="percent"}else e.includes("bp");if(this.onMap){const{mapOffset:e,bbOffsetPercent:s}=t;o.isNumeric(e)?(this._offsetType="map",this._value.mapOffset=Math.round(e)):o.isNumeric(s)?(this._offsetType="backbone",this._value.bbOffsetPercent=this.formatNumber(s,-100,100,0)):(this._offsetType="map",this._value.mapOffset=20)}}this.refresh()}refresh(){let t;this.onCanvas?"name"===this.type?t=this._originFromName(this.value):"percent"===this.type&&(t=this._originFromCanvasPercents(this.value)):this.onMap&&"percent"===this.type&&(t=this._originFromMapPercent(this.value)),this._x=t.x,this._y=t.y}_originFromName(t){const{xPercent:e,yPercent:s}=a.percentsFromName(t);return this._xPercent=e,this._yPercent=s,this._originFromCanvasPercents({xPercent:e,yPercent:s})}_originFromCanvasPercents({xPercent:t,yPercent:e}){return{x:this.canvas.width*t/100,y:this.canvas.height*e/100}}_originFromMapPercent(t=this.value){let e;if(50===t.lengthPercent&&0===t.mapOffset)e=this.viewer.layout.centerCaptionPoint();else{const s=this.viewer.sequence.length*t.lengthPercent/100,i=this.centerOffset(t);e=this.canvas.pointForBp(s,i)}return e}centerOffset(t=this.value){const{bbOffsetPercent:e,mapOffset:s}=t,i=this.viewer.layout;let r;return r="backbone"===this.offsetType?i.centerOffsetForBBOffsetPercent(e):i.centerOffsetForMapOffset(s),r}convertToOnMap(){if(this.onMap)return this;const t=this.viewer,e=this.canvas,s=t.layout,i=this.point,r=e.bpForPoint(i),n=this.formatNumber(r/t.sequence.length*100),o=s.centerOffsetForPoint(i),a=t.backbone.adjustedCenterOffset;let h,l;return o>=s.centerOutsideOffset?(h=o-s.centerOutsideOffset,this.value={lengthPercent:n,mapOffset:h}):o<=s.centerInsideOffset?(h=o-s.centerInsideOffset,this.value={lengthPercent:n,mapOffset:h}):o>=a?(l=(o-a)/s.bbOutsideOffset*100,this.value={lengthPercent:n,bbOffsetPercent:l}):o<a&&(l=(a-o)/s.bbInsideOffset*100,this.value={lengthPercent:n,bbOffsetPercent:l}),this}convertToOnCanvas(){if(this.onCanvas)return this;const t=this.viewer,e=this.canvas,s=this.value,i=this.centerOffset(s),r=t.sequence.length*s.lengthPercent/100,n=e.pointForBp(r,i);return this.value={xPercent:this.formatNumber(n.x/t.width*100),yPercent:this.formatNumber(n.y/t.height*100)},this}moveTo(t){if(this.onMap){const e=this.viewer.sequence.length*this.value.lengthPercent/100,s=this.viewer.backbone.adjustedCenterOffset-this.centerOffset();this.viewer.moveTo(e,null,{duration:t,bbOffset:s})}}toJSON(t={}){return this.value}}class h{constructor(t){"string"==typeof t?"auto"===t?this.auto=!0:this.name=t:"object"==typeof t?(this.xPercent=o.defaultFor(Number(t.xPercent),50),this.yPercent=o.defaultFor(Number(t.yPercent),50)):(this.xPercent=50,this.yPercent=50)}toString(){return"Anchor"}get auto(){return this._auto}set auto(t){this._auto=Boolean(t)}get xPercent(){return this._xPercent}set xPercent(t){this._xPercent=Math.round(o.constrain(t,0,100)),this._name=a.nameFromPercents(this.xPercent,this.yPercent)}get yPercent(){return this._yPercent}set yPercent(t){this._yPercent=Math.round(o.constrain(t,0,100)),this._name=a.nameFromPercents(this.xPercent,this.yPercent)}get name(){return this._name}set name(t){t&&o.validate(t,a.names)&&(this._name=t,this._updatePercentsFromName(t))}_updatePercentsFromName(t){const{xPercent:e,yPercent:s}=a.percentsFromName(t);this._xPercent=e,this._yPercent=s}autoUpdateForPosition(t){if(this.auto)if(t.onCanvas)this.xPercent=t.xPercent,this.yPercent=t.yPercent;else if(t.onMap){const e=t.viewer.format,s=t.offsetPositive,i=t.value.lengthPercent;"linear"===e?(this.yPercent=s?100:0,this.xPercent=i):"circular"===e&&(i<=7?(this.xPercent=(i+7)/14*100,this.yPercent=100):i>7&&i<43?(this.xPercent=0,this.yPercent=(i-7)/36*100):i>=43&&i<=57?(this.xPercent=(i-43)/14*100,this.yPercent=0):i>57&&i<93?(this.xPercent=100,this.yPercent=(i-57)/36*100):i>=93&&(this.xPercent=(i-93)/14*100,this.yPercent=100))}}toJSON(){return this.auto?"auto":this.name?this.name:{xPercent:this.xPercent,yPercent:this.yPercent}}}let l=0;class c{constructor(t,e={},s={}){this._viewer=t,this.meta=o.merge(e.meta,s),this.visible=o.defaultFor(e.visible,!0),this._cgvID="cgv-id-"+l++,t._objects[this.cgvID]=this}toString(){return"CGObject"}get cgvID(){return this._cgvID}get viewer(){return this._viewer}get canvas(){return this.viewer.canvas}get layout(){return this.viewer.layout}get sequence(){return this.viewer.sequence}get visible(){return this._visible}set visible(t){this._visible=t}get meta(){return this._meta}set meta(t){this._meta=t}deleteFromObjects(){delete this.viewer._objects[this.cgvID]}}class d{constructor(t,e,s,i,r){this.x=t,this.y=e,this.width=s,this.height=i,this._label=r}get width(){return this._width}set width(t){this._width=t}get height(){return this._height}set height(t){this._height=t}get x(){return this._x}set x(t){this._x=t}get y(){return this._y}set y(t){this._y=t}get bottom(){return this.y+this.height}get top(){return this.y}get left(){return this.x}get right(){return this.x+this.width}overlap(t){const e=this;let s=!1;for(let i=0,r=t.length;i<r;i++){const r=t[i];if(e.x<=r.right&&r.x<=e.right+4&&e.y<=r.bottom&&r.y<=e.bottom){s=r;break}s=!1}return s}containsPt(t,e){return t>=this.x&&t<=this.x+this.width&&e>=this.y&&e<=this.y+this.height}ptForClockPosition(t){let e,s;switch(t){case 1:case 2:e=this.x+this.width,s=this.y;break;case 3:e=this.x+this.width,s=this.y+this.height/2;break;case 4:case 5:e=this.x+this.width,s=this.y+this.height;break;case 6:e=this.x+this.width/2,s=this.y+this.height;break;case 7:case 8:e=this.x,s=this.y+this.height;break;case 9:e=this.x,s=this.y+this.height/2;break;case 10:case 11:e=this.x,s=this.y;break;case 12:e=this.x+this.width/2,s=this.y}return{x:e,y:s}}}class g{constructor(t,e={}){this._annotation=t,this._initialLabelLineLength=t._labelLineLength,this._labelLineMarginInner=t._labelLineMarginInner,this._labelLineMarginOuter=t._labelLineMarginOuter}get viewer(){return this.annotation.viewer}get annotation(){return this._annotation}get canvas(){return this.viewer.canvas}get initialLabelLineLength(){return this._initialLabelLineLength}rectCenterOffset(t=this.initialLabelLineLength){return this._rectOffsetWithoutLineLength+t}toString(){return"LabelPlacementDefault"}get name(){return"default"}placeLabels(t,e){const s=this.canvas;let i,r,a,h;this._rectOffsetWithoutLineLength=e+this._labelLineMarginInner+this._labelLineMarginOuter;const l=new n;for(let e=0,n=t.length;e<n;e++){i=t[e],r=i.bp,a=this.initialLabelLineLength;do{const t=s.pointForBp(r,this.rectCenterOffset(a)),e=o.rectOriginForAttachementPoint(t,i.lineAttachment,i.width,i.height);i.rect=new d(e.x,e.y,i.width,i.height),h=i.rect.overlap(l),a+=i.height}while(h);l.push(i.rect),i.attachementPt=i.rect.ptForClockPosition(i.lineAttachment)}}}class u extends g{constructor(t,e={}){super(t,e),this.viewer.off("click.labels-test"),this.viewer.on("click.labels-test",(t=>{if("label"===t.elementType){const e=t.element;console.log(`LABEL: ${e.name}, BP:${e.bp}, aBP:${e._attachBp}, D:${e._direction}, P:${e._popped}`),console.log(e,e._island)}}))}toString(){return"LabelPlacementAngled"}get name(){return"angled"}_nextLabel(t,e=1){return e>=0?t._next:t._prev}_prevLabel(t,e=1){return e>=0?t._prev:t._next}placeLabels(t,e){this._debug&&console.log("LABELS -----------------------------------------");const s=this.canvas;let i;this._rectOffsetWithoutLineLength=e+this._labelLineMarginInner+this._labelLineMarginOuter;const r=1/s.pixelsPerBp(this.rectCenterOffset());this._boundaryMarginBp=t[0]?.height*r/2,t.sort(((t,e)=>t.bp-e.bp));this.maxBpAdjustment=this.maxBpAdjustForAngle(80);for(let e=0,r=t.length;e<r;e++){i=t[e],i._attachBp=i.bp,i._direction=0,i._popped=!1,i._placementIndex=e,i._next=e===r-1?t[0]:t[e+1],i._prev=0===e?t[t.length-1]:t[e-1];const n=s.pointForBp(i.bp,this.rectCenterOffset()),a=o.rectOriginForAttachementPoint(n,i.lineAttachment,i.width,i.height);i._defaultRect=new d(a.x,a.y,i.width,i.height),i.rect=i._defaultRect,i._lineLength=this.initialLabelLineLength,i._maxBpAdjustment=[6,12].includes(i.lineAttachment)?this.maxBpAdjustment/2:this.maxBpAdjustment}let n=this.findIslands(t);this.placeIslands(n),n=this.mergeIslands(n),this.finalLabelAdjust(t);for(let e=0,s=t.length;e<s;e++){const s=t[e];s.rect&&(s.attachementPt=s.rect.ptForClockPosition(s.lineAttachment))}}findIslands(t=[]){const e=this.viewer.sequence,s=e.length/2;let i,r;const n=[];if(0===t.length)return n;let o=new p(this,t[0]);for(let a=1,h=t.length;a<h;a++){i=t[a],r=this._prevLabel(i);const h=i._defaultRect.overlap([r._defaultRect]),l=e.lengthOfRange(r.bp,i.bp);h&&l<=s?o.addLabels(i):(n.push(o),o=new p(this,i))}return n.push(o),n}placeIslands(t){for(let e=0,s=t.length;e<s;e++){t[e].placeLabels()}}mergeIslands(t){const e=this.viewer.sequence;if(t.length<=1)return t;let s,i,r,n=t,o=t[0]?.labels,a=0;do{s=!1,i=[],a++;for(let t=0,a=n.length;t<a;t++){const h=n[t],l=t>=a-1?n[0]:n[t+1];if(h.placeLabels(),l.placeLabels(),l===h)break;if(h.clash(l)){if(h.canMergeWith(l)){if(o=h.labels.concat(l.labels),r=new p(this,o),r.startBoundaryBp=h.startBoundaryBp,h===n[a-1]){i[0]=r,r.placeLabels();break}i.push(r),n[t+2]&&(i=i.concat(n.slice(t+2))),n=i,s=!0;break}{const t=e.lengthOfRange(h.lastLabel.bp,l.firstLabel.bp);if(t<e.length/4){let s=t/2;s-=this._boundaryMarginBp,s=s<0?0:s,h.stopBoundaryBp=e.addBp(h.lastLabel.bp,s),l.startBoundaryBp=e.subtractBp(l.firstLabel.bp,s),h.placeLabels()}i.push(h)}}else i.push(h)}}while(s&&a<t.length);return i}_getNextAttachPt(t,e=1){const s=this.viewer.scale,i=e>0,r=this.rectCenterOffset(),n=r*r;let o,a,h,l,c=t.height,d=t.width;const g=this._prevLabel(t,e)?.rect;if(!g)return this.canvas.pointForBp(t.bp,r);const u="linear"===this.viewer.format;switch(t.lineAttachment){case 7:case 8:a=i?g.bottom+c+2:g.top-2,h=s.y.invert(a),l=Math.sqrt(n-h*h),o=s.x(l);break;case 9:a=i?g.bottom+c/2+2:g.top-c/2-2,h=s.y.invert(a),l=Math.sqrt(n-h*h),o=s.x(l);break;case 10:case 11:a=i?g.bottom+2:g.top-c-2,h=s.y.invert(a),l=Math.sqrt(n-h*h),o=s.x(l);break;case 12:o=i?g.left-d/2-2:g.right+d/2+2,l=s.x.invert(o),h=-Math.sqrt(n-l*l),a=s.y(h);break;case 1:case 2:a=i?g.top-c-2:g.bottom+2,h=s.y.invert(a),l=-Math.sqrt(n-h*h),o=s.x(l);break;case 3:a=i?g.top-c/2-2:g.bottom+c/2+2,h=s.y.invert(a),l=-Math.sqrt(n-h*h),o=s.x(l);break;case 4:case 5:a=i?g.top-2:g.bottom+c+2,h=s.y.invert(a),l=-Math.sqrt(n-h*h),o=s.x(l);break;case 6:o=i?g.right+d/2+2:g.left-d/2-2,u?a=g.top:(l=s.x.invert(o),h=Math.sqrt(n-l*l),a=s.y(h))}return{x:o,y:a}}maxBpAdjustForAngle(t){this.rectCenterOffset();const e=this.initialLabelLineLength,s=t*Math.PI/180,i=e*Math.tan(s),r=this.canvas.pointForBp(1,this.rectCenterOffset());r.x+=i;const n=this.canvas.bpForPoint(r);return this._debug&&console.log(`BP Diff for angle ${t}°: ${n}`),n}finalLabelAdjust(t){const e=this.canvas;let s,i,r,a;const h=new n;for(let n=0,l=t.length;n<l;n++){s=t[n],i=s._attachBp,r=s._lineLength;do{const t=e.pointForBp(i,this.rectCenterOffset(r)),n=o.rectOriginForAttachementPoint(t,s.lineAttachment,s.width,s.height);s.rect=new d(n.x,n.y,s.width,s.height),a=s.rect.overlap(h),r+=s.height}while(a);s._lineLength=r,h.push(s.rect),s.attachementPt=s.rect.ptForClockPosition(s.lineAttachment)}}}class p{constructor(t,e){this.labelPlacement=t,this._labels=[],this.canvas=t.canvas,this.viewer=t.viewer,this.sequence=this.viewer.sequence,this._placedRects=[],this.addLabels(e)}get labels(){return this._labels}get length(){return this.labels.length}get single(){return 1===this.labels.length}get firstLabel(){return this.labels[0]}get lastLabel(){return this.labels[this.labels.length-1]}get placedRects(){return this._placedRects}addLabels(t){if(t)if(Array.isArray(t)){this._labels=this._labels.concat(t);for(const e of t)e._island=this}else this._labels.push(t),t._island=this}placeLabels(){let t,e;if(!this.single){const s=Math.floor((this.length-1)/2);t=this.adjustLabels(s,1),e=this.adjustLabels(s,-1)}(t||e)&&(this.placeWithMaxAngle(),this.placePoppedLabels()),this._placedRects=this.labels.map((t=>t.rect))}adjustLabels(t,e){const s=this.canvas;for(let i=t+e,r=this.labels.length;e>0?i<r:i>=0;i+=e){const t=this.labels[i];let r=this.labelPlacement._getNextAttachPt(t,e),n=s.bpForPoint(r);if(e>0){if(n>this.stopBoundaryBp)return!0}else if(e<0&&n<this.startBoundaryBp)return!0;if(isNaN(n)||Math.abs(n-t.bp)>t._maxBpAdjustment)return!0;this.adjustLabelWithAttachPt(t,r)}}placeWithMaxAngle(){let t,e,s,i,r;this.canvas,this.adjustLabelToMaxAngle(this.firstLabel,-1),this.adjustLabelToMaxAngle(this.lastLabel,1);for(let n=1,o=this.labels.length;n<o;n++){if(t=n,e=o-1-n,t>e)return;if(t===e){r=this.labels[e],this.adjustLabelToNextAttachPt(r,1);const s=isNaN(r._attachBp),n=i||this.lastLabel;return void((this.labelsClash(r,n)||s)&&(this.poppedStartIndex=t,this.poppedStopIndex=e))}s=this.labels[t],i=this.labels[e],this.adjustLabelToNextAttachPt(s,1),this.adjustLabelToNextAttachPt(i,-1);const a=isNaN(s._attachBp)||isNaN(NaN===i._attachBp);if(this.labelsClash(s,i)||a)return this.poppedStartIndex=this.adjustPopIndex(t,-1),void(this.poppedStopIndex=this.adjustPopIndex(e,1))}}adjustPopIndex(t,e){let s=t;for(let i=t+e,r=this.labels.length;e>0?i<r:i>=0;i+=e){if(this.labels[i]._direction==e)break;s=i}return s}placePoppedLabels(){if(void 0===this.poppedStartIndex||void 0===this.poppedStopIndex)return;let t,e,s;const i=this.viewer.sequence;i.length;let r=this.labels.filter(((t,e)=>e<this.poppedStartIndex||e>this.poppedStopIndex)).map((t=>t.rect));const n=this.firstLabel?._prev?._island;n&&(r=r.concat(n.placedRects));const o=Math.max(this.poppedStartIndex-1,0),a=Math.min(this.poppedStopIndex+1,this.labels.length-1),h=this.labels[o]._attachBp,l=this.labels[a]._attachBp,c=i.lengthOfRange(h,l)/(this.poppedStopIndex-this.poppedStartIndex+2);let d,g,u=1,p=this.labelPlacement.initialLabelLineLength;for(let i=this.poppedStartIndex;i<=this.poppedStopIndex;i++){t=this.labels[i],e=h+c*u,t._popped=!0;let n=u/(this.poppedStopIndex-this.poppedStartIndex+1);n*=5;let o=p/this.labelPlacement.initialLabelLineLength;o/=5,d=p-1.1*t.height*n*o,d=Math.max(d,this.labelPlacement.initialLabelLineLength),g=-1;do{const i=this.canvas.pointForBp(e,this.labelPlacement.rectCenterOffset(p));this.adjustLabelWithAttachPt(t,i),s=t.rect.overlap(r),p+=1.1*t.height*g,p<d&&(g=1,p=d)}while(s);t._lineLength=p,r.push(t.rect),u++}}adjustLabelToNextAttachPt(t,e){let s=this.labelPlacement._getNextAttachPt(t,e);this.adjustLabelWithAttachPt(t,s)}adjustLabelWithAttachPt(t,e){const s=o.rectOriginForAttachementPoint(e,t.lineAttachment,t.width,t.height);t.rect=new d(s.x,s.y,t.width,t.height),t._attachBp=this.canvas.bpForPoint(e);const i=t.bp-t._attachBp;t._direction=i>0?-1:i<0?1:0;const r=this.viewer.sequence.length/2;Math.abs(i)>r&&(t._direction*=-1)}forwardBoundary(){if(this.stopBoundaryBp)return this.stopBoundaryBp;const t=this.lastLabel,e=t._next;this.viewer.sequence.length;let s=this.sequence.lengthOfRange(t.bp,e.bp);return s=s>t._maxBpAdjustment?t._maxBpAdjustment:s,t.bp+s}backwardBoundary(){if(this.startBoundaryBp)return this.startBoundaryBp;const t=this.firstLabel,e=this.firstLabel._prev,s=this.viewer.sequence.length;let i;return e?._attachBp>t.bp?i=s-e.bp+t.bp:e&&(i=t.bp-e._attachBp-this.labelPlacement._boundaryMarginBp),i=i>t._maxBpAdjustment?t._maxBpAdjustment:i,t.bp-i}adjustLabelToMaxAngle(t,e){t._maxBpAdjustment;let s;t.bp,e>0?s=this.forwardBoundary():e<0&&(s=this.backwardBoundary());const i=this.canvas.pointForBp(s,this.labelPlacement.rectCenterOffset());this.adjustLabelWithAttachPt(t,i)}clash(t){return this.labelsClash(this.lastLabel,t.firstLabel)}labelsClash(t,e){const s=this.viewer.sequence,i=t.rect.overlap([e.rect]),r=s.lengthOfRange(t.bp,e.bp),n=s.lengthOfRange(t._attachBp,e._attachBp),o=r<s.length/2&&n>s.length/2;return i||o}canMergeWith(t){const e=this.viewer.sequence,s=1*(this.firstLabel._maxBpAdjustment+t.lastLabel._maxBpAdjustment),i=e.lengthOfRange(this.firstLabel._attachBp,t.lastLabel._attachBp),r=e.lengthOfRange(this.firstLabel.bp,t.lastLabel.bp);return i<=s&&r<=s}}class f{constructor(){this._handlers={}}on(t,e){const s=this._handlers;m(t);const i=v(t);s[i]||(s[i]=[]),s[i].push(new b(t,e))}off(t,e){const s=this._handlers;m(t);const i=v(t),r=w(t);void 0===e?r?i?s[i]=s[i].filter((t=>t.namespace!==r)):Object.keys(s).forEach((function(t){s[t]=s[t].filter((t=>t.namespace!==r))})):s[i]=void 0:s[i]=s[i].filter((t=>t.callback!==e)),this._handlers=s}trigger(t,e){const s=this._handlers;m(t);const i=v(t),r=w(t);Array.isArray(s[i])&&s[i].forEach((function(t){r?t.namespace===r&&t.callback.call(null,e):t.callback.call(null,e)}))}}const m=function(t){if("string"!=typeof t)throw new Error("Type must be a string")},b=function(t,e){this.callback=e,this.eventType=v(t),this.namespace=w(t)},v=function(t){return t.replace(/\..*/,"")},w=function(t){const e=t.match(/\.(.*)/);return e?e[1]:void 0};class _ extends f{constructor(t){super(),this._rawFont=t}toString(){return"Font"}set _rawFont(t){if("string"==typeof t||t instanceof String)this.string=t;else{const e=Object.keys(t);e.includes("family")&&e.includes("style")&&e.includes("size")?(this._family=t.family,this._style=t.style,this._size=Number(t.size),this._generateFont()):console.log("Font objects require the following keys: family, style, and size")}}get string(){return`${this.family},${this.style},${this.size}`}set string(t){const e=(t=t.replace(/ +/g,"")).split(",");3===e.length?(this._family=e[0],this._style=e[1],this._size=Number(e[2])):console.log("Font must have 3 parts"),this._generateFont()}get css(){return this._font}cssScaled(t){return t&&1!==t?`${this._styleAsCss()} ${this.size*t}px ${this.family}`:this.css}get family(){return this._family||"sans-serif"}set family(t){this._family=t,this._generateFont()}get size(){return this._size||12}set size(t){this._size=Number(t),this._generateFont()}get style(){return this._style||"plain"}set style(t){this._style=t,this._generateFont()}get bold(){return"bold"===this.style||"bold-italic"===this.style}set bold(t){t?"plain"===this.style?this.style="bold":"italic"===this.style&&(this.style="bold-italic"):"bold"===this.style?this.style="plain":"bold-italic"===this.style&&(this.style="italic")}get italic(){return"italic"===this.style||"bold-italic"===this.style}set italic(t){t?"plain"===this.style?this.style="italic":"bold"===this.style&&(this.style="bold-italic"):"italic"===this.style?this.style="plain":"bold-italic"===this.style&&(this.style="bold")}get height(){return this.size}width(t,e){return t.font=this.css,t.measureText(e).width}copy(){return new _(this.string)}_styleAsCss(){return"plain"===this.style?"normal":"bold"===this.style?"bold":"italic"===this.style?"italic":"bold-italic"===this.style?"italic bold":""}_generateFont(){this._font=`${this._styleAsCss()} ${this.size}px ${this.family}`,this.trigger("change",this)}}_.calculateWidths=function(t,e,s){t.save();const i=[],r=[];for(let t=0,i=e.length;t<i;t++)r.push({index:t,font:e[t],text:s[t]});r.sort(((t,e)=>t.font>e.font?1:-1));let n,o,a="";for(let e=0,s=r.length;e<s;e++)n=r[e].font,o=r[e].text,n!==a&&(t.font=n,a=n),i[r[e].index]=t.measureText(o).width;return t.restore(),i};class y{constructor(t){this.setColor(t)}toString(){return"Color"}setColor(t){if("string"==typeof t||t instanceof String)this._string=t;else if("Color"===t.toString())this._string=t.rgbaString;else{const e=Object.keys(t);e.includes("h")&&e.includes("s")&&e.includes("v")?this.hsv=t:e.includes("r")&&e.includes("g")&&e.includes("b")&&e.includes("a")?this.rgba=t:e.includes("r")&&e.includes("g")&&e.includes("b")&&(this.rgb=t)}}set _string(t){const e=y.string2rgba(t,this.opacity);this._rgbaString=y.rgba2String(e),this._updateOpacityFromRgba()}get opacity(){return void 0===this._opacity?1:this._opacity}set opacity(t){this._opacity=y._validateOpacity(t),this._updateRgbaOpacity()}get rgbaString(){return this._rgbaString}get rgbString(){return y.rgb2String(this.rgb)}get rgb(){const t=/^rgba\((\d+),(\d+),(\d+)/.exec(this.rgbaString);return t?{r:Number(t[1]),g:Number(t[2]),b:Number(t[3])}:void 0}set rgb(t){this._string=y.rgb2String(t),this._updateOpacityFromRgba()}get rgba(){const t=/^rgba\((\d+),(\d+),(\d+),([\d.]+)/.exec(this.rgbaString);return t?{r:Number(t[1]),g:Number(t[2]),b:Number(t[3]),a:Number(t[4])}:void 0}set rgba(t){this._string=y.rgba2String(t),this._updateOpacityFromRgba()}get hsv(){return y.rgb2hsv(this.rgb)}set hsv(t){const e=y.hsv2rgb(t);e.a=this.opacity,this.rgba=e}get hex(){return y.rgb2hex(this.rgb)}get hsl(){return y.rgb2hsl(this.rgb)}set hsl(t){const e=y.hsl2rgb(t);e.a=this.opacity,this.rgba=e}copy(){return new y(this.rgbaString)}equals(t,e=!1){const s=this.rgba,i=t.rgba;return e?s.r===i.r&&s.g===i.g&&s.b===i.b:s.r===i.r&&s.g===i.g&&s.b===i.b&&s.a===i.a}inArray(t,e){let s=!1;for(const i of t)if(this.equals(i,e)){s=!0;break}return s}highlight(t=.25){const e=this.hsv;e.v+=e.v<.5?t:-t,this.hsv=e}lighten(t){const e=this.hsl;return e.l+=o.constrain(t,0,1),e.l=Math.min(e.l,1),this.hsl=e,this}darken(t){const e=this.hsl;return e.l-=o.constrain(t,0,1),e.l=Math.max(e.l,0),this.hsl=e,this}invert(){const t=this.rgb;return this.rgb={r:255-t.r,g:255-t.g,b:255-t.b},this}_updateRgbaOpacity(){this._rgbaString=this._rgbaString.replace(/^(rgba\(.*,)([\d.]+?)(\))/,((t,e,s,i)=>e+this.opacity+i))}_updateOpacityFromRgba(){const t=/^rgba.*,([\d.]+?)\)$/.exec(this.rgbaString);t&&(this._opacity=y._validateOpacity(t[1]))}}y.string2rgba=function(t,e=1){if(/^#/.test(t))return y.hexString2rgba(t,e);if(/^rgb\(/.test(t))return y.rgbString2rgba(t,e);if(/^rgba\(/.test(t))return y.rgbaString2rgba(t,e);if(/^hsl\(/.test(t))return y.hslStringToRgba(t,e);{const s=y.name2HexString(t);return y.hexString2rgba(s,e)}},y._validateOpacity=function(t){return t=Number(t),isNaN(t)||t>1?t=1:t<0&&(t=0),t},y._validateRgba=function(t){return{r:y._validateRgbNumber(t.r),g:y._validateRgbNumber(t.g),b:y._validateRgbNumber(t.b),a:y._validateOpacity(t.a)}},y._validateRgbNumber=function(t){return t=Number(t),isNaN(t)?t=0:t>255?t=255:t<0&&(t=0),t},y.rgbString2rgba=function(t,e=1){t=t.replace(/ +/g,"");const s=/^rgb\((\d+),(\d+),(\d+)\)/.exec(t);return s?{r:Number(s[1]),g:Number(s[2]),b:Number(s[3]),a:e}:void 0},y.rgbaString2rgba=function(t){t=t.replace(/ +/g,"");const e=/^rgba\((\d+),(\d+),(\d+),([\d.]+)\)/.exec(t);return e?{r:Number(e[1]),g:Number(e[2]),b:Number(e[3]),a:Number(e[4])}:void 0},y.hslStringToRgba=function(t){console.log("NOT IMPLEMENTED")},y.rgb2hsv=function(t){let e,s,i,r,n=t.r,o=t.g,a=t.b;return(n>1||o>1||a>1)&&(n/=255,o/=255,a/=255),i=Math.max(n,o,a),r=i-Math.min(n,o,a),e=0===r?null:i===n?(o-a)/r+(o<a?6:0):i===o?(a-n)/r+2:(n-o)/r+4,e=e%6*60,s=0===r?0:r/i,{h:e,s:s,v:i}},y.hsv2rgb=function(t){let e,s,i,r,n,o=t.h%360/60;n=t.v*t.s,r=n*(1-Math.abs(o%2-1)),e=s=i=t.v-n,o=~~o,e+=[n,r,0,0,r,n][o],s+=[r,n,n,r,0,0][o],i+=[0,0,r,n,n,r][o];return{r:Math.round(255*e),g:Math.round(255*s),b:Math.round(255*i)}},y.hexString2rgba=function(t,e=1){t=t.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,(function(t,e,s,i){return e+e+s+s+i+i}));let s=0,i=0,r=0;const n=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(t);return n&&(s=parseInt(n[1],16),i=parseInt(n[2],16),r=parseInt(n[3],16)),{r:s,g:i,b:r,a:e}},y.rgb2hex=function(t){function e(t){var e=t.toString(16);return 1==e.length?"0"+e:e}return(e(t.r)+e(t.g)+e(t.b)).toUpperCase()},y.rgb2hsl=function(t){const e=t.r/255,s=t.g/255,i=t.b/255,r=Math.max(e,s,i),n=Math.min(e,s,i);let o,a,h=(r+n)/2;if(r===n)o=a=0;else{const t=r-n;switch(a=h>.5?t/(2-r-n):t/(r+n),r){case e:o=(s-i)/t+(s<i?6:0);break;case s:o=(i-e)/t+2;break;case i:o=(e-s)/t+4}o/=6}return{h:o,s:a,l:h}},y.hsl2rgb=function(t){const e=t.h,s=t.s,i=t.l;let r,n,o;if(0===s)r=n=o=i;else{function a(t,e,s){return s<0&&(s+=1),s>1&&(s-=1),s<1/6?t+6*(e-t)*s:s<.5?e:s<2/3?t+(e-t)*(2/3-s)*6:t}const t=i<.5?i*(1+s):i+s-i*s,h=2*i-t;r=a(h,t,e+1/3),n=a(h,t,e),o=a(h,t,e-1/3)}return r=Math.floor(255*r),n=Math.floor(255*n),o=Math.floor(255*o),{r:r,g:n,b:o}},y.rgba2String=function(t){return`rgba(${(t=y._validateRgba(t)).r},${t.g},${t.b},${t.a})`},y.rgb2String=function(t){return`rgb(${t.r},${t.g},${t.b})`},y.name2HexString=function(t){t=t.toLowerCase();const e=y.names()[t];return e||(console.log("Name not found! Defaulting to Black"),"#000000")},y.getColor=function(t=[],e=128,s=127,i=1){const r=[],n=2*t.length+1;for(let t=0;t<n;++t){const n=Math.round(Math.sin(2.4*t+0)*s+e),o=Math.round(Math.sin(2.4*t+4)*s+e),a=Math.round(Math.sin(2.4*t+2)*s+e);r.push(new y(`rgba(${n}, ${o}, ${a}, ${i})`))}let o=t.length;if(o>0)for(;o<r.length;o++){if(!r[o].inArray(t))break}return r[o]},y.names=function(){return{aliceblue:"#f0f8ff",antiquewhite:"#faebd7",aqua:"#00ffff",aquamarine:"#7fffd4",azure:"#f0ffff",beige:"#f5f5dc",bisque:"#ffe4c4",black:"#000000",blanchedalmond:"#ffebcd",blue:"#0000ff",blueviolet:"#8a2be2",brown:"#a52a2a",burlywood:"#deb887",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",cornflowerblue:"#6495ed",cornsilk:"#fff8dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkgray:"#a9a9a9",darkgrey:"#a9a9a9",darkgreen:"#006400",darkkhaki:"#bdb76b",darkmagenta:"#8b008b",darkolivegreen:"#556b2f",darkorange:"#ff8c00",darkorchid:"#9932cc",darkred:"#8b0000",darksalmon:"#e9967a",darkseagreen:"#8fbc8f",darkslateblue:"#483d8b",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",darkturquoise:"#00ced1",darkviolet:"#9400d3",deeppink:"#ff1493",deepskyblue:"#00bfff",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1e90ff",firebrick:"#b22222",floralwhite:"#fffaf0",forestgreen:"#228b22",fuchsia:"#ff00ff",gainsboro:"#dcdcdc",ghostwhite:"#f8f8ff",gold:"#ffd700",goldenrod:"#daa520",gray:"#808080",grey:"#808080",green:"#008000",greenyellow:"#adff2f",honeydew:"#f0fff0",hotpink:"#ff69b4",indianred:"#cd5c5c",indigo:"#4b0082",ivory:"#fffff0",khaki:"#f0e68c",lavender:"#e6e6fa",lavenderblush:"#fff0f5",lawngreen:"#7cfc00",lemonchiffon:"#fffacd",lightblue:"#add8e6",lightcoral:"#f08080",lightcyan:"#e0ffff",lightgoldenrodyellow:"#fafad2",lightgray:"#d3d3d3",lightgrey:"#d3d3d3",lightgreen:"#90ee90",lightpink:"#ffb6c1",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",lightskyblue:"#87cefa",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#b0c4de",lightyellow:"#ffffe0",lime:"#00ff00",limegreen:"#32cd32",linen:"#faf0e6",magenta:"#ff00ff",maroon:"#800000",mediumaquamarine:"#66cdaa",mediumblue:"#0000cd",mediumorchid:"#ba55d3",mediumpurple:"#9370db",mediumseagreen:"#3cb371",mediumslateblue:"#7b68ee",mediumspringgreen:"#00fa9a",mediumturquoise:"#48d1cc",mediumvioletred:"#c71585",midnightblue:"#191970",mintcream:"#f5fffa",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",navajowhite:"#ffdead",navy:"#000080",oldlace:"#fdf5e6",olive:"#808000",olivedrab:"#6b8e23",orange:"#ffa500",orangered:"#ff4500",orchid:"#da70d6",palegoldenrod:"#eee8aa",palegreen:"#98fb98",paleturquoise:"#afeeee",palevioletred:"#db7093",papayawhip:"#ffefd5",peachpuff:"#ffdab9",peru:"#cd853f",pink:"#ffc0cb",plum:"#dda0dd",powderblue:"#b0e0e6",purple:"#800080",rebeccapurple:"#663399",red:"#ff0000",rosybrown:"#bc8f8f",royalblue:"#4169e1",saddlebrown:"#8b4513",salmon:"#fa8072",sandybrown:"#f4a460",seagreen:"#2e8b57",seashell:"#fff5ee",sienna:"#a0522d",silver:"#c0c0c0",skyblue:"#87ceeb",slateblue:"#6a5acd",slategray:"#708090",slategrey:"#708090",snow:"#fffafa",springgreen:"#00ff7f",steelblue:"#4682b4",tan:"#d2b48c",teal:"#008080",thistle:"#d8bfd8",tomato:"#ff6347",turquoise:"#40e0d0",violet:"#ee82ee",wheat:"#f5deb3",white:"#ffffff",whitesmoke:"#f5f5f5",yellow:"#ffff00",yellowgreen:"#9acd32"}};class x{constructor(t=[],e={}){this.intervals=[],this.circularLength=e.circularLength,this.startProperty=e.startProperty||"start",this.stopProperty=e.stopProperty||"stop",this.fill(t)}get length(){return this._length}_normalize(t){let e;const s=[];for(let i=0,r=t.length;i<r;i++)e=t[i],e[this.startProperty]<=e[this.stopProperty]?s.push({interval:e,index:i}):(s.push({interval:e,index:i,[this.startProperty]:this.start(e),[this.stopProperty]:this.circularLength,crossesOrigin:!0}),s.push({interval:e,index:i,[this.startProperty]:1,[this.stopProperty]:this.end(e),crossesOrigin:!0}));return s}fill(t){if(this._length=t.length,0===t.length)return void(this.topList=[]);const e=this.sublist;t=this._normalize(t),this.intervals=t,t.sort(((t,e)=>this.start(t)!==this.start(e)?this.start(t)-this.start(e):this.end(e)-this.end(t)));const s=[];let i,r,n=[];if(this.topList=n,n.push(t[0]),1!==t.length)for(let o=1,a=t.length;o<a;o++)if(i=t[o],this.end(i)<this.end(t[o-1]))s.push(n),n=new Array(i),e(t[o-1],n);else for(;;){if(0===s.length){n.push(i);break}if(r=s[s.length-1],this.end(r[r.length-1])>this.end(i)){n.push(i);break}n=s.pop()}}end(t){return t[this.stopProperty]||t.interval[this.stopProperty]}start(t){return t[this.startProperty]||t.interval[this.startProperty]}sublist(t,e){t.sublist=e}_run(t,e=t,s=1,i=function(){},r=this.topList){let n,o;const a=r.length;let h,l;for(s>0?(l=1,h=this._binarySearch(r,t,!0,"end")):s<0&&(l=-1,h=this._binarySearch(r,e,!1,"start"));h>=0&&h<a&&(1===l?this.start(r[h])<=e:this.end(r[h])>=t);)n=!1,o=!1,this.visbleRangeCrossesOrigin&&this.start(r[h])<e&&this.end(r[h])>t&&(o=!0),(r[h].crossesOrigin||o)&&(-1!==this._runIntervalsCrossingOrigin.indexOf(r[h].interval)?n=!0:this._runIntervalsCrossingOrigin.push(r[h].interval)),n||r[h].index%s!=0||i.call(r[h].interval,r[h].interval),r[h].sublist&&this._run(t,e,s,i,r[h].sublist),h+=l}run(t,e=t,s=1,i=function(){}){this._runIntervalsCrossingOrigin=[],this.circularLength&&e<t?(this.visbleRangeCrossesOrigin=!0,this._run(t,this.circularLength,s,i),this._run(1,e,s,i)):(this.visbleRangeCrossesOrigin=!1,this._run(t,e,s,i))}count(t,e,s){let i=0;return this.run(t,e,s,(()=>{i++})),i}find(t,e,s){const i=[];return this.run(t,e,s,(t=>{i.push(t)})),i}_binarySearch(t,e,s,i){let r,n,o=-1,a=t.length;for(;a-o>1;)if(r=(o+a)/2|0,n=this[i](t[r]),n<e)o=r;else{if(!(n>e))return r;a=r}return s?a:o}static test(){function t(t,e,s,i){const r=t.find(e,s).map((t=>t.name)).sort().join(", ");let n=`${e}..${s}: ${i=i.sort().join(", ")} - `;n+=r===i?"Pass":`FAIL - ${r}`,console.log(n)}const e=new x([{name:"A",start:1,stop:20},{name:"B",start:10,stop:15},{name:"C",start:10,stop:20},{name:"D",start:15,stop:30},{name:"E",start:20,stop:30},{name:"F",start:20,stop:50},{name:"G",start:80,stop:100},{name:"H",start:90,stop:95},{name:"I",start:90,stop:5},{name:"J",start:95,stop:15},{name:"K",start:95,stop:2},{name:"L",start:92,stop:50}],{circularLength:100});return t(e,10,20,["A","B","C","D","E","F","J","L"]),t(e,40,85,["F","G","L"]),t(e,40,95,["F","G","H","I","J","K","L"]),t(e,95,10,["A","B","C","G","H","I","J","K","L"]),e}static testMapStarts(){const t=new x([{name:"A",mapStart:10,mapStop:10},{name:"B",mapStart:20,mapStop:21},{name:"C",mapStart:950,mapStop:5}],{circularLength:1e3,startProperty:"mapStart",stopProperty:"mapStop"});return function(t,e,s,i){const r=t.find(e,s).map((t=>t.name)).sort().join(", ");let n=`${e}..${s}: ${i=i.sort().join(", ")} - `;n+=r===i?"Pass":`FAIL - ${r}`,console.log(n)}(t,900,200,["A","B","C"]),t}static testMapStarts2(){const t=new x([{name:"A",start:10,stop:10},{name:"B",start:20,stop:21},{name:"C",start:950,stop:5}],{circularLength:1e3,startProperty:"start",stopProperty:"stop"});return function(t,e,s,i){const r=t.find(e,s).map((t=>t.name)).sort().join(", ");let n=`${e}..${s}: ${i=i.sort().join(", ")} - `;n+=r===i?"Pass":`FAIL - ${r}`,console.log(n)}(t,900,200,["A","B","C"]),t}}class k extends c{constructor(t,e={},s={}){super(t,e,s),this._labels=new n,this.font=o.defaultFor(e.font,"monospace, plain, 12"),this.labelLineLength=o.defaultFor(e.labelLineLength,20),this.priorityMax=o.defaultFor(e.priorityMax,50),this._labelLineMarginInner=10,this._labelLineMarginOuter=5,this._labelLineWidth=1,this.refresh(),this._visibleLabels=new n,this.color=e.color,this.lineCap="round",this.onlyDrawFavorites=o.defaultFor(e.onlyDrawFavorites,!1),this.labelPlacement=o.defaultFor(e.labelPlacement,"default"),this.viewer.trigger("annotation-update",{attributes:this.toJSON({includeDefaults:!0})})}toString(){return"Annotation"}get color(){return this._color}set color(t){void 0===t||"Color"===t.toString()?this._color=t:this._color=new y(t)}get labelLineLength(){return this._labelLineLength}set labelLineLength(t){this._labelLineLength=t}get priorityMax(){return this._priorityMax}set priorityMax(t){this._priorityMax=t}get font(){return this._font}set font(t){"Font"===t.toString()?this._font=t:this._font=new _(t),this.refreshLabelWidths(),this._font.on("change",(()=>this.refreshLabelWidths()))}get length(){return this._labels.length}set labelPlacement(t){const e=this._initialializeLabelPlacement(t);this._labelPlacementFast=e,this._labelPlacementFull=e}get labelPlacementFast(){return this._labelPlacementFast}set labelPlacementFast(t){this._labelPlacementFast=this._initialializeLabelPlacement(t)}get labelPlacementFull(){return this._labelPlacementFull}set labelPlacementFull(t){this._labelPlacementFull=this._initialializeLabelPlacement(t)}_initialializeLabelPlacement(t){if("string"!=typeof t)return new t(this);switch(t){case"default":return new g(this);case"angled":return new u(this);default:throw new Error(`Label Placement name '${t}' unknown. Use one of 'default', 'angled'`)}}labels(t){return this._labels.get(t)}addLabel(t){this._labels.push(t)}removeLabels(t){t="CGArray"===t.toString()?t:new n(t),this._labels=this._labels.filter((e=>!t.includes(e))),this.refresh()}refresh(){const t=this._labels.filter((t=>t.feature.visible&&t.feature.contig.visible&&t.feature.tracks().some((t=>t.visible))));this._availableLabels=t;for(const e of t)e.bpDefault=e.feature.mapRange.middle;this._labelsNCList=new x(t,{circularLength:this.sequence.length,startProperty:"mapStart",stopProperty:"mapStop"})}refreshLabelWidths(){const t=this._labels.map((t=>t.font.css)),e=this._labels.map((t=>t.name)),s=_.calculateWidths(this.canvas.context("map"),t,e);for(let t=0,e=this._labels.length;t<e;t++)this._labels[t].width=s[t]}_calculatePositions(t){t=t||this._labels;const e=this._visibleRange;let s,i,r,n,o,a;const h=this.sequence;for(let l=0,c=t.length;l<c;l++)if(s=t[l],i=s.feature,r=e.containsMapBp(i.mapStart),n=e.containsMapBp(i.mapStop),r&&n)s.bp=s.bpDefault,s.lineAttachment=s.lineAttachmentDefault;else{if(r)s.bp=i.mapRange.getStartPlus(h.lengthOfRange(i.mapStart,e.stop)/2);else if(n)s.bp=i.mapRange.getStopPlus(-h.lengthOfRange(e.start,i.mapStop)/2);else{o=h.lengthOfRange(e.stop,i.mapStop),a=h.lengthOfRange(i.mapStart,e.start);const t=e.length/2,r=e.start+t;s.bp=a>o?r+t*o/(o+a):r+t*a/(o+a)}s.lineAttachment=this.viewer.layout.clockPositionForBp(s.bp,!0)}}_calculatePriorityLabelRectsFast(t){t=t||this._labels;const e=this.canvas;let s,i,r,a;const h=this._outerCenterOffset+this._labelLineMarginInner,l=new n;for(let n=0,c=t.length;n<c;n++){s=t[n],i=s.bp,r=this.labelLineLength;do{const t=e.pointForBp(i,h+r+this._labelLineMarginOuter),n=o.rectOriginForAttachementPoint(t,s.lineAttachment,s.width,s.height);s.rect=new d(n.x,n.y,s.width,s.height),a=s.rect.overlap(l),r+=s.height}while(a);l.push(s.rect),s.attachementPt=s.rect.ptForClockPosition(s.lineAttachment)}}_calculatePriorityLabelRects(t){!this._fastDraw||t.length<20?this.labelPlacementFull.placeLabels(t,this._outerCenterOffset):this.labelPlacementFast.placeLabels(t,this._outerCenterOffset)}_calculateLabelRects(t){t=t||this._labels;const e=this.canvas;let s,i;const r=this._outerCenterOffset+this._labelLineMarginInner;for(let n=0,a=t.length;n<a;n++){s=t[n],i=s.bp;const a=e.pointForBp(i,r+this.labelLineLength+this._labelLineMarginOuter),h=o.rectOriginForAttachementPoint(a,s.lineAttachment,s.width,s.height);s.rect=new d(h.x,h.y,s.width,s.height),s.attachementPt=s.rect.ptForClockPosition(s.lineAttachment)}}visibleLabels(){let t=new n;const e=this._visibleRange;return e&&(t=1===e.start&&e.stop===this.sequence.length?this._availableLabels:this._labelsNCList.find(e.start,e.stop)),t}_onlyFavoriteLabels(t){const e=(t=t||this._labels).findIndex((t=>!t.feature.favorite));return-1!==e?t.slice(0,e):t}_sortByPriority(t){return(t=t||this._labels).sort(((t,e)=>e.feature.favorite===t.feature.favorite?e.feature.length-t.feature.length:t.feature.favorite?-1:1)),t}invertColors(){this.color&&this.update({color:this.color.invert().rgbaString})}drawLabelLine(t,e,s){const i=this.canvas.pointForBp(t.bp,this._outerCenterOffset+this._labelLineMarginInner),r=t.attachementPt,n=this.color||t.feature.color;e.beginPath(),e.moveTo(i.x,i.y),e.lineTo(r.x,r.y),e.strokeStyle=n.rgbaString,e.lineCap=this.lineCap,e.lineWidth=s||this._labelLineWidth,e.stroke()}draw(t,e,s){this._fastDraw=s,this._visibleRange=this.canvas.visibleRangeForCenterOffset(e),this._innerCenterOffset=t,this._outerCenterOffset=e;let i=this.visibleLabels(e);i=this._sortByPriority(i),this.onlyDrawFavorites&&(i=this._onlyFavoriteLabels(i)),this._calculatePositions(i);const r=i.slice(0,this.priorityMax),n=i.slice(this.priorityMax);this._calculatePriorityLabelRects(r),this._calculateLabelRects(n);const o=r.map((t=>t.rect));this._visibleLabels=r;for(let t=0,e=n.length;t<e;t++){const e=n[t];e.rect.overlap(o)||(this._visibleLabels.push(e),o.push(e.rect))}const a=this.canvas.context("map");let h,l;a.font=this.font.css,a.textAlign="left",a.textBaseline="alphabetic";for(let t=0,e=this._visibleLabels.length;t<e;t++)h=this._visibleLabels[t],h.feature.visible&&(this.color||h.feature.color,this.drawLabelLine(h,a));const c=this.viewer.settings.backgroundColor.copy();c.opacity=.75;for(let t=0,e=this._visibleLabels.length;t<e;t++){if(h=this._visibleLabels[t],!h.feature.visible)continue;const e=this.color||h.feature.color;a.fillStyle=c.rgbaString,l=h.rect,a.fillRect(l.x,l.y,l.width,l.height),a.fillStyle=e.rgbaString,a.fillText(h.name,h.rect.x,h.rect.bottom-1)}this.viewer.debug&&this.viewer.debug.data.n&&(this.viewer.debug.data.n.labels=this._visibleLabels.length)}update(t){this.viewer.updateRecords(this,t,{recordClass:"Annotation",validKeys:["color","font","onlyDrawFavorites","visible","labelPlacement"]}),this.viewer.trigger("annotation-update",{attributes:t})}toJSON(t={}){return{font:this.font.string,color:this.color&&this.color.rgbaString,onlyDrawFavorites:this.onlyDrawFavorites,labelPlacement:this.labelPlacementFull.name,visible:this.visible}}}class S extends c{constructor(t,e={},s={}){super(t,e,s),this.color=o.defaultFor(e.color,"grey"),this.colorAlternate=o.defaultFor(e.colorAlternate,"rgb(200,200,200)"),this.thickness=o.defaultFor(e.thickness,5),this._bpThicknessAddition=0;const i=this.sequence.hasMultipleContigs?"arrow":"arc";this.decoration=o.defaultFor(e.decoration,i),this.viewer.trigger("backbone-update",{attributes:this.toJSON({includeDefaults:!0})})}toString(){return"Backbone"}get visible(){return this._visible}set visible(t){this._visible=t,this.viewer._initialized&&this.refreshThickness(),this.viewer.layout&&this.viewer.layout._adjustProportions()}get color(){return this._color}set color(t){"Color"===t.toString()?this._color=t:this._color=new y(t)}get colorAlternate(){return this._colorAlternate}set colorAlternate(t){"Color"===t.toString()?this._colorAlternate=t:this._colorAlternate=new y(t)}get decoration(){return this._decoration}set decoration(t){this._decoration=t}set centerOffset(t){o.isNumeric(t)&&(this._centerOffset=t,this.viewer._updateZoomMax())}get centerOffset(){return this._centerOffset}get adjustedCenterOffset(){return this.layout.adjustedBackboneCenterOffset(this.centerOffset)}set thickness(t){o.isNumeric(t)&&(this._thickness=Number(t),this.viewer.layout&&this.viewer.layout._adjustProportions())}get thickness(){return this.visible?this._thickness:0}get adjustedThickness(){return this.visible?Math.min(this.viewer.zoomFactor,4)*this.thickness+this.bpThicknessAddition:0}get maxThickness(){return Math.max(this.adjustedThickness,this.sequence.thickness)}get bpThicknessAddition(){return this._bpThicknessAddition}get visibleRange(){return this._visibleRange}get pixelLength(){return this.layout.pixelsPerBp(this.adjustedCenterOffset)/this.viewer.zoomFactor*this.sequence.length}containsCenterOffset(t){const e=this.adjustedThickness/2,s=this.adjustedCenterOffset;return t>=s-e&&t<=s+e}maxZoomFactor(){return this.sequence.length*(this.sequence.bpSpacing+2*this.sequence.bpMargin)/this.pixelLength}pixelsPerBp(){return this.layout.pixelsPerBp()}directionalDecorationForContig(t){return"arrow"===this.decoration?"+"===t.orientation?"clockwise-arrow":"counterclockwise-arrow":this.decoration}invertColors(){this.update({color:this.color.invert().rgbaString,colorAlternate:this.colorAlternate.invert().rgbaString})}draw(){if(this._visibleRange=this.canvas.visibleRangeForCenterOffset(this.adjustedCenterOffset,100),this.visibleRange&&this.visible){if(this.refreshThickness(),this.sequence.hasMultipleContigs){const t=this.sequence.contigsForMapRange(this.visibleRange);for(let e=0,s=t.length;e<s;e++){const s=t[e];let i=this.sequence.bpForContig(s);i<this.visibleRange.start&&!this.visibleRange.isWrapped()&&(i=this.visibleRange.start);let r=this.sequence.bpForContig(s,s.length);r>this.visibleRange.stop&&!this.visibleRange.isWrapped()&&(r=this.visibleRange.stop);let n=s.index%2==0?this.color:this.colorAlternate;s.color&&(n=s.color),this.viewer.canvas.drawElement("map",i,r,this.adjustedCenterOffset,n.rgbaString,this.adjustedThickness,this.directionalDecorationForContig(s))}}else this.visibleRange.isWrapped()&&"arrow"===this.decoration?(this.viewer.canvas.drawElement("map",this.visibleRange.start,this.sequence.length,this.adjustedCenterOffset,this.color.rgbaString,this.adjustedThickness,this.directionalDecorationForContig(this.sequence.mapContig)),this.viewer.canvas.drawElement("map",1,this.visibleRange.stop,this.adjustedCenterOffset,this.color.rgbaString,this.adjustedThickness,this.directionalDecorationForContig(this.sequence.mapContig))):this.viewer.canvas.drawElement("map",this.visibleRange.start,this.visibleRange.stop,this.adjustedCenterOffset,this.color.rgbaString,this.adjustedThickness,this.directionalDecorationForContig(this.sequence.mapContig));this.pixelsPerBp()>1&&this.sequence.draw()}}refreshThickness(){const t=this.pixelsPerBp();if(t>1&&this.visible){const e=Math.min(this.viewer.zoomFactor,4)*this.thickness,s=2*t;e+s>=this.maxThickness?this._bpThicknessAddition=this.maxThickness-e:this._bpThicknessAddition=s}else this._bpThicknessAddition=0}update(t){this.viewer.updateRecords(this,t,{recordClass:"Backbone",validKeys:["color","colorAlternate","thickness","decoration","visible"]}),this.viewer.trigger("backbone-update",{attributes:t})}toJSON(t={}){const e={color:this.color.rgbaString,colorAlternate:this.colorAlternate.rgbaString,thickness:this._thickness,decoration:this.decoration};return this.visible&&!t.includeDefaults||(e.visible=this.visible),e}}class F extends c{constructor(t,e={},s={}){super(t,e,s),this.viewer=t,this.bp=o.defaultFor(e.bp,t.canvas.bpForCanvasCenter()),this.zoom=o.defaultFor(e.zoom,t.zoomFactor),this.format=o.defaultFor(e.format,t.format),this.name=o.defaultFor(e.name,this.incrementalName()),this.favorite=o.defaultFor(e.favorite,!1),this.shortcut=o.defaultFor(e.shortcut,this.incrementalShortcut()),this.bbOffset=o.defaultFor(e.bbOffset,t.bbOffset)}toString(){return"Bookmark"}get viewer(){return this._viewer}set viewer(t){this.viewer,this._viewer=t,t._bookmarks.push(this)}get name(){return this._name}set name(t){this._name=t}get bp(){return this._bp}set bp(t){this._bp=t}get zoom(){return this._zoom}set zoom(t){this._zoom=t}get format(){return this._format}set format(t){this._format=t}get favorite(){return this._favorite}set favorite(t){this._favorite=t}get shortcut(){return this._shortcut}set shortcut(t){this._shortcut=[void 0,null,""].includes(t)?void 0:String(t).charAt(0)}update(t){this.viewer.updateBookmarks(this,t)}remove(){this.viewer.removeBookmarks(this)}moveTo(t=1e3){this.viewer.format!==this.format&&this.viewer.settings.update({format:this.format}),setTimeout((()=>{this.viewer.zoomTo(this.bp,this.zoom,{duration:t,bbOffset:this.bbOffset})}),0)}incrementalName(){const t=this.viewer.bookmarks().map((t=>t.name));return o.uniqueId("Bookmark-",t.length,t)}incrementalShortcut(){const t=this.viewer.bookmarks().map((t=>t.shorcut)),e=o.uniqueId("",t.length,t);if(e<10&&e>0)return e}toJSON(t={}){const e={name:this.name,bp:this.bp,zoom:this.zoom,bbOffset:this.bbOffset,format:this.format,shortcut:this.shortcut};return this.favorite&&!t.includeDefaults||(e.favorite=this.favorite),e}}class C{constructor(t,e={}){this._viewer=t,this._width=o.defaultFor(e.width,100),this._height=o.defaultFor(e.height,100),this.anchor=e.anchor,this.position=o.defaultFor(e.position,"middle-center"),this.padding=o.defaultFor(e.padding,0),this.color=o.defaultFor(e.color,"white")}toString(){return"Box"}get viewer(){return this._viewer}get canvas(){return this.viewer.canvas}get on(){return this.position.on}set on(t){this.position.on=t,this.position.onMap?this.anchor.auto=!1:this.position.onCanvas&&(this.position={xPercent:this.x/(this.viewer.width-this.width)*100,yPercent:this.y/(this.viewer.height-this.height)*100})}get position(){return this._position}set position(t){this._position=new a(this.viewer,t),this._adjustAnchor(),this.refresh(!0)}get anchor(){return this._anchor}set anchor(t){this.position&&this.position.onCanvas||(this._anchor=new h(t),this.position&&this.refresh(!0))}get width(){return this._width}set width(t){this._width=t,this.refresh(!0)}get height(){return this._height}set height(t){this._height=t,this.refresh(!0)}get x(){return this._x}get y(){return this._y}get padding(){return this._padding}set padding(t){this._padding=t}get paddedX(){return this.x+this.padding}get paddedY(){return this.y+this.padding}get bottom(){return this.y+this.height}get bottomPadded(){return this.bottom-this.padding}get top(){return this.y}get topPadded(){return this.top+this.padding}get left(){return this.x}get leftPadded(){return this.left+this.padding}get right(){return this.x+this.width}get rightPadded(){return this.right-this.padding}get centerX(){return this.x+this.width/2}get centerY(){return this.y+this.height/2}resize(t,e){this._width=t,this._height=e,this.refresh(!0)}containsPt(t,e){return t>=this.x&&t<=this.x+this.width&&e>=this.y&&e<=this.y+this.height}_adjustAnchor(){this.position.onCanvas&&(this.anchor.xPercent=this.position.xPercent,this.anchor.yPercent=this.position.yPercent,this.anchor.auto=!0)}refresh(t=!1){(t||"canvas"!==this.on)&&(this.position.refresh(),this.anchor.auto&&this.anchor.autoUpdateForPosition(this.position),this._x=this.position.x-this.width*this.anchor.xPercent/100,this._y=this.position.y-this.height*this.anchor.yPercent/100)}clear(t){t.clearRect(this.x-1,this.y-1,this.width+2,this.height+2)}}class P{constructor(t,e,s={}){this._viewer=t,this.width=o.defaultFor(s.width,600),this.height=o.defaultFor(s.height,600),this.determinePixelRatio(e),this._layerNames=["background","map","foreground","canvas","debug","ui"],this._layers=this.createLayers(e,this._layerNames,this._width,this._height),this._drawRange=.4}get pixelRatio(){return this._pixelRatio}determinePixelRatio(t){const e=t.append("canvas").style("position","absolute").style("top",0).style("left",0).attr("width",this._width).attr("height",this._height).node();e.getContext?this._pixelRatio=o.getPixelRatio(e):t.html("<h3>CGView requires Canvas, which is not supported by this browser.</h3>"),i.select(e).remove()}createLayers(t,e,s,i,r=!0){const n={};for(let a=0,h=e.length;a<h;a++){const h=e[a],l=10*(a+1),c=t.append("canvas").classed("cgv-layer",!0).classed(`cgv-layer-${h}`,!0).style("z-index",l).attr("width",s).attr("height",i).node();r&&o.scaleResolution(c,this.pixelRatio);const d=c.getContext("2d");n[h]={ctx:d,node:c}}return n}resize(t,e){this.width=t,this.height=e;for(const s of this.layerNames){const i=this.layers(s).node;i.width=this.width,i.height=this.height,i.style.width=`${t}px`,i.style.height=`${e}px`,o.scaleResolution(i,this.pixelRatio)}this.layout.updateScales()}get viewer(){return this._viewer}get layout(){return this.viewer.layout}get layerNames(){return this._layerNames}get sequence(){return this.viewer.sequence}get width(){return this._width}set width(t){this._width=t}get height(){return this._height}set height(t){this._height=t}get cursor(){return i.select(this.node("ui")).style("cursor")}set cursor(t){i.select(this.node("ui")).style("cursor",t)}clear(t="map"){if("all"===t)for(let t=0,e=this.layerNames.length;t<e;t++)this.clear(this.layerNames[t]);else if("background"===t){const t=this.context("background");t.clearRect(0,0,this.width,this.height),t.fillStyle=this.viewer.settings.backgroundColor.rgbaString,t.fillRect(0,0,this.width,this.height)}else this._testDrawRange?this.context(t).clearRect(0,0,this.width/this._drawRange,this.height/this._drawRange):this.context(t).clearRect(0,0,this.width,this.height)}drawElement(t,e,s,i,r="#000000",n=1,a="arc",h,l){if("none"===a)return;const c=this.context(t),d=this.viewer.settings,g=.15;if(c.lineCap="butt",h=void 0===h?d.showShading:h,e-=.5,s+=.5,"arc"===a){const a=o.defaultFor(l,this.viewer.legend.defaultMinArcLength),d=this.sequence.lengthOfRange(e,s),u=a/this.pixelsPerBp(i);if(d<u){const t=e+d/2;e=t-u/2,s=t+u/2}if(h){const o=.1*n,a=n-2*o;c.beginPath(),c.strokeStyle=r,c.lineWidth=a,this.path(t,i,e,s),c.stroke();const h=a/2+o/2;c.lineWidth=o,c.beginPath(),c.strokeStyle=new y(r).lighten(g).rgbaString,this.path(t,i+h,e,s),c.stroke(),c.beginPath(),c.strokeStyle=new y(r).darken(g).rgbaString,this.path(t,i-h,e,s),c.stroke()}else c.beginPath(),c.strokeStyle=r,c.lineWidth=n,this.path(t,i,e,s),c.stroke()}if("clockwise-arrow"===a||"counterclockwise-arrow"===a){const o=n*d.arrowHeadLength/this.pixelsPerBp(i),l=this.sequence.lengthOfRange(e,s);if(l<o){const t=e+l/2,i=(o+.1)/2;e=t-i,s=t+i}const u="clockwise-arrow"===a?e:s,p="clockwise-arrow"===a?s:e,f="clockwise-arrow"===a?1:-1,m=n/2,b=p-f*o,v=this.pointForBp(p,i),w=this.pointForBp(b,i-m);if(h){const e=.4*n,s=this.pointForBp(b,i-e);c.beginPath(),c.fillStyle=r,this.path(t,i+e,u,b,-1===f),c.lineTo(v.x,v.y),c.lineTo(s.x,s.y),this.path(t,i-e,b,u,1===f,"noMoveTo"),c.closePath(),c.fill();const o=this.pointForBp(b,i+e);c.beginPath(),c.fillStyle=new y(r).lighten(g).rgbaString,this.path(t,i+m,u,b,-1===f),c.lineTo(v.x,v.y),c.lineTo(o.x,o.y),this.path(t,i+e,b,u,1===f,"noMoveTo"),c.closePath(),c.fill(),c.beginPath(),c.fillStyle=new y(r).darken(g).rgbaString,this.path(t,i-m,u,b,-1===f),c.lineTo(v.x,v.y),c.lineTo(s.x,s.y),this.path(t,i-e,b,u,1===f,"noMoveTo"),c.closePath(),c.fill()}else c.beginPath(),c.fillStyle=r,this.path(t,i+m,u,b,-1===f),c.lineTo(v.x,v.y),c.lineTo(w.x,w.y),this.path(t,i-m,b,u,1===f,"noMoveTo"),c.closePath(),c.fill()}}path(t,e,s,i,r=!1,n="moveTo"){this.layout.path(t,e,s,i,r,n)}radiantLine(t,e,s,i,r=1,n="black",o="butt"){const a=this.pointForBp(e,s),h=this.pointForBp(e,s+i),l=this.context(t);l.beginPath(),l.moveTo(a.x,a.y),l.lineTo(h.x,h.y),l.strokeStyle=n,l.lineCap=o,l.lineWidth=r,l.stroke()}pointForBp(t,e){return this.layout.pointForBp(t,e)}bpForMouse(){const t=this.viewer.mouse;if(t)return this.bpForPoint({x:t.canvasX,y:t.canvasY})}bpForCanvasCenter(){return this.bpForPoint({x:this.width/2,y:this.height/2})}bpForPoint(t){return this.layout.bpForPoint(t)}visibleRangeForCenterOffset(t,e=0){return this.layout.visibleRangeForCenterOffset(t,e)}pixelsPerBp(t=this.viewer.backbone.adjustedCenterOffset){return this.layout.pixelsPerBp(t)}layers(t="map"){return this._layerNames.includes(t)?this._layers[t]:(console.error("Returning map layer by default"),this._layers.map)}context(t){return this._layerNames.includes(t)?this.layers(t).ctx:(console.error("Returning map layer by default"),this.layers("map").ctx)}node(t){return this._layerNames.includes(t)?this.layers(t).node:(console.error("Returning map layer by default"),this.layers("map").node)}get _testDrawRange(){return this.__testDrawRange}set _testDrawRange(t){if(this.__testDrawRange=t,t){this.width=this.width*this._drawRange,this.height=this.height*this._drawRange;const t=this.context("canvas");t.strokeStyle="grey",t.rect(0,0,this.width,this.height),t.stroke()}else{this.width=this.width/this._drawRange,this.height=this.height/this._drawRange;this.context("canvas").clearRect(0,0,this.width,this.height)}this.viewer.drawFull()}}class L extends c{constructor(t,e={},s={}){super(t,e,s),this.viewer=t,this._name=o.defaultFor(e.name,""),this.backgroundColor=e.backgroundColor,this.fontColor=o.defaultFor(e.fontColor,"black"),this.textAlignment=o.defaultFor(e.textAlignment,"left"),this.box=new C(t,{position:o.defaultFor(e.position,"middle-center"),anchor:o.defaultFor(e.anchor,"middle-center")}),this.font=o.defaultFor(e.font,"sans-serif, plain, 8")}toString(){return"Caption"}get viewer(){return this._viewer}set viewer(t){this._viewer=t,t._captions.push(this)}get visible(){return this._visible}set visible(t){this._visible=t,this.viewer.refreshCanvasLayer()}get on(){return this.box.on}set on(t){this.clear(),this.box.on=t,this.refresh()}get anchor(){return this.box.anchor}set anchor(t){this.clear(),this.box.anchor=t,this.refresh()}get onMap(){return this.position.onMap}get onCanvas(){return this.position.onCanvas}get ctx(){const t=this.onMap?"foreground":"canvas";return this.canvas.context(t)}get position(){return this.box.position}set position(t){this.clear(),this.box.position=t,this.viewer.refreshCanvasLayer()}get backgroundColor(){return this._backgroundColor}set backgroundColor(t){void 0===t?this._backgroundColor=this.viewer.settings.backgroundColor:"Color"===t.toString()?this._backgroundColor=t:this._backgroundColor=new y(t),this.refresh()}get font(){return this._font}set font(t){"Font"===t.toString()?this._font=t:this._font=new _(t),this.refresh()}get fontColor(){return this._fontColor}set fontColor(t){"Color"===t.toString()?this._fontColor=t:this._fontColor=new y(t),this.refresh()}get textAlignment(){return this._textAlignment}set textAlignment(t){o.validate(t,["left","center","right"])&&(this._textAlignment=t),this.refresh()}get name(){return this._name||""}set name(t){this._name=t,this.refresh()}get lines(){return this.name.split("\n")}update(t){this.viewer.updateCaptions(this,t)}moveTo(t=1e3){this.position.moveTo(t)}refresh(){const t=this.box;if(!t)return;this.clear(),t.padding=this.font.size/2;const e=this.lines,s=e.map((()=>this.font.css)),r=_.calculateWidths(this.ctx,s,e),n=i.max(r)+2*t.padding,o=(this.font.size+t.padding)*e.length+t.padding;t.resize(n,o),this.draw()}fillBackground(){const t=this.box;this.ctx.fillStyle=this.backgroundColor.rgbaString,t.clear(this.ctx),this.ctx.fillRect(t.x,t.y,t.width,t.height)}invertColors(){this.update({backgroundColor:this.backgroundColor.invert().rgbaString,fontColor:this.fontColor.invert().rgbaString})}highlight(t=this.fontColor){if(!this.visible)return;const e=this.canvas.context("ui");e.lineWidth=1,e.strokeStyle=t.rgbaString;const s=this.box,i=Math.min(s.height/4,4);e.beginPath(),e.roundRect(s.x,s.y,s.width,s.height,[i]),e.stroke()}textX(){const t=this.box;return"left"===this.textAlignment?t.leftPadded:"center"===this.textAlignment?t.centerX:"right"===this.textAlignment?t.rightPadded:void 0}clear(){this.box.clear(this.ctx)}draw(){if(!this.visible)return;const t=this.ctx,e=this.box;e.refresh(),this.fillBackground(),t.textBaseline="alphabetic",t.font=this.font.css,t.textAlign=this.textAlignment,t.fillStyle=this.fontColor.rgbaString;const s=(e.height-e.padding)/this.lines.length;let i=e.y+s;for(let e=0,r=this.lines.length;e<r;e++)t.fillText(this.lines[e],this.textX(),i),i+=s}remove(){this.viewer.removeCaptions(this)}move(t){const e=this.viewer.captions().indexOf(this);this.viewer.moveCaption(e,t)}toJSON(t={}){const e={name:this.name,position:this.position.toJSON(t),textAlignment:this.textAlignment,font:this.font.string,fontColor:this.fontColor.rgbaString,backgroundColor:this.backgroundColor.rgbaString};return this.position.onMap&&(e.anchor=this.anchor.toJSON()),this.visible&&!t.includeDefaults||(e.visible=this.visible),e}}class M{constructor(t,e,s){this._contig=t,this.start=e,this.stop=s}get contig(){return this._contig}get sequence(){return this.contig.sequence}get start(){return this._start}set start(t){const e=this.isWrappingAllowed?this.contig.length:this.stop||this.contig.length;this._start=o.constrain(t,1,e)}get stop(){return this._stop}set stop(t){const e=this.isWrappingAllowed?1:this.start||1;this._stop=o.constrain(t,e,this.contig.length)}get mapStart(){return this.start+this.contig.lengthOffset}set mapStart(t){this.start=t-this.contig.lengthOffset}get mapStop(){return this.stop+this.contig.lengthOffset}set mapStop(t){this.stop=t-this.contig.lengthOffset}get onMap(){return new M(this.sequence.mapContig,this.mapStart,this.mapStop)}get length(){return this.stop>=this.start?this.stop-this.start+1:this.contig.length+(this.stop-this.start)+1}get middle(){const t=this.start-.5+this.length/2;return t>this.contig.length?t-this.contig.length:t}overHalfMapLength(){return this.length>this.sequence.length/2}normalize(t){if(this.sequence.hasMultipleContigs)return o.constrain(t,1,this.contig.length);{let e;return t>this.sequenceLength?(e=Math.floor(t/this.sequenceLength),t-this.sequenceLength*e):t<1?(e=Math.ceil(Math.abs(t/this.sequenceLength)),this.sequenceLength*e+t):t}}getStartPlus(t){return this.normalize(this.start+t)}getStopPlus(t){return this.normalize(this.stop+t)}isMapLength(){return this.length===this.sequence.length}isWrappingAllowed(){return this.contig===this.sequence.mapContig}isWrapped(){return this.stop<this.start}containsMapBp(t){return this.stop>=this.start?t>=this.mapStart&&t<=this.mapStop:t>=this.mapStart||t<=this.mapStop}copy(){return new M(this.contig,this.start,this.stop)}overlapsMapRange(t){return this.containsMapBp(t.mapStart)||this.containsMapBp(t.mapStop)||t.containsMapBp(this.mapStart)}mergeWithRange(t){if(t.contig!==this.contig)return this;const e=this,s=[e,t,new M(this.contig,e.start,t.stop),new M(this.contig,t.start,e.stop)];let i,r,n=0;for(let t=0,e=s.length;t<e;t++)i=s[t].length,i>n&&(n=i,r=s[t]);return r}}class O{constructor(){this._tables={}}get tables(){return this._tables}byID(t){const e=T.availableGeneticCodeIDs,s=t.toString();let i;return this.tables[s]?i=this.tables[s]:e.includes(s)?(i=new T(s),this.tables[s]=i):console.error(`Unknown Codon Table ID: '${t}'`),i}names(){const t={};return Object.keys(T.definitions).map((e=>t[e]=T.definitions[e].name)),t}translate(t,e,s=1){const i=this.byID(e);if(i)return i.translate(t,s)}}class T{constructor(t){this._codons=this.generateCodons(),this._geneticCodeID=t&&t.toString(),this._generateTable()}toString(){return"CodonTable"}static get availableGeneticCodeIDs(){return Object.keys(T.definitions)}get codons(){return this._codons}get geneticCodeID(){return this._geneticCodeID}get name(){return this._name}get table(){return this._table}get starts(){return this._starts}get stops(){return this._stops}_generateTable(){const t=this.geneticCodeID;if(T.availableGeneticCodeIDs.includes(t)){const e=T.definitions[t];this._name=e.name;const s={},i=[],r=[];for(const[t,n]of this.codons.entries())s[n]=e.aa[t],"M"===e.starts[t]&&i.push(n),"*"===e.aa[t]&&r.push(n);this._table=s,this._starts=i,this._stops=r}else console.error(`Unknown Codon Table ID: '${t}'`)}generateCodons(){const t=["T","C","A","G"],e=[];for(const s of t)for(const i of t)for(const r of t)e.push(`${s}${i}${r}`);return e}static get definitions(){return{1:{name:"Standard",aa:"FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"---M---------------M---------------M----------------------------"},2:{name:"Vertebrate Mitochondrial",aa:"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSS**VVVVAAAADDEEGGGG",starts:"--------------------------------MMMM---------------M------------"},3:{name:"Yeast Mitochondrial",aa:"FFLLSSSSYY**CCWWTTTTPPPPHHQQRRRRIIMMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"----------------------------------MM----------------------------"},4:{name:"Mold, Protozoan, Coelenterate Mitochondrial and Mycoplasma/Spiroplasma",aa:"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"--MM---------------M------------MMMM---------------M------------"},5:{name:"Invertebrate Mitochondrial",aa:"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSSSSVVVVAAAADDEEGGGG",starts:"---M----------------------------MMMM---------------M------------"},6:{name:"Ciliate, Dasycladacean and Hexamita Nuclear",aa:"FFLLSSSSYYQQCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"-----------------------------------M----------------------------"},9:{name:"Echinoderm and Flatworm Mitochondrial",aa:"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNNKSSSSVVVVAAAADDEEGGGG",starts:"-----------------------------------M---------------M------------"},10:{name:"Euplotid Nuclear",aa:"FFLLSSSSYY**CCCWLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"-----------------------------------M----------------------------"},11:{name:"Bacterial and Plant Plastid",aa:"FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"---M---------------M------------MMMM---------------M------------"},12:{name:"Alternative Yeast Nuclear",aa:"FFLLSSSSYY**CC*WLLLSPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"-------------------M---------------M----------------------------"},13:{name:"Ascidian Mitochondrial",aa:"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSSGGVVVVAAAADDEEGGGG",starts:"---M------------------------------MM---------------M------------"},14:{name:"Alternative Flatworm Mitochondrial",aa:"FFLLSSSSYYY*CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNNKSSSSVVVVAAAADDEEGGGG",starts:"-----------------------------------M----------------------------"},15:{name:"Blepharisma Nuclear",aa:"FFLLSSSSYY*QCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"-----------------------------------M----------------------------"},16:{name:"Chlorophycean Mitochondrial",aa:"FFLLSSSSYY*LCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"-----------------------------------M----------------------------"},21:{name:"Trematode Mitochondrial",aa:"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNNKSSSSVVVVAAAADDEEGGGG",starts:"-----------------------------------M---------------M------------"},22:{name:"Scenedesmus obliquus mitochondrial",aa:"FFLLSS*SYY*LCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"-----------------------------------M----------------------------"},23:{name:"Thraustochytrium Mitochondrial",aa:"FF*LSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG",starts:"--------------------------------M--M---------------M------------"}}}translate(t,e=1){const s=t.toUpperCase();let i=-1+e,r=s.slice(i,i+3),n="";for(;3===r.length;)n+=this.table[r]||"X",i+=3,r=s.slice(i,i+3);return n}}class I{constructor(t,e={}){this.containerId=t,this._object=e.object,this.container=i.select(`#${t}`).node(),this.localStorageKey="cgv-colorpicker-favorites",this.mode="default",this._width=o.defaultFor(e.width,100),this._height=o.defaultFor(e.height,100),this._color=new y(o.defaultFor(e.colorString,"rgba(255,0,0,1)")),this.hsv=this._color.hsv,this.opacity=this._color.opacity,this.favorites=[],this.maxFavorites=13,this.onChange=e.onChange,this.onClose=e.onClose,this.container.innerHTML=this._colorpickerHTMLSnippet(),i.select(this.container).classed("cp-dialog",!0),this.dialogElement=this.container.getElementsByClassName("cp-dialog")[0],this.slideElement=this.container.getElementsByClassName("cp-color-slider")[0],this.pickerElement=this.container.getElementsByClassName("cp-color-picker")[0],this.alphaElement=this.container.getElementsByClassName("cp-alpha-slider")[0],this.slideIndicator=this.container.getElementsByClassName("cp-color-slider-indicator")[0],this.pickerIndicator=this.container.getElementsByClassName("cp-color-picker-indicator")[0],this.pickerIndicatorRect1=this.container.getElementsByClassName("cp-picker-indicator-rect-1")[0],this.alphaIndicator=this.container.getElementsByClassName("cp-alpha-slider-indicator")[0],this.currentColorIndicator=this.container.getElementsByClassName("cp-color-current")[0],this.originalColorIndicator=this.container.getElementsByClassName("cp-color-original")[0],this.hexInput=this.container.getElementsByClassName("cp-hex-input")[0],this.rgbRInput=this.container.getElementsByClassName("cp-rgb-r-input")[0],this.rgbGInput=this.container.getElementsByClassName("cp-rgb-g-input")[0],this.rgbBInput=this.container.getElementsByClassName("cp-rgb-b-input")[0],this.rgbRLabel=this.container.querySelector(".cp-rgb-r-input + .cp-number-label"),this.rgbGLabel=this.container.querySelector(".cp-rgb-g-input + .cp-number-label"),this.rgbBLabel=this.container.querySelector(".cp-rgb-b-input + .cp-number-label"),this.alphaNumber=this.container.getElementsByClassName("cp-alpha-number")[0],this.swatchesElement=this.container.getElementsByClassName("cp-dialog-swatches")[0],this.doneButton=this.container.getElementsByClassName("cp-done-button")[0],this.modeButton=this.container.getElementsByClassName("cp-mode-button")[0],this.modeDefault=this.container.querySelector(".cp-color-picker-mode-default"),this.modeSwatches=this.container.querySelector(".cp-color-picker-mode-swatches"),this._configureView(),this.addPairedSwatches(),this.favoritesElement=this.container.getElementsByClassName("cp-dialog-favorites")[0],this.addModeSwatches(),this.modeIconDefault=this.createHueSlide(16.5,16,"icon"),this.modeIconDefault.classList.add("cp-mode-hidden"),this.modeIconSwatches=this.createSwatchModeIcon(16.5,16),this.modeButton.appendChild(this.modeIconDefault),this.modeButton.appendChild(this.modeIconSwatches);this.doneButton.innerHTML="<svg xmlns='http://www.w3.org/2000/svg' height='11px' width: '11px' viewBox='0 0 15 15'><path d='M15 0 L0 15 '/><path d='M0 0 L15 15 ' /></svg>",i.select(this.slideElement).on("mousedown.click",this.slideListener()),i.select(this.pickerElement).on("mousedown.click",this.pickerListener()),i.select(this.alphaElement).on("mousedown.click",this.alphaListener()),i.select(this.originalColorIndicator).on("mousedown.click",this.originalColorListener()),i.select(this.doneButton).on("click",this.doneListener()),i.select(this.modeButton).on("click",this.modeListener()),this.enableDragging(this,this.slideElement,this.slideListener()),this.enableDragging(this,this.pickerElement,this.pickerListener()),this.enableDragging(this,this.alphaElement,this.alphaListener()),this.enableDragging(this,this.container,this.dialogListener()),this.enableDragging(this,this.slideIndicator,this.slideListener()),this.enableDragging(this,this.pickerIndicator,this.pickerListener()),this.enableDragging(this,this.alphaIndicator,this.alphaListener()),i.select(this.hexInput).on("blur",this.hexListener()),i.select(this.hexInput).on("keydown",this.hexListener()),i.select(this.rgbRInput).on("input",this.rgbListener()),i.select(this.rgbGInput).on("input",this.rgbListener()),i.select(this.rgbBInput).on("input",this.rgbListener()),i.selectAll(".cp-number-div input").on("mousedown",(t=>{t.stopPropagation()})),this.enableDragging(this,this.rgbRLabel,this.rgbLabelListener(this.rgbRLabel,"red")),this.enableDragging(this,this.rgbGLabel,this.rgbLabelListener(this.rgbGLabel,"green")),this.enableDragging(this,this.rgbBLabel,this.rgbLabelListener(this.rgbBLabel,"blue")),this.setColor(this._color),i.select(this.container).style("visibility","hidden")}get color(){return this._color}get object(){return this._object}set object(t){this._object=t}updateColor(){this._color.hsv=this.hsv,this._color.opacity=this.opacity,this.updateIndicators();const t=y.rgb2String(y.hsv2rgb({h:this.hsv.h,s:1,v:1}));this.pickerElement.style.backgroundColor=t,this.pickerIndicatorRect1.style.backgroundColor=this.color.rgbString,this.slideIndicator.style.backgroundColor=t,i.select(this.alphaElement).selectAll("stop").attr("stop-color",this.color.rgbString),this.currentColorIndicator.style.backgroundColor=this.color.rgbaString,this.onChange&&this.onChange(this.color)}setColor(t,e=!0){this._color.setColor(t),this.hsv=this._color.hsv,this.opacity=Number(this._color.opacity.toFixed(2)),e&&(this.originalColorIndicator.style.backgroundColor=this._color.rgbaString),this.updateColor()}updateIndicators(){const t=this.hsv,e=t.h*this.slideElement.offsetHeight/360,s=this.pickerElement.offsetHeight,i=t.s*this.pickerElement.offsetWidth,r=s-t.v*s,n=this.alphaElement.offsetWidth*this.opacity,o=this.pickerIndicator,a=this.slideIndicator,h=this.alphaIndicator;a.style.top=e-a.offsetHeight/2+"px",o.style.top=r-o.offsetHeight/2+"px",o.style.left=i-o.offsetWidth/2+"px",h.style.left=n-h.offsetWidth/2+"px",this.hexInput.value=this.color.hex,this.rgbRInput.value=this.color.rgb.r,this.rgbGInput.value=this.color.rgb.g,this.rgbBInput.value=this.color.rgb.b,this.alphaNumber.innerHTML=`${Math.round(100*this.opacity)}`,this.updateFavorites(),this.highlightSwatches(),this.highlightFavoriteBtn()}setPosition(t){this.container.style.left=`${t.x}px`,this.container.style.top=`${t.y}px`}get width(){return this.container.offsetWidth}get height(){return this.container.offsetHeight}_colorpickerHTMLSnippet(){return['<div class="cp-dialog-header">','<button class="cp-mode-button" title="Toggle Swatches"></button>','<div class="cp-header-color-section">','<div class="cp-color-original" title="Original Color"></div>','<div class="cp-color-current"></div>',"</div>",'<button class="cp-done-button" title="Close"></button>',"</div>",'<div class="cp-color-picker-mode-swatches cp-mode-hidden"></div>','<div class="cp-color-picker-mode-default">','<div class="cp-color-picker-wrapper">','<div class="cp-color-picker"></div>','<div class="cp-color-picker-indicator">','<div class="cp-picker-indicator-rect-1"></div>','<div class="cp-picker-indicator-rect-2"></div>',"</div>","</div>",'<div class="cp-color-slider-wrapper" title="Hue">','<div class="cp-color-slider"></div>','<div class="cp-color-slider-indicator">','<div class="cp-color-indicator-rect-1"></div>','<div class="cp-color-indicator-rect-2"></div>',"</div>","</div>",'<div class="cp-alpha-wrapper" title="Opacity">','<div class="cp-alpha-slider-wrapper">','<div class="cp-alpha-slider"></div>','<div class="cp-alpha-slider-indicator">','<div class="cp-alpha-indicator-rect-1"></div>','<div class="cp-alpha-indicator-rect-2"></div>',"</div>","</div>",'<div class="cp-alpha-number"></div>',"</div>",'<div class="cp-dialog-numbers">','<div class="cp-number-div cp-hex-div"><input type="text" class="cp-hex-input"  spellcheck="false" /><div class="cp-number-label">Hex</div></div>','<div class="cp-number-div" title="Red"><input type="text" maxlength="3" class="cp-rgb-r-input" /><div class="cp-number-label">R</div></div>','<div class="cp-number-div" title="Green"><input type="text" maxlength="3" class="cp-rgb-g-input" /><div class="cp-number-label">G</div></div>','<div class="cp-number-div" title="Blue"><input type="text" maxlength="3" class="cp-rgb-b-input" /><div class="cp-number-label">B</div></div>',"</div>","</div>",'<div class="cp-dialog-swatches">',"</div>"].join("")}createSwatchModeIcon(t,e){this.containerId;const s=[["#CCC","#999","#666"],["#CCF","#99F","#66F"],["#FCC","#F99","#F66"]],i=[];for(let t=0;t<3;t++)for(let e=0;e<3;e++)i.push([t,e]);const r=(t-4)/3,n=(e-4)/3,o=i.map((t=>{const e=t[0],i=t[1],o=r*i+2*i,a=n*e+2*e,h=s[e][i];return R("rect",{x:`${o}px`,y:`${a}px`,width:`${r}px`,height:`${n}px`,rx:"1px",fill:`${h}`})}));return R("svg",{xmlns:"http://www.w3.org/2000/svg",version:"1.1",width:`${t+1}px`,height:`${e}px`},o)}createHueSlide(t,e,s){const i=this.containerId;return R("svg",{xmlns:"http://www.w3.org/2000/svg",version:"1.1",width:`${t}px`,height:`${e}px`},[R("defs",{},R("linearGradient",{id:`${i}-${s}-gradient-hsv`,x1:"0%",y1:"100%",x2:"0%",y2:"0%"},[R("stop",{offset:"0%","stop-color":"#FF0000","stop-opacity":"1"}),R("stop",{offset:"13%","stop-color":"#FF00FF","stop-opacity":"1"}),R("stop",{offset:"25%","stop-color":"#8000FF","stop-opacity":"1"}),R("stop",{offset:"38%","stop-color":"#0040FF","stop-opacity":"1"}),R("stop",{offset:"50%","stop-color":"#00FFFF","stop-opacity":"1"}),R("stop",{offset:"63%","stop-color":"#00FF40","stop-opacity":"1"}),R("stop",{offset:"75%","stop-color":"#0BED00","stop-opacity":"1"}),R("stop",{offset:"88%","stop-color":"#FFFF00","stop-opacity":"1"}),R("stop",{offset:"100%","stop-color":"#FF0000","stop-opacity":"1"})])),R("rect",{x:"0",y:"0",width:`${t}px`,height:`${e}px`,rx:"2px",fill:`url(#${i}-${s}-gradient-hsv)`})])}_configureView(){const t=this.containerId,e=this.createHueSlide(20,100,"main"),s=R("svg",{xmlns:"http://www.w3.org/2000/svg",version:"1.1",width:"100px",height:"100px"},[R("defs",{},[R("linearGradient",{id:`${t}-gradient-black`,x1:"0%",y1:"100%",x2:"0%",y2:"0%"},[R("stop",{offset:"0%","stop-color":"#000000","stop-opacity":"1"}),R("stop",{offset:"100%","stop-color":"#CC9A81","stop-opacity":"0"})]),R("linearGradient",{id:`${t}-gradient-white`,x1:"0%",y1:"100%",x2:"100%",y2:"100%"},[R("stop",{offset:"0%","stop-color":"#FFFFFF","stop-opacity":"1"}),R("stop",{offset:"100%","stop-color":"#CC9A81","stop-opacity":"0"})])]),R("rect",{x:"0",y:"0",width:"100px",height:"100px",rx:"2px",fill:`url(#${t}-gradient-white)`}),R("rect",{x:"0",y:"0",width:"100px",height:"100px",rx:"2px",fill:`url(#${t}-gradient-black)`})]),i=R("svg",{xmlns:"http://www.w3.org/2000/svg",version:"1.1",width:"100px",height:"10px",style:"position: absolute;"},[R("defs",{},[R("linearGradient",{id:`${t}-alpha-gradient`},[R("stop",{offset:"0%","stop-color":"#FFFFFF","stop-opacity":"0"}),R("stop",{offset:"100%","stop-color":"#FFFFFF","stop-opacity":"1"})]),R("pattern",{id:`${t}-alpha-squares`,x:"0",y:"0",width:"10px",height:"10px",patternUnits:"userSpaceOnUse"},[R("rect",{x:"0",y:"0",width:"10px",height:"10px",fill:"white"}),R("rect",{x:"0",y:"0",width:"5px",height:"5px",fill:"lightgray"}),R("rect",{x:"5px",y:"5px",width:"5px",height:"5px",fill:"lightgray"})])]),R("rect",{x:"0",y:"0",width:"100px",height:"10px",rx:"2px",fill:`url(#${t}-alpha-squares)`}),R("rect",{x:"0",y:"0",width:"100px",height:"10px",rx:"2px",fill:`url(#${t}-alpha-gradient)`})]);this.slideElement.appendChild(e),this.pickerElement.appendChild(s),this.alphaElement.appendChild(i)}addModeSwatches(){const t=this,e=[["Grays",["rgb(236, 236, 236)","rgb(209, 209, 209)","rgb(172, 172, 172)","rgb(130, 130, 130)","rgb(91, 91, 91)","rgb(44, 44, 44)","rgb(0, 0, 0)"]],["Blues",["rgb(219, 233, 246)","rgb(186, 214, 235)","rgb(136, 190, 220)","rgb(84, 158, 205)","rgb(43, 122, 185)","rgb(14, 85, 157)","rgb(8, 48, 107)"]],["Purples",["rgb(235, 234, 243)","rgb(209, 209, 230)","rgb(175, 174, 211)","rgb(141, 137, 192)","rgb(112, 94, 170)","rgb(87, 45, 146)","rgb(63, 0, 125)"]],["Reds",["rgb(254, 217, 201)","rgb(252, 175, 148)","rgb(251, 129, 97)","rgb(243, 79, 57)","rgb(213, 36, 34)","rgb(168, 16, 22)","rgb(103, 0, 13)"]],["Oranges",["rgb(254, 226, 198)","rgb(253, 198, 146)","rgb(253, 160, 87)","rgb(246, 120, 37)","rgb(222, 82, 7)","rgb(175, 57, 3)","rgb(127, 39, 4)"]],["Greens",["rgb(223, 243, 218)","rgb(188, 228, 181)","rgb(141, 208, 139)","rgb(87, 181, 104)","rgb(43, 148, 76)","rgb(9, 112, 48)","rgb(0, 68, 27)"]]].map((t=>`<div class="cp-swatch-section"><div class="cp-swatch-label">${t[0]}</div><div class="cp-swatch-row">${t[1].map((t=>new y(t))).map((t=>`<div class="cp-swatch" data-rgba-string='${t.rgbaString}' title='${t.rgbString}' style="background-color: ${t.rgbString}"></div>`)).join("")}</div>`)).join("");this.modeSwatchesElement=this.container.getElementsByClassName("cp-color-picker-mode-swatches")[0],this.modeSwatchesElement.innerHTML=`${e}`;const s=t.modeSwatchesElement.getElementsByClassName("cp-swatch");for(const e of s)e.addEventListener("click",(function(s){const i=e.dataset.rgbaString;t.setColor(i,!1)}))}addPairedSwatches(){const t=this,e=["#FFFFFF","#A6CEE3","#B2DF8A","#FB9A99","#FDBF6F","#CAB2D6","#FFFF99","#000000","#1F78B4","#33A02C","#E31A1C","#FF7F00","#6A3D9A","#B15928"].map((t=>new y(t))).map((t=>`<div class="cp-swatch" data-rgba-string='${t.rgbaString}' title='${t.rgbString}' style="background-color: ${t.rgbString}"></div>`)).join("");t.swatchesElement.innerHTML=`${e}<div class='cp-dialog-favorites'></div>`;const s=t.swatchesElement.getElementsByClassName("cp-swatch");for(const e of s)e.addEventListener("click",(function(s){const i=e.dataset.rgbaString;t.setColor(i,!1)}))}loadFavorites(){const t=localStorage.getItem(this.localStorageKey)||"[]";let e=JSON.parse(t);e=Array.isArray(e)?e:[],this.favorites=e.slice(0,this.maxFavorites),this.updateFavorites()}updateFavorites(){const t=this,e=t.color.rgbaString,s=t.favorites?.map((t=>`<div data-rgba-string='${t}' title="${t}" class="cp-swatch ${t===e?"cp-swatch-active":""}" style="background-color: ${t}"></div>`)).join(""),r=t.maxFavorites-t.favorites.length,n=Array(r>=7?r-7:r).fill("<div class=\"cp-swatch-blank\"><svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 15 15'><path d='M15 0 L0 15 '/><path d='M0 0 L15 15 ' /></svg></div>").join("");t.favoritesElement.innerHTML=`<div class='cp-favorite-btn' title='Favorite current color'><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 51 48"><path fill="none" stroke="#000" d="m25,1 6,17h18l-14,11 5,17-15-10-15,10 5-17-14-11h18z"/></svg></div>${s}${n}`,this.favoriteBtn=this.container.querySelector(".cp-favorite-btn"),i.select(this.favoriteBtn).on("click",(()=>{t.favorites.includes(t.color.rgbaString)?t.favorites=t.favorites.filter((e=>e!==t.color.rgbaString)):t.favorites.unshift(t.color.rgbaString),t.favorites=t.favorites.slice(0,t.maxFavorites),localStorage.setItem(this.localStorageKey,JSON.stringify(t.favorites)),t.updateIndicators()})),t.highlightFavoriteBtn();const o=t.favoritesElement.getElementsByClassName("cp-swatch");for(const e of o)e.addEventListener("click",(function(s){const i=e.dataset.rgbaString;t.setColor(i,!1)}))}highlightSwatches(){const t=this.color.rgbaString,e=this.container.getElementsByClassName("cp-swatch");for(const s of e){new y(s.style.backgroundColor).rgbaString===t?s.classList.add("cp-swatch-active"):s.classList.remove("cp-swatch-active")}}highlightFavoriteBtn(){const t=this,e=t.color.rgbaString;t.favorites.includes(e)?(t.favoriteBtn.classList.add("cp-favorite-btn-active"),t.favoriteBtn.title="Unfavorite current color"):(t.favoriteBtn.classList.remove("cp-favorite-btn-active"),t.favoriteBtn.title="Favorite current color")}enableDragging(t,e,s){i.select(e).on("mousedown",(function(t){t.preventDefault(),t.stopPropagation();const r=A(e,t);i.select(document).on("mousemove.colordrag",(function(t){document.selection?document.selection.empty():window.getSelection().removeAllRanges(),s(t,r)})),i.select(document).on("mouseup",(function(){i.select(document).on("mousemove.colordrag",null)}))}))}slideListener(){const t=this,e=t.slideElement;return function(s,i){const r=A(e,s);t.hsv.h=r.y/e.offsetHeight*360,t.hsv.h>=359&&(t.hsv.h=359),t.updateColor()}}pickerListener(){const t=this,e=t.pickerElement;return function(s,i){const r=e.offsetWidth,n=e.offsetHeight,o=A(e,s);t.hsv.s=o.x/r,t.hsv.v=(n-o.y)/n,t.updateColor()}}alphaListener(){const t=this,e=t.alphaElement;return function(s,i){const r=A(e,s).x/e.offsetWidth;t.opacity=Number(r.toFixed(2)),t.updateColor()}}rgbLabelListener(t,e){const s=this,i=s.rgbRInput,r=s.rgbGInput,n=s.rgbBInput;return function(a,h){let l=parseInt(i.value);"green"===e&&(l=parseInt(r.value)),"blue"===e&&(l=parseInt(n.value));const c=A(t,a,!1);let d=l+Math.floor(c.x-h.x);d=o.constrain(d,0,255);const g=y.rgb2hsv({r:"red"===e?d:parseInt(i.value),g:"green"===e?d:parseInt(r.value),b:"blue"===e?d:parseInt(n.value)});s.hsv=g,s.updateColor(),h.x=c.x}}hexListener(){const t=this,e=t.hexInput;return function(s){if("keydown"===s.type&&13!==s.keyCode)return;let i=e.value;new RegExp(/^([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/).test(i)&&(i="#"+i),""===i&&(i=t.color.rgbString),t.setColor(i,!1)}}rgbListener(){const t=this,e=t.rgbRInput,s=t.rgbGInput,i=t.rgbBInput;return function(r){let n=parseInt(e.value.replace(/[^0-9]/g,""));n>255&&(n=255);let o=parseInt(s.value.replace(/[^0-9]/g,""));o>255&&(o=255);let a=parseInt(i.value.replace(/[^0-9]/g,""));a>255&&(a=255);const h=y.rgb2hsv({r:n,g:o,b:a});t.hsv=h,t.updateColor()}}dialogListener(){const t=this.container;return function(e,s){const i=o.getOffset(t.offsetParent),r=i.left,n=i.top;t.style.left=e.pageX-r-s.x+"px",t.style.top=e.pageY-n-s.y+"px"}}originalColorListener(){const t=this;return function(){t.setColor(t.originalColorIndicator.style.backgroundColor)}}doneListener(){const t=this;return function(){t.onChange=void 0,t.close()}}modeListener(){const t=this;return function(){"default"===t.mode?(t.mode="swatches",t.modeSwatches.classList.remove("cp-mode-hidden"),t.modeDefault.classList.add("cp-mode-hidden"),t.modeIconSwatches.classList.add("cp-mode-hidden"),t.modeIconDefault.classList.remove("cp-mode-hidden")):(t.mode="default",t.modeDefault.classList.remove("cp-mode-hidden"),t.modeSwatches.classList.add("cp-mode-hidden"),t.modeIconDefault.classList.add("cp-mode-hidden"),t.modeIconSwatches.classList.remove("cp-mode-hidden"),t.updateIndicators())}}get visible(){return"visible"===i.select(this.container).style("visibility")}set visible(t){t?this.open():this.close()}open(t){this.loadFavorites(),t&&(this.object=t);const e=i.select(this.container);return e.style("visibility","visible"),e.transition().duration(200).style("opacity",1),this}close(){return i.select(this.container).transition().duration(200).style("opacity",0).on("end",(function(){i.select(this).style("visibility","hidden")})),this.onClose&&this.onClose(),this.onClose=void 0,this}}function R(t,e,s){t=document.createElementNS("http://www.w3.org/2000/svg",t);for(const s in e)t.setAttribute(s,e[s]);"[object Array]"!==Object.prototype.toString.call(s)&&(s=[s]);const i=s[0]&&s.length||0;for(let e=0;e<i;e++)t.appendChild(s[e]);return t}function A(t,e,s=!0){const r=t.offsetWidth,n=t.offsetHeight,o=i.pointer(e,t),a={x:o[0],y:o[1]};return s&&(a.x>r?a.x=r:a.x<0&&(a.x=0),a.y>n?a.y=n:a.y<0&&(a.y=0)),a}function B(){onmessage=function(e){const s=t(e.data);postMessage({messageType:"complete",featureDataArray:s}),close()},onerror=function(t){console.error(`Oops. Problem with ${t.data.type}`)};const t=function(t){let s;const r=t.type,n=t.seqType,o=t.seqData,a=t.seqTotalLength,h=t.options;console.log(`Starting ${r}`);let l,c,d,g=[],u=0,p=0;for(var f=0,m=o.length;f<m;f++)l=o[f].seq,c=l.length/a*100,p=u/a*100,d=p+c,"contigs"===n&&(h.contigID=o[f].name),"start-stop-codons"===r?(s={start:p,stop:p+c/2},g=g.concat(e(l,1,h,s)),s={start:s.stop,stop:d},g=g.concat(e(l,-1,h,s))):"orfs"===r&&(s={start:p,stop:d},g=g.concat(i(l,h,s))),u+=l.length;return g},e=function(t,e,i,r={}){let o=0,a=0;t=1===e?t:n(t);const h=i.startPattern.toUpperCase().split(",").map((t=>t.trim())).join("|"),l=i.stopPattern.toUpperCase().split(",").map((t=>t.trim())).join("|"),c=`${h}|${l}`,d=h.split("|"),g=l.split("|"),u=new RegExp(c,"g");let p,f,m,b;const v=t.length,w=[];for(;null!==(p=u.exec(t));)f=1===e?p.index+1:v-p.index-p[0].length+1,d.indexOf(p[0])>=0?b="start-codon":g.indexOf(p[0])>=0&&(b="stop-codon"),m={type:b,start:f,stop:f+p[0].length-1,strand:e,source:"start-stop-codons",contig:i.contigID,extractedFromSequence:!0},w.push(m),o=Math.round(1===e?f/v*100:(v-f)/v*100),a=s(o,a,r),u.lastIndex=p.index+1;return w},s=function(t,e,s={}){const i=Math.round(s.start||0),r=Math.round(s.stop||100),n=s.increment||1,o=r-i;if(t>e&&t%n==0){const s=i+o*e/100;e=t;const r=i+o*t/100;r>s&&r%n==0&&postMessage({messageType:"progress",progress:r})}return e},i=function(t,s,i={}){s.minORFLength;const n=t.length;let o=[];const h=i.start||0,l=i.stop||100,c=(l-h)/4;let d=e(t,1,s,i={start:h,stop:h+c});i={start:i.stop,stop:h+2*c},d=d.concat(e(t,-1,s,i));const g=d.filter((t=>"start-codon"===t.type)),u=d.filter((t=>"stop-codon"===t.type)),p=a(g,n),f=a(u,n);return i={start:i.stop,stop:h+3*c},o=r(1,p,f,n,s,i),i={start:i.stop,stop:l},o=o.concat(r(-1,p,f,n,s,i)),o},r=function(t,e,i,r,n={},o={}){let a,h,l,c,d,g,u,p,f,m;const b=n.minORFLength||100,v=[],w=1===t?["rfPlus1","rfPlus2","rfPlus3"]:["rfMinus1","rfMinus2","rfMinus3"];return w.forEach((function(_){a=1===t?1:r,u=0,l=e[_],c=i[_];const y=33*w.indexOf(_);f=0,m=0,-1===t&&(l.sort(((t,e)=>e.start-t.start)),c.sort(((t,e)=>e.start-t.start)));for(let e=0,r=l.length;e<r;e++)if(d=l[e],f=y+Math.round(e/r*33),m=s(f,m,o),!(1===t&&d.start<a||-1===t&&d.start>a))for(let e=u,s=i[_].length;e<s;e++){if(g=c[e],h=1===t?g.stop-d.start:d.stop-g.start,h>=3*b){a=1===t?g.stop:g.start,p={type:"ORF",start:1===t?d.start:g.start,stop:1===t?g.stop:d.stop,strand:t,source:"orfs",contig:n.contigID,extractedFromSequence:!0},v.push(p),u=e;break}if(h>0){a=1===t?g.stop:g.start,u=e;break}}})),v},n=function(t){return o(t.split("").reverse().join(""))},o=function(t){let e,s,i="";for(let r=0,n=t.length;r<n;r++){switch(e=t.charAt(r),e){case"A":s="T";break;case"T":s="A";break;case"G":s="C";break;case"C":s="G"}i+=s}return i},a=function(t,e){const s={rfPlus1:[],rfPlus2:[],rfPlus3:[],rfMinus1:[],rfMinus2:[],rfMinus3:[]};let i,r;for(let n=0,o=t.length;n<o;n++)r=t[n],-1===r.strand?(i=(e-r.stop+1)%3,0===i&&(i=3),s[`rfMinus${i}`].push(r)):(i=r.start%3,0===i&&(i=3),s[`rfPlus${i}`].push(r));return s}}function N(){onmessage=function(e){console.log(`Starting ${e.data.type}`),t(e.data),console.log(`Done ${e.data.type}`)},onerror=function(t){console.error(`Oops. Problem with ${t.data.type}`)};const t=function(t){let s=0,i=0;const r=[];let l=[];const c=t.type,d=t.seqData[0].seq,g=t.options,u=g.window,p=g.step,f=g.deviation;let m=e(c,d),b=1,v=0;const w=u/2;let _,y;for(let t=1,h=d.length;t<h;t+=p){_=n(d,t,w),y=o(d,t,w);const g=a(d,_,y),u=e(c,g);u>v&&(v=u),u<b&&(b=u),1===t?r.push(1):r.push(t-p/2),l.push(u),s=Math.round(t/h*100),s>i&&s%5==0&&(i=s,postMessage({messageType:"progress",progress:s}))}console.log(`Min: ${b}`),console.log(`Max: ${v}`),console.log(`Average: ${m}`),"scale"===f&&(l=l.map((t=>t>=m?h(t,{min:m,max:v},{min:.5,max:1}):h(t,{min:b,max:m},{min:0,max:.5}))),b=0,v=1,m=.5);postMessage({messageType:"complete",baseContent:{positions:r,scores:l,min:b,max:v,average:m}})},e=function(t,e){return"gc-content"===t?s(e):"gc-skew"===t?i(e):void 0},s=function(t){if(0===t.length)return.5;return(r(t,"g")+r(t,"c"))/t.length},i=function(t){const e=r(t,"g"),s=r(t,"c");if(e+s===0)return.5;return(e-s)/(e+s)},r=function(t,e){return(t.match(new RegExp(e,"gi"))||[]).length},n=function(t,e,s){return s<e?e-s:t.length+e-s},o=function(t,e,s){return t.length>=s+e?s+e:e-t.length+s},a=function(t,e,s){let i;return i=s<e?t.substring(e-1)+t.substring(0,s):t.substring(e-1,s),i},h=function(t,e={min:0,max:1},s={min:0,max:1}){return(s.max-s.min)*(t-e.min)/(e.max-e.min)+s.min}}class q{constructor(t,e={}){if(this.sequence=t,!t.seq)throw"Sequence invalid. The sequence must be provided."}get sequence(){return this._sequence}set sequence(t){t&&(this._sequence=t)}get viewer(){return this.sequence.viewer}get length(){return this.sequence.length}fn2workerURL(t){const e=new Blob([`(${t.toString()})()`],{type:"application/javascript"});return URL.createObjectURL(e)}sequenceInput(t=!1){let e,s;return this.sequence.hasMultipleContigs&&!t?(e="contigs",s=this.sequence.contigs().map((t=>t.toJSON()))):(e="sequence",s=[{seq:this.sequence.seq}]),{type:e,data:s}}extractTrackData(t,e,s={}){if(o.validate(e,["start-stop-codons","orfs","gc-skew","gc-content"]))switch(e){case"start-stop-codons":case"orfs":t.dataType="feature",this.generateFeatures(t,e,s);break;case"gc-skew":case"gc-content":t.dataType="plot",this.generatePlot(t,e,s)}}generateFeatures(t,e,s={}){if(!o.validate(e,["start-stop-codons","orfs"]))return;let i=(new Date).getTime();const r=this.viewer,n=this.fn2workerURL(B),a=new Worker(n),h=this.sequenceInput(),l={type:e,seqType:h.type,seqData:h.data,seqTotalLength:this.sequence.length,options:{startPattern:o.defaultFor(s.start,"ATG, TTG, CTG, ATT, ATC, ATA, GTG"),stopPattern:o.defaultFor(s.stop,"TAA,TAG,TGA"),minORFLength:o.defaultFor(s.minORFLength,100)}};a.postMessage(l),a.onmessage=s=>{const n=s.data.messageType;if("progress"===n&&(t.update({loadProgress:s.data.progress}),r.layout.drawProgress()),"complete"===n){t.update({loadProgress:100});const n=s.data.featureDataArray;console.log(`Features '${e}' Worker Time: ${o.elapsedTime(i)}`),i=(new Date).getTime();const a=this.createLegendItems(e);console.log(e);for(let t=0,e=n.length;t<e;t++)n[t].legend=a[n[t].type];const h=r.addFeatures(n);console.log(`Features '${e}' Creation Time: ${o.elapsedTime(i)}`),i=(new Date).getTime(),t._features=h,t.updateSlots(),t.triggerUpdate(),console.log(`Features '${e}' Update Time: ${o.elapsedTime(i)}`),r.drawFull()}},a.onerror=t=>{}}generatePlot(t,e,s={}){if(!o.validate(e,["gc-content","gc-skew"]))return;const i=(new Date).getTime(),r=this.viewer,n=this.fn2workerURL(N),a=new Worker(n),h=this.sequenceInput(!0),l={type:e,seqType:h.type,seqData:h.data,seqTotalLength:this.sequence.length,options:{window:o.defaultFor(s.window,this.getWindowStep().window),step:o.defaultFor(s.step,this.getWindowStep().step),deviation:o.defaultFor(s.deviation,"average")}};console.log(l.options),a.postMessage(l),a.onmessage=s=>{const n=s.data.messageType;if("progress"===n&&(t.update({loadProgress:s.data.progress}),r.layout.drawProgress()),"complete"===n){t.update({loadProgress:100});const n=s.data.baseContent,a={positions:n.positions,scores:n.scores,baseline:n.average,axisMin:n.min,axisMax:n.max};a.source=e,a.legendPositive=this.getLegendItem(e,"+").name,a.legendNegative=this.getLegendItem(e,"-").name,a.name=e,a.extractedFromSequence=!0,"gc-skew"===e&&(a.baseline=0);const h=r.addPlots(a);t._plot=h[0],t.updateSlots(),t.triggerUpdate(),console.log(`Plot '${e}' Worker Time: ${o.elapsedTime(i)}`),r.drawFull()}},a.onerror=t=>{}}createLegendItems(t){let e={};return"orfs"===t?e={ORF:this.getLegendItem("ORF")}:"start-stop-codons"===t&&(e={"start-codon":this.getLegendItem("start-codon"),"stop-codon":this.getLegendItem("stop-codon")}),e}getLegendItem(t,e){const s=this.viewer.legend;let i;switch(t){case"start-codon":i=s.findLegendItemOrCreate("Start","blue","arc");break;case"stop-codon":i=s.findLegendItemOrCreate("Stop","red","arc");break;case"ORF":i=s.findLegendItemOrCreate("ORF","green","arc");break;case"gc-content":const t=this.viewer.settings.backgroundColor.copy().invert();i=s.findLegendItemOrCreate("GC Content",t);break;case"gc-skew":{const t="+"===e?"rgb(0,153,0)":"rgb(153,0,153)",r="+"===e?"GC Skew+":"GC Skew-";i=s.findLegendItemOrCreate(r,t);break}default:i=s.findLegendItemOrCreate("Unknown","grey")}return i}getWindowStep(){let t,e;const s=this.length;return s<1e3?(t=10,e=1):s<1e4?(t=50,e=1):s<1e5?(t=500,e=1):s<1e6?(t=1e3,e=10):s<1e7?(t=1e4,e=100):s<1e8&&(t=5e4,e=1e3),{step:e,window:t}}}class j extends c{constructor(t,e={},s={}){super(t,e,s),this._viewer=t,this.bpMargin=2,this.color=o.defaultFor(e.color,"black"),this.font=o.defaultFor(e.font,"sans-serif, plain, 14"),this._contigs=new n,this.createMapContig(e),this.viewer.trigger("sequence-update",{attributes:this.toJSON({includeDefaults:!0})})}static forRange(t,e,s=!1){const i=e&&e.start,r=e&&e.stop;if(!t||!i||!r)return;let n="";return n=r<i?t.substring(i-1)+t.substring(0,r):t.substring(i-1,r),s&&(n=j.reverseComplement(n)),n}static complement(t){let e,s,i="";for(let r=0,n=t.length;r<n;r++){switch(e=t.charAt(r),e){case"A":s="T";break;case"T":s="A";break;case"G":s="C";break;case"C":s="G";break;case"U":s="A";break;case"Y":s="R";break;case"S":s="S";break;case"W":s="W";break;case"K":s="M";break;case"M":s="K";break;case"B":s="V";break;case"D":s="H";break;case"H":s="D";break;case"V":s="B";break;case"N":s="N"}i+=s}return i}static baseCalculation(t,e){return"gc-content"===t?j.calcGCContent(e):"gc-skew"===t?j.calcGCSkew(e):void 0}static calcGCContent(t){if(0===t.length)return.5;return(j.count(t,"g")+j.count(t,"c"))/t.length}static calcGCSkew(t){const e=j.count(t,"g"),s=j.count(t,"c");if(e+s===0)return.5;return.5+(e-s)/(e+s)/2}static reverseComplement(t){return j.complement(t.split("").reverse().join(""))}static count(t,e){return(t.match(new RegExp(e,"gi"))||[]).length}static random(t){let e,s="";for(let i=0;i<t;i++)switch(e=Math.floor(4*Math.random()),e%4){case 0:s+="A";break;case 1:s+="T";break;case 2:s+="G";break;case 3:s+="C"}return s}reverseComplement(){return j.reverseComplement(this.seq)}count(t){return j.count(this.seq,t)}toString(){return"Sequence"}get seq(){return this.mapContig.seq}get mapContig(){return this._mapContig}get sequenceExtractor(){return this._sequenceExtractor}get length(){return this.mapContig.length}_updateScale(){this.viewer.layout.updateScales()}get color(){return this._color}set color(t){"Color"===t.toString()?this._color=t:this._color=new y(t)}get font(){return this._font}set font(t){"Font"===t.toString()?this._font=t:this._font=new _(t),this.bpSpacing=this.font.size}get bpSpacing(){return this._bpSpacing}set bpSpacing(t){this._bpSpacing=t,this.viewer._updateZoomMax()}get bpMargin(){return this._bpMargin}set bpMargin(t){this._bpMargin=t}get thickness(){return 2*this.bpSpacing+8*this.bpMargin}get isLinear(){return!1}get isCircular(){return!0}get hasSeq(){return"string"==typeof this.seq}get hasMultipleContigs(){return this._contigs.length>1}addContigs(t=[]){const e=(t=n.arrayerize(t)).map((t=>{const e=new D(this,t);return this._contigs.push(e),e}));return this.updateMapContig(),this.viewer.trigger("contigs-add",e),e}removeContigs(t){if((t=n.arrayerize(t).slice()).length===this._contigs.length){const e=t.pop();console.error("The last contig can not be removed. Keeping:",e)}if(t.length>0){const e=t.map((t=>t.features())).flat();this.viewer.removeFeatures(e),this._contigs=this._contigs.filter((e=>!t.includes(e))),t.forEach((t=>t.deleteFromObjects())),this.updateMapContig()}this.viewer.trigger("contigs-remove",t)}updateContigs(t,e){const{records:s,updates:i}=this.viewer.updateRecords(t,e,{recordClass:"Contig",validKeys:["name","orientation","color","visible"]});this.updateMapContig();for(const t of this.viewer.tracks())t.refresh();this.viewer.annotation.refresh(),this.viewer.trigger("tracks-update",{tracks:this.viewer.tracks()}),this.viewer.trigger("contigs-update",{contigs:s,attributes:e,updates:i})}moveContig(t,e){this._contigs.move(t,e),this.updateMapContig();for(const t of this.viewer.tracks())t.refresh();this.viewer.annotation.refresh(),this.viewer.trigger("contigs-moved",{oldIndex:t,newIndex:e});const s=[],i=Math.min(t,e),r=Math.max(t,e);for(let t=i;t<=r;t++)s.push(this._contigs[t]);this.viewer.trigger("contigs-update",{contigs:s,attributes:{}})}createMapContig(t){t.seq?this.addContigs([{seq:t.seq}]):t.contigs?this.addContigs(t.contigs):t.length?this.addContigs([{length:t.length}]):this.addContigs([{length:1e3}])}updateMapContig(){if(1===this._contigs.length)this._mapContig=this._contigs[0],this._mapContig._index=1,this._mapContig._updateLengthOffset(0);else{const t=this._contigs[0].hasSeq;let e="",s=0;for(let i=0,r=this._contigs.length;i<r;i++){const r=this._contigs[i];r._index=i+1,r.visible&&(r._updateLengthOffset(s),t?r.hasSeq?(e+=r.seq,s+=r.seq.length):console.error(`Expecting Sequence but Contig '${r.name}' has no sequence !`):r.length?s+=r.length:console.error(`Expecting Length but Contig '${r.name}' has no length!`))}const i=this.mapContig,r=t?{seq:e}:{length:s};this._mapContig=new D(this,r),i&&(i.features().forEach((t=>t.contig=this.mapContig)),i.deleteFromObjects())}this._sequenceExtractor=this.hasSeq?new q(this):void 0,this._updateScale()}contigs(t){return this._contigs.get(t)}contigsForMapRange(t){const e=new n;for(let s=1,i=this.sequence.contigs().length;s<=i;s++){const i=this.sequence.contigs(s);i.visible&&t.overlapsMapRange(i.mapRange)&&e.push(i)}return e}bpForContig(t,e=1){return t.mapStart+e-1}contigForBp(t){if(this.hasMultipleContigs){for(let e=0,s=this._contigs.length;e<s;e++)if(t<=this._contigs[e].lengthOffset)return this._contigs[e-1];return this._contigs[this._contigs.length-1]}}asFasta(t,e={}){if(e.concatenateContigs||!this.hasMultipleContigs){return`>${t||this.contigs(1).name}\n${this.seq}`}{let t="";for(const e of this._contigs)t+=`${e.asFasta()}\n`;return t}}lengthOfRange(t,e){return e>=t?e-t:this.length+(e-t)}subtractBp(t,e){return e<t?t-e:this.length+t-e}addBp(t,e){return this.length>=e+t?e+t:t-this.length+e}constrain(t){return o.constrain(t,1,this.length)}forRange(t,e){let s;return s=this.seq?j.forRange(this.seq,t,e):this._fakeSequenceForRange(t),s}_fakeSequenceForRange(t){let e="",s=t.start;for(let i=0,r=t.length;i<r;i++){switch(s%4){case 0:e+="A";break;case 1:e+="T";break;case 2:e+="G";break;case 3:e+="C"}s++}return e}findPattern(t,e=1){const s=new RegExp(t,"g"),i=[];let r,n;const o=1===e?this.seq:this.reverseComplement();for(;null!==(r=s.exec(o));)n=1===e?r.index+1:this.length-r.index-r[0].length+1,i.push(new M(this.mapContig,n,n+r[0].length-1)),s.lastIndex=r.index+1;return i}featuresByReadingFrame(t){const e={rfPlus1:new n,rfPlus2:new n,rfPlus3:new n,rfMinus1:new n,rfMinus2:new n,rfMinus3:new n};let s;return t.each(((t,i)=>{-1===i.strand?(s=(this.length-i.stop+1)%3,0===s&&(s=3),e[`rfMinus${s}`].push(i)):(s=i.start%3,0===s&&(s=3),e[`rfPlus${s}`].push(i))})),e}_emptySequence(t){return Array(t+1).join("•")}draw(){if(!this.visible)return;const t=this.canvas.context("map"),e=this.viewer.backbone,s=e.pixelsPerBp();if(s<.25*(this.bpSpacing-this.bpMargin))return;const i=Math.min(1,s/(this.bpSpacing-this.bpMargin)),r=e.adjustedCenterOffset,n=e.visibleRange;let o,a;if(n){this.seq?(o=this.forRange(n),a=j.complement(o)):(o=this._emptySequence(n.length),a=this._emptySequence(n.length));let e=n.start;t.save(),t.fillStyle=this.color.rgbaString,t.font=this.font.cssScaled(i),t.textAlign="center",t.textBaseline="alphabetic";const s=this.font.height*i/2-1,h=(this.bpSpacing/2+this.bpMargin)*i;for(let i=0,l=n.length;i<l;i++){let n=this.canvas.pointForBp(e,r+h);t.fillText(o[i],n.x,n.y+s),n=this.canvas.pointForBp(e,r-h),t.fillText(a[i],n.x,n.y+s),e++}t.restore()}}invertColors(){this.update({color:this.color.invert().rgbaString})}update(t){this.viewer.updateRecords(this,t,{recordClass:"Sequence",validKeys:["color","font","visible"]}),this.viewer.trigger("sequence-update",{attributes:t})}toJSON(t={}){const e={font:this.font.string,color:this.color.rgbString,contigs:this._contigs.map((e=>e.toJSON(t)))};return this.visible&&!t.includeDefaults||(e.visible=this.visible),e}}class D extends c{constructor(t,e={},s={}){super(t.viewer,e,s),this._sequence=t,this._viewer=t.viewer,this.name=o.defaultFor(e.name,"Unknown"),this.orientation=o.defaultFor(e.orientation,"+"),this.seq=e.seq,this.color=e.color,this._features=new n,this._updateLengthOffset(0),this.seq||(this.length=e.length),this.length||console.error(`Contig '${this.name}'  has no sequence or length set!`)}static removeFeatures(t){if(0===(t=n.arrayerize(t)).length)return;const e=t[0].viewer,s={};for(const e of t){const t=e.contig&&e.contig.cgvID;t&&(s[t]?s[t].push(e):s[t]=[e])}const i=Object.keys(s);for(const t of i){const i=e.objects(t);i._features=i._features.filter((e=>!s[t].includes(e)))}}toString(){return"Contig"}get sequence(){return this._sequence}get name(){return this._name}set name(t){let e=`${t}`;""==e&&(e="Unknown");const s=this.sequence._contigs.map((t=>t.name));this._name=o.uniqueName(e,s),this._name!==e&&console.log(`Contig with name '${e}' already exists, using name '${this._name}' instead.`)}get isMapContig(){return this.sequence.mapContig===this}get index(){return this._index}get orientation(){return this._orientation}set orientation(t){o.validate(t,["-","+"])&&(this._orientation&&t!==this._orientation&&this.reverseFeatureOrientations(),this.seq&&(this.seq=this.reverseComplement()),this._orientation=t)}get seq(){return this._seq}set seq(t){this._seq=t,this._seq&&(this._seq=this._seq.toUpperCase(),this._length=t.length)}get length(){return this._length}set length(t){t&&(this.seq?console.error("Can not change the sequence length if *seq* is set."):(this._length=Number(t),this.sequence._updateScale()))}get lengthOffset(){return this._lengthOffset}get color(){return this._color}set color(t){void 0===t?this._color=void 0:"Color"===t.toString()?this._color=t:this._color=new y(t)}get mapRange(){return new M(this.sequence.mapContig,this.lengthOffset+1,this.lengthOffset+this.length)}get mapStart(){return this.mapRange.start}get mapStop(){return this.mapRange.stop}_updateLengthOffset(t){this._lengthOffset=t}reverseComplement(){return j.reverseComplement(this.seq)}update(t){this.sequence.updateContigs(this,t)}get hasSeq(){return"string"==typeof this.seq}features(t){return this._features.get(t)}remove(){this.sequence.removeContigs(this)}move(t){const e=this.sequence.contigs().indexOf(this);this.sequence.moveContig(e,t)}moveTo(t,e){if(this.mapRange.isMapLength())this.viewer.reset(t,e);else{const s=Math.ceil(.05*this.length),i=this.sequence.subtractBp(this.mapStart,s),r=this.sequence.addBp(this.mapStop,s);this.viewer.moveTo(i,r,{duration:t,ease:e})}}reverseFeatureOrientations(){const t={};for(let e=0,s=this._features.length;e<s;e++){const s=this._features[e];t[s.cgvID]={start:this.length-s.stop+1,stop:this.length-s.start+1,strand:-s.strand}}this.viewer.updateFeatures(t)}forRange(t,e){return j.forRange(this.seq,t,e)}asFasta(){return`>${this.name}\n${this.seq}`}highlight(t){const e=this.viewer.backbone;let s;if(this.viewer.canvas,e.visibleRange,t)s=new y(t);else{let t=this.index%2==0?e.color:e.colorAlternate;this.color&&(t=this.color),s=t.copy(),s.highlight()}if(this.visible){const t=this.sequence.bpForContig(this),i=this.sequence.bpForContig(this,this.length);this.viewer.canvas.drawElement("ui",t,i,e.adjustedCenterOffset,s.rgbaString,e.adjustedThickness,e.directionalDecorationForContig(this))}}toJSON(t={}){const e={name:this.name,orientation:this.orientation,length:this.length,color:this.color&&this.color.rgbaString};return this.hasSeq&&(e.seq=this.seq),this.visible&&!t.includeDefaults||(e.visible=this.visible),e}}class ${constructor(t,e={}){this.viewer=t,this._data={},this._sections=o.defaultFor(e.sections,[]);for(const t of this.sections)this.data[t]={}}get sections(){return this._sections}get data(){return this._data}draw(t=10,e=20){const s=this.viewer.canvas;s.clear("debug");const i=s.context("debug"),r=this._data,n=this._sections;i.font="10pt Sans-Serif";const o=this.viewer.settings.backgroundColor.copy();i.fillStyle=o.invert().rgbaString;i.textAlign="left";let a=0;n.forEach((function(s){Object.keys(r[s]).forEach((function(n){i.fillText(`${s}|${n}: ${r[s][n]}`,t,e+18*a),a+=1}))}))}}class E extends c{constructor(t,e,s={},i={}){super(t,s,i),this.color=o.defaultFor(s.color,"grey"),this._thickness=o.defaultFor(s.thickness,1),this._spacing=o.defaultFor(s.spacing,1),this._name=e,this._bbOffsets=new n,this.viewer.trigger("divider-update",{divider:this,attributes:this.toJSON({includeDefaults:!0})})}toString(){return"Divider"}get name(){return this._name}get visible(){return this._visible}set visible(t){this._visible=t,this.viewer.layout&&this.viewer.layout._adjustProportions()}get color(){return this._color}set color(t){"Color"===t.toString()?this._color=t:this._color=new y(t)}set thickness(t){void 0!==t&&(this._thickness=t,this.viewer.layout._adjustProportions())}get thickness(){return this._thickness}get adjustedThickness(){return this.visible?this.viewer.zoomFactor<1?this._thickness*this.viewer.zoomFactor:this._thickness:0}set spacing(t){void 0!==t&&(this._spacing=Math.round(t),this.viewer.layout._adjustProportions())}get spacing(){return this._spacing}get adjustedSpacing(){return this.viewer.zoomFactor<1?this._spacing*this.viewer.zoomFactor:this._spacing}get mirror(){return this.viewer.dividers.dividersMirrored}set mirror(t){this._mirror=t,!0===t?this.viewer.dividers.mirrorDivider(this):this.viewer.dividers.mirrorDivider()}update(t){const{records:e,updates:s}=this.viewer.updateRecords(this,t,{recordClass:"Divider",validKeys:["visible","color","thickness","spacing","mirror"]});this.viewer.trigger("divider-update",{divider:this,attributes:t,updates:s})}toJSON(){return{visible:this.visible,color:this.color.rgbaString,thickness:this.thickness,spacing:this.spacing}}}class z{constructor(t,e={},s={}){this.viewer=t;const i=Object.keys(e);i.includes("slot")&&i.includes("track")?(this._slot=new E(t,"slot",e.slot),this._track=new E(t,"track",e.track)):i.includes("slot")?(this._slot=new E(t,"mirrored",e.slot),this._track=this.slot):i.includes("track")?(this._track=new E(t,"mirrored",e.track),this._slot=this.track):(this._slot=new E(t,"mirrored"),this._track=this.slot),this.clearBbOffsets()}toString(){return"Dividers"}get track(){return this._track}get slot(){return this._slot}get dividersMirrored(){return this.slot===this.track}mirrorDivider(t){t?(this.slot===t?this._track=this.slot:this._slot=this.track,this.slot._name="mirrored"):(this._track=new E(this.viewer,"track",this.slot.toJSON()),this.slot._name="slot")}get bbOffsets(){return this._bbOffsets}clearBbOffsets(){this._bbOffsets=new n}addBbOffset(t,e){if(!["track","slot"].includes(e))throw'Divider bbOffset type must be one of "slot" or "track"';this._bbOffsets.push({distance:t,type:e})}invertColors(){this.track.mirror?this.track.update({color:this.track.color.invert().rgbaString}):(this.track.update({color:this.track.color.invert().rgbaString}),this.slot.update({color:this.slot.color.invert().rgbaString}))}draw(){const t=this.viewer.canvas,e=this.viewer.backbone.adjustedCenterOffset;for(let s=0,i=this._bbOffsets.length;s<i;s++){const i=this._bbOffsets[s];if(!this[i.type].visible)continue;const r=e+i.distance,n=t.visibleRangeForCenterOffset(r,100);n&&t.drawElement("map",n.start,n.stop,r,this[i.type].color.rgbaString,this[i.type].adjustedThickness)}}toJSON(t={}){return this.slot===this.track?{slot:this._slot.toJSON(t)}:{track:this._track.toJSON(t),slot:this._slot.toJSON(t)}}}class G{constructor(t){this._viewer=t,this.events=t.events,this._initializeMousemove(),this._initializeClick(),this._initializeBookmarkShortcuts(),this.events.on("mousemove",(t=>{this.viewer.debug&&this.viewer.debug.data.position&&(this.viewer.debug.data.position.xy=`${Math.round(t.mapX)}, ${Math.round(t.mapY)}`,this.viewer.debug.data.position.bp=o.commaNumber(t.bp),this.viewer.debug.data.position.element=t.element&&t.element.name,this.viewer.debug.data.position.score=t.score,this.viewer.debug.draw())})),this._legendSwatchClick(),this._legendSwatchMouseOver()}get viewer(){return this._viewer}get canvas(){return this.viewer.canvas}get mouse(){return this._mouse}_initializeMousemove(){const t=this.viewer;i.select(this.canvas.node("ui")).on("mousemove.cgv",(e=>{const s=this._createEvent(e);this._mouse=s,t.clear("ui"),this.events.trigger("mousemove",s)}))}_initializeClick(){i.select(this.canvas.node("ui")).on("click.cgv",(t=>{this.viewer.stopAnimate(),this.events.trigger("click",this._createEvent(t))}))}_initializeBookmarkShortcuts(){const t=/^(input|textarea|select|button)$/i;document.addEventListener("keypress",(e=>{if(t.test(e.target.tagName))return;if(e.target.isContentEditable)return;const s=this.viewer.bookmarkByShortcut(e.key);s&&(s.moveTo(),this.viewer.trigger("bookmarks-shortcut",s))}))}_createEvent(t){if(this.viewer.loading)return{};const e=this.viewer.layout.scale,s=t.offsetX,i=t.offsetY,r=e.x.invert(s),n=e.y.invert(i),o=this.viewer.layout.centerOffsetForPoint({x:s,y:i}),a=this.viewer.layout.slotForCenterOffset(o),h=this.canvas.bpForPoint({x:s,y:i}),{elementType:l,element:c}=this._getElement(a,h,o,s,i);let d;return d="plot"===l?c.scoreForPosition(h).toFixed(2):c&&c.score,{bp:h,centerOffset:o,slot:a,elementType:l,element:c,score:d,canvasX:s,canvasY:i,mapX:r,mapY:n,d3:t}}_getElement(t,e,s,i,r){let n,o;const a=this.viewer.legend;if(a.visible&&a.box.containsPt(i,r))for(let t=0,e=a.items().length;t<e;t++){const e=a.items()[t];e._textContainsPoint({x:i,y:r})&&(n="legendItem",o=e)}if(!n){const t=this.viewer.captions();for(let e=0,s=t.length;e<s;e++){const s=t[e];s.visible&&s.box.containsPt(i,r)&&(n="caption",o=s)}}if(!n&&t){const s=t.findFeaturesForBp(e);let i;for(let t=0,e=s.length;t<e;t++){const e=s[t];e.visible&&(!i||e.length<i.length)&&(i=e)}i&&i.visible?(n="feature",o=i):t._plot&&(n="plot",o=t._plot)}if(!n&&this.viewer.backbone.visible&&this.viewer.backbone.containsCenterOffset(s)){const t=this.viewer.backbone,s=this.viewer.sequence;s.hasMultipleContigs?(n="contig",o=s.contigForBp(e)):(n="backbone",o=t)}if(!n&&this.viewer.annotation.visible){const t=this.viewer.annotation._visibleLabels;for(let e=0,s=t.length;e<s;e++){const s=t[e];s.rect.containsPt(i,r)&&s.feature.visible&&(n="label",o=s)}}return{elementType:n,element:o}}_legendSwatchClick(){const t=this.viewer;this.events.on("click.swatch",(e=>{const s=t.legend;if(!s.visible)return;const i=s.visibleItems();for(let r=0,n=i.length;r<n;r++)if(i[r]._swatchContainsPoint({x:e.canvasX,y:e.canvasY})){const e=i[r];e.swatchSelected=!0;const n=t.colorPicker;n.visible||s.setColorPickerPosition(n),n.onChange=function(s){e.update({swatchColor:s.rgbaString}),t.drawFast()},n.onClose=function(){e.swatchSelected=!1,t.drawFull(),s.draw()},n.setColor(e._swatchColor.rgba),n.open(e);break}}))}_legendSwatchMouseOver(){const t=this.viewer;this.events.on("mousemove.swatch",(e=>{const s=t.legend;if(!s.visible)return;const i=s.visibleItems(),r=s.highlightedSwatchedItem;s.highlightedSwatchedItem=void 0;for(let t=0,r=i.length;t<r;t++)if(i[t]._swatchContainsPoint({x:e.canvasX,y:e.canvasY})){i[t].swatchHighlighted=!0,this.canvas.cursor="pointer",s.draw();break}r&&!s.highlightedSwatchedItem&&(this.canvas.cursor="auto",s.draw())}))}}class W{constructor(t,e={}){this._feature=t,this.name=e.name,this.bp=this.feature.mapStart-.5+this.feature.length/2,this.bpDefault=this.bp}get name(){return this._name}set name(t){void 0===t||""===t?(this.width=0,""!==this._name&&void 0!==this._name&&this.annotation.removeLabels(this),this._name=""):(""!==this._name&&void 0!==this._name||this.annotation.addLabel(this),this._name=t,this.width=this.font.width(this.viewer.canvas.context("map"),this._name))}get rect(){return this._rect}set rect(t){this._rect=t}get width(){return this._width}set width(t){this._width=t}get height(){return this.font.height}get lineAttachmentDefault(){return this.viewer.layout.clockPositionForBp(this.bp,!0)}get lineAttachment(){return this._lineAttachment||this.lineAttachmentDefault}set lineAttachment(t){this._lineAttachment=t}get font(){return this._font||this.annotation.font}set font(t){void 0===t?this._font=this.annotation.font:"Font"===t.toString()?this._font=t:this._font=new _(t)}get viewer(){return this.feature.viewer}get annotation(){return this.viewer.annotation}get feature(){return this._feature}get mapStart(){return this.feature.mapStart}get mapStop(){return this.feature.mapStop}hightlight(){this.feature.hightlight()}_highlight(){if(!this.rect)return;if(!this.annotation._visibleLabels.includes(this))return;const t=this.viewer.canvas,e=this.annotation.color||this.feature.color,s=t.context("ui"),i=this.rect;s.strokeStyle=e.rgbaString,s.lineWidth=1;const r=this.height/4;s.beginPath(),s.roundRect(i.x-2,i.y-2,i.width+4,i.height+4,[r]),s.stroke(),this.annotation.drawLabelLine(this,s,1.5)}}class V extends c{constructor(t,e={},s={}){super(t,e,s),this.viewer=t,this.type=o.defaultFor(e.type,""),this.source=o.defaultFor(e.source,""),this.tags=e.tags,this.favorite=o.defaultFor(e.favorite,!1),this.contig=e.contig,this.updateRanges(e.start,e.stop),this.strand=o.defaultFor(e.strand,1),this.score=o.defaultFor(e.score,1),this.codonStart=e.codonStart,this.geneticCode=e.geneticCode,this.label=new W(this,{name:e.name}),this._centerOffsetAdjustment=Number(e.centerOffsetAdjustment)||0,this._proportionOfThickness=Number(e.proportionOfThickness)||1,this.extractedFromSequence=o.defaultFor(e.extractedFromSequence,!1),this.legendItem=e.legend}toString(){return"Feature"}get type(){return this._type}set type(t){this._type=t}get tags(){return this._tags}set tags(t){this._tags=null==t||""===t?new n:new n(t)}get name(){return this.label&&this.label.name}set name(t){this.label?this.label.name=t:this.label=new W(this,{name:t})}get codonStart(){return this._codonStart||1}set codonStart(t){this._codonStart=t}get geneticCode(){return this._geneticCode}set geneticCode(t){this._geneticCode=t}get extractedFromSequence(){return this._extractedFromSequence}set extractedFromSequence(t){this._extractedFromSequence=t}get viewer(){return this._viewer}set viewer(t){this.viewer,this._viewer=t,t._features.push(this)}get strand(){return this._strand}set strand(t){"-"===t||-1===Number(t)?this._strand=-1:this._strand=1}get score(){return this._score}set score(t){Number.isNaN(Number(t))||(this._score=o.constrain(Number(t),0,1))}isDirect(){return 1===this.strand}isReverse(){return-1===this.strand}get range(){return this._range}set range(t){this._range=t}get mapRange(){return this.range.onMap}get start(){return this.range.start}set start(t){this.range.start=t}get stop(){return this.range.stop}set stop(t){this.range.stop=t}get mapStart(){return this.range.mapStart}set mapStart(t){this.range.mapStart=t}get mapStop(){return this.range.mapStop}set mapStop(t){this.range.mapStop=t}get length(){return this.range.length}get label(){return this._label}set label(t){this._label=t}get favorite(){return Boolean(this._favorite)}set favorite(t){this._favorite=t}get color(){return this.legendItem.swatchColor}get decoration(){return this.legendItem.decoration||"arc"}get directionalDecoration(){return"arrow"===this.decoration?1===this.strand?"clockwise-arrow":"counterclockwise-arrow":"score"===this.decoration?"arc":this.decoration}get legendItem(){return this._legendItem}set legendItem(t){this.legendItem&&void 0===t||(t&&"LegendItem"===t.toString()&&"LegendItem"!==t?this._legendItem=t:this._legendItem=this.viewer.legend.findLegendItemOrCreate(t))}get legend(){return this.legendItem}set legend(t){this.legendItem=t}get contig(){return this._contig}set contig(t){const e=this._contig;let s;if(void 0===t||t===this.sequence.mapContig)s=this.sequence.mapContig;else if(t&&"Contig"===t.toString()&&"Contig"!==t)s=t;else{const e=this.viewer.sequence.contigs(t);if(!e)return void console.error(`Feature '${this.name}' could not find contig '${t}'`);s=e}e!==s&&(s&&s._features.push(this),e&&D.removeFeatures(this)),this._contig=s,e&&(s.isMapContig?this.updateRanges(this.mapStart,this.mapStop):this.updateRanges(this.start,this.stop))}moveToContig(){if(this.contig.isMapContig){const t=this.sequence.contigForBp(this.start),e=this.start-t.lengthOffset,s=this.stop-t.lengthOffset;this.update({contig:t,start:e,stop:s})}}moveToMapContig(){this.contig.isMapContig||(this.contig=void 0)}update(t){this.viewer.updateFeatures(this,t)}updateRanges(t,e){t=Number(t),e=Number(e);const s=this.contig||this.sequence.mapContig;this.range=new M(s,t,e)}draw(t,e,s,i,r={}){if(this.visible&&this.mapRange.overlapsMapRange(i)){const n=this.canvas;let o=this.mapStart,a=this.mapStop;const h=i.containsMapBp(o),l=i.containsMapBp(a),c=r.color||this.color,d=r.showShading,g=this.legendItem.minArcLength;h||(o=Math.max(1,i.start-100)),l||(a=Math.min(this.sequence.length,i.stop+100));const u=h&&l&&this.viewer.zoomFactor>1e3&&this.range.overHalfMapLength(),p=h&&l&&this.range.isWrapped()&&"linear"===this.viewer.format;if(u||p){const r=Math.max(i.start-100,1),h=Math.min(i.stop+100,this.sequence.length);n.drawElement(t,r,a,this.adjustedCenterOffset(e,s),c.rgbaString,this.adjustedWidth(s),this.directionalDecoration,d,g),n.drawElement(t,o,h,this.adjustedCenterOffset(e,s),c.rgbaString,this.adjustedWidth(s),this.directionalDecoration,d,g)}else n.drawElement(t,o,a,this.adjustedCenterOffset(e,s),c.rgbaString,this.adjustedWidth(s),this.directionalDecoration,d,g)}}highlight(t){if(!this.visible)return;this.canvas.clear("ui"),this.viewer.annotation.visible&&this.label._highlight();const e=this.color.copy();e.highlight(),t&&t.features().includes(this)?this.draw("ui",t.centerOffset,t.thickness,t.visibleRange,{color:e}):this.viewer.slots().each(((t,s)=>{s.features().includes(this)&&this.draw("ui",s.centerOffset,s.thickness,s.visibleRange,{color:e})}))}adjustedCenterOffset(t,e){return"score"===this.legendItem.decoration?t-e/2+this.score*e/2:0===this._centerOffsetAdjustment&&1===this._proportionOfThickness?t:0===this._centerOffsetAdjustment?t-e/2+this._proportionOfThickness*e/2:t}adjustedWidth(t){return"score"===this.legendItem.decoration?this.score*t:this._proportionOfThickness*t}tracks(t){const e=new n;return this.viewer.tracks().each(((t,s)=>{"feature"===s.type&&("source"===s.dataMethod&&s.dataKeys.includes(this.source)||"type"===s.dataMethod&&s.dataKeys.includes(this.type)||"tag"===s.dataMethod&&s.dataKeys.some((t=>this.tags.includes(t)))||"sequence"===s.dataMethod&&this.extractedFromSequence&&s.features().includes(this))&&e.push(s)})),e.get(t)}slots(t){const e=new n;return this.tracks().each(((t,s)=>{s.slots().each(((t,s)=>{s.features().includes(this)&&e.push(s)}))})),e.get(t)}remove(){this.viewer.removeFeatures(this)}moveTo(t,e){const s=Math.ceil(.05*this.length),i=this.sequence.subtractBp(this.mapStart,s),r=this.sequence.addBp(this.mapStop,s);this.viewer.moveTo(i,r,{duration:t,ease:e})}refresh(){this.viewer.tracks().each(((t,e)=>{(e.features().includes(this)||"source"===e.dataMethod&&e.dataKeys.includes(this.source))&&e.refresh()}))}translate(t){const e=t||this.geneticCode||this.viewer.geneticCode,s=this.viewer.codonTables.byID(e);return s&&s.translate(this.seq,this.start_codon)}get seq(){return this.contig.forRange(this.range,this.isReverse())}toJSON(t={}){const e={name:this.name,type:this.type,start:this.start,stop:this.stop,strand:this.strand,source:this.source,legend:this.legend.name};return this.codonStart&&1!=this.codonStart&&(e.codonStart=this.codonStart),this.geneticCode&&this.geneticCode!=this.viewer.geneticCode&&(e.geneticCode=this.geneticCode),this.sequence.hasMultipleContigs&&!this.contig.isMapContig&&(e.contig=this.contig.name),void 0!==this.tags&&(e.tags=1===this.tags.length?this.tags[0]:[...this.tags]),this.visible&&!t.includeDefaults||(e.visible=this.visible),(void 0!==this.score&&1!==this.score||t.includeDefaults)&&(e.score=this.score),(this.favorite||t.includeDefaults)&&(e.favorite=this.favorite),Object.keys(this.meta).length>0&&(e.meta=this.meta),e}}class H extends c{constructor(t,e={},s={}){super(t,e,s),this._viewer=t,this.showMetaData=o.defaultFor(e.showMetaData,!0),this.popoverBox=t._wrapper.append("div").attr("class","cgv-highlighter-popover-box").style("visibility","hidden"),this._feature=new K("feature",e.feature),this._plot=new K("plot",e.plot),this._contig=new K("contig",e.contig),this._backbone=new K("backbone",e.contig),this.initializeEvents(),this._offsetLeft=8,this._offsetTop=-18}get viewer(){return this._viewer}get feature(){return this._feature}get plot(){return this._plot}get contig(){return this._contig}get backbone(){return this._backbone}position(t){return{x:t.canvasX+this._offsetLeft,y:t.canvasY+this._offsetTop}}initializeEvents(){this.viewer.off(".cgv-highlighter"),this.viewer.on("mousemove.cgv-highlighter",(t=>{this.mouseOver(t)}))}mouseOver(t){const e=t.elementType;if(e&&this[e])if(this[e].highlighting&&this[`highlight${o.capitalize(e)}`](t),this[e].popovers&&this.visible){const s=this.position(t),i=this[e].popoverContents&&this[e].popoverContents(t)||this[`${e}PopoverContentsDefault`](t);this.showPopoverBox({position:s,html:i})}else this.hidePopoverBox();else this.hidePopoverBox()}getTrackDiv(t){let e="";if(t.slot){const s=t.slot.track;let i="";"feature"===s.type&&"none"!==s.separateFeaturesBy&&(i=t.slot.isDirect()?"(+)":"(-)"),e=`<div class='track-data'>Track: ${s.name} ${i}</div>`}return e}getPositionDiv(t){let e=`<div class='track-data'>Map: ${o.commaNumber(t.bp)} bp</div>`;if("contig"===t.elementType){const s=t.element;e=`<div class='track-data'>Contig: ${o.commaNumber(t.bp-s.lengthOffset)} bp</div>`+e}return e}featurePopoverContentsDefault(t){const e=t.element,s=Object.keys(e.meta);let i="";return this.showMetaData&&s.length>0&&(i=s.map((t=>`<div class='meta-data'><span class='meta-data-key'>${t}</span>: <span class='meta-data-value'>${e.meta[t]}</span></div>`)).join(""),i=`<div class='meta-data-container'>${i}</div>`),`\n      <div style='margin: 0 5px; font-size: 14px'>\n        <div>${e.type}: ${e.name}<div>\n        <div class='track-data'>Length: ${o.commaNumber(e.length)} bp</div>\n        ${i}\n        ${this.getTrackDiv(t)}\n      </div>\n    `}plotPopoverContentsDefault(t){return`\n      <div style='margin: 0 5px; font-size: 14px'>\n        <div>Score: ${t.element.scoreForPosition(t.bp).toFixed(2)}</div>\n        ${this.getTrackDiv(t)}\n      </div>\n    `}backbonePopoverContentsDefault(t){return`\n      <div style='margin: 0 5px; font-size: 14px'>\n        <div>Backbone: ${o.commaNumber(this.sequence.length)} bp</div>\n        ${this.getPositionDiv(t)}\n      </div>\n    `}contigPopoverContentsDefault(t){const e=t.element,s=o.commaNumber(e.length);return`\n      <div style='margin: 0 5px; font-size: 14px'>\n        <div>Contig ${e.index}/${this.sequence.contigs().length} [${s} bp]: ${e.name}</div>\n        ${this.getPositionDiv(t)}\n      </div>\n    `}highlightFeature(t){t.element.highlight(t.slot)}highlightPlot(t){const e=this.viewer,s=t.element,i=s.scoreForPosition(t.bp);if(i){const r=o.indexOfValue(s.positions,t.bp,!1),n=s.positions[r],a=s.positions[r+1]||e.sequence.length,h=(s.baseline-s.axisMin)/(s.axisMax-s.axisMin),l=t.slot.centerOffset-t.slot.thickness/2+t.slot.thickness*h,c=l+(i-s.baseline)/(s.axisMax-s.axisMin)*t.slot.thickness,d=Math.abs(l-c),g=Math.min(l,c)+d/2,u=i>=s.baseline?s.colorPositive.copy():s.colorNegative.copy();u.highlight(),e.canvas.drawElement("ui",n,a,g,u.rgbaString,d)}}highlightBackbone(t){}highlightContig(t){}hidePopoverBox(){this.popoverBox.style("visibility","hidden")}showPopoverBox(t={}){t.html&&this.popoverBox.html(t.html),t.position&&this.popoverBox.style("left",`${t.position.x}px`).style("top",`${t.position.y}px`),this.popoverBox.style("visibility","visible")}toJSON(){return{visible:this.visible}}}class K{constructor(t,e={}){this.type=t,this.highlighting=o.defaultFor(e.highlighting,!0),this.popovers=o.defaultFor(e.popovers,!0),this.popoverContents=e.popoverContents}get type(){return this._type}set type(t){this._type=t}get highlighting(){return this._highlighting}set highlighting(t){this._highlighting=t}get popover(){return this._popover}set popover(t){this._popover=t}get popoverContents(){return this._popoverContents}set popoverContents(t){this._popoverContents=t}}class J{constructor(t,e={}){this.viewer=t,e.format&&(this.format=e.format),this._backgroundColor=new y(o.defaultFor(e.backgroundColor,"white")),this._geneticCode=o.defaultFor(e.geneticCode,11),this.arrowHeadLength=o.defaultFor(e.arrowHeadLength,.3),this._showShading=o.defaultFor(e.showShading,!0),this.initialMapThicknessProportion=o.defaultFor(e.initialMapThicknessProportion,.1),this.maxMapThicknessProportion=o.defaultFor(e.maxMapThicknessProportion,.5),this.viewer.trigger("settings-update",{attributes:this.toJSON({includeDefaults:!0})})}toString(){return"Settings"}get format(){return this.viewer.format}set format(t){this.viewer.format=t}get geneticCode(){return this._geneticCode||11}set geneticCode(t){this._geneticCode=t}get backgroundColor(){return this._backgroundColor}set backgroundColor(t){void 0===t?this._backgroundColor=new y("white"):"Color"===t.toString()?this._backgroundColor=t:this._backgroundColor=new y(t),this.viewer.fillBackground()}set arrowHeadLength(t){this._arrowHeadLength=o.constrain(Number(t),0,1)}get arrowHeadLength(){return this._arrowHeadLength}get showShading(){return this._showShading}set showShading(t){this._showShading=t,this.viewer.drawFull()}get initialMapThicknessProportion(){return this.viewer.layout.initialMapThicknessProportion}set initialMapThicknessProportion(t){this.viewer.layout.initialMapThicknessProportion=t}get maxMapThicknessProportion(){return this.viewer.layout.maxMapThicknessProportion}set maxMapThicknessProportion(t){this.viewer.layout.maxMapThicknessProportion=t}update(t){this.viewer.updateRecords(this,t,{recordClass:"Settings",validKeys:["format","backgroundColor","showShading","arrowHeadLength","geneticCode","initialMapThicknessProportion","maxMapThicknessProportion"]}),this.viewer.trigger("settings-update",{attributes:t})}toJSON(){return{format:this.format,geneticCode:this.geneticCode,backgroundColor:this.backgroundColor.rgbaString,showShading:this.showShading,arrowHeadLength:this.arrowHeadLength,initialMapThicknessProportion:this.initialMapThicknessProportion,maxMapThicknessProportion:this.maxMapThicknessProportion}}}class Y extends c{constructor(t,e={},s={}){super(t,e,s),this.tickCount=o.defaultFor(e.tickCount,10),this.tickWidth=o.defaultFor(e.tickWidth,1),this.tickLength=o.defaultFor(e.tickLength,4),this.rulerPadding=o.defaultFor(e.rulerPadding,10),this.spacing=o.defaultFor(e.spacing,2),this.font=o.defaultFor(e.font,"sans-serif, plain, 10"),this.color=new y(o.defaultFor(e.color,"black")),this.lineCap="round",this.viewer.trigger("ruler-update",{attributes:this.toJSON({includeDefaults:!0})})}toString(){return"Ruler"}get font(){return this._font}set font(t){"Font"===t.toString()?this._font=t:this._font=new _(t)}get color(){return this._color}set color(t){"Color"===t.toString()?this._color=t:this._color.setColor(t)}get tickCount(){return this._tickCount}set tickCount(t){this._tickCount=t}get tickWidth(){return this._tickWidth}set tickWidth(t){this._tickWidth=t}get tickLength(){return this._tickLength}set tickLength(t){this._tickLength=t}get rulerPadding(){return this._rulerPadding}set rulerPadding(t){this._rulerPadding=t}get spacing(){return this._spacing}set spacing(t){this._spacing=t}get majorTicks(){return this._majorTicks}get majorTickStep(){return this._majorTickStep}get minorTicks(){return this._minorTicks}get minorTickStep(){return this._minorTickStep}get tickFormater(){return this._tickFormater}_createTickFormatter(t){let e,s;return t<=50?e=i.formatPrefix(",.0",1):t<=5e4?(s=i.precisionPrefix(t,1e3),e=i.formatPrefix(`.${s}`,1e3)):t<=5e7&&(s=i.precisionPrefix(t,1e6),e=i.formatPrefix(`.${s}`,1e6)),e}_updateTicks(t,e){const s=this.sequence.length;let r=0,n=0,o=[],a=0,h=[],l=0,c=this.tickCount;if(this.viewer.zoomFactor<5)r=1,n=s;else{c=Math.ceil(c/2);const s=this.canvas.visibleRangeForCenterOffset(t),i=this.canvas.visibleRangeForCenterOffset(e);if(s&&i){const t=s.mergeWithRange(i);r=t.start,n=t.stop}else s?(r=s.start,n=s.stop):i&&(r=i.start,n=i.stop)}if(n>r)o=o.concat(i.ticks(r,n,c)),a=i.tickStep(r,n,c);else if(n<r){const t=(s-r)/this.sequence.lengthOfRange(r,n),e=Math.round(c*t),h=2*Math.round(c*(1-t));if(e>0){o=o.concat(i.ticks(r,s,e)),a=Math.round(i.tickStep(r,s,e));for(let t=1;t<=h;t++)a*t<r&&o.push(a*t)}else o=o.concat(i.ticks(1,n,c)),a=Math.round(i.tickStep(1,n,c))}if(h=[],l=a%5?a%2?0:a/2:a/5,l)if(this.sequence.lengthOfRange(o[o.length-1],o[0])<=3*a?(r=0,n=s):(r=o[0]-a,n=o[o.length-1]+a),r<n)for(let t=r;t<=n;t+=l)t%a&&h.push(t);else{for(let t=r;t<=s;t+=l)t%a&&h.push(t);for(let t=0;t<=n;t+=l)t%a&&h.push(t)}this._majorTicks=o,this._majorTickStep=a,this._minorTicks=h,this._minorTickStep=l,this._tickFormater=this._createTickFormatter(a)}draw(t,e){this.visible&&(t-=this.spacing,e+=this.spacing,this._updateTicks(t,e),this.drawForCenterOffset(t,"inner"),this.drawForCenterOffset(e,"outer",!1))}drawForCenterOffset(t,e="inner",s=!0){const i=this.canvas.context("map"),r="inner"===e?-this.tickLength:this.tickLength;i.fillStyle=this.color.rgbaString,i.font=this.font.css,i.textAlign="left",i.textBaseline="alphabetic",this.canvas.radiantLine("map",1,t,r,2*this.tickWidth,this.color.rgbaString,this.lineCap),this.majorTicks.forEach((i=>{if(this.canvas.radiantLine("map",i,t,r,this.tickWidth,this.color.rgbaString,this.lineCap),s){const s=this.tickFormater(i);this.drawLabel(i,s,t,e)}}));for(const e of this.minorTicks){if(e>this.sequence.length)break;this.canvas.radiantLine("map",e,t,r/2,this.tickWidth,this.color.rgbaString,this.lineCap)}}drawLabel(t,e,s,i="inner"){const r=this.canvas.context("map");e=e.replace(/([kM])?$/," $1bp");const n=this.canvas.pointForBp(t,s-this.rulerPadding),a=this.layout.clockPositionForBp(t),h=this.font.width(r,e),l=o.rectOriginForAttachementPoint(n,a,h,this.font.height);r.fillText(e,l.x,l.y+this.font.height)}invertColors(){this.update({color:this.color.invert().rgbaString})}update(t){this.viewer.updateRecords(this,t,{recordClass:"Ruler",validKeys:["color","font","visible"]}),this.viewer.trigger("ruler-update",{attributes:t})}toJSON(t={}){const e={font:this.font.string,color:this.color.rgbaString};return this.visible&&!t.includeDefaults||(e.visible=this.visible),e}}class U extends c{constructor(t,e={},s={}){super(t.viewer,e,s),this.legend=t,this.name=o.defaultFor(e.name,""),this.font=e.font,this.fontColor=e.fontColor,this.minArcLength=e.minArcLength,this._drawSwatch=o.defaultFor(e.drawSwatch,!0),this._swatchColor=new y(o.defaultFor(e.swatchColor,"black")),this._decoration=o.defaultFor(e.decoration,"arc"),this._initializationComplete=!0,this.refresh()}toString(){return"LegendItem"}get legend(){return this._legend}set legend(t){t._items.push(this),this._legend=t}get visible(){return this._visible}set visible(t){this._visible=t,this.refresh()}get name(){return this._name}set name(t){const e=`${t}`,s=this.legend._items.map((t=>t.name));this._name=o.uniqueName(e,s),this._name!==e&&console.log(`LegendItem with name '${e}' already exists, using name '${this._name}' instead.`),this.refresh()}get textAlignment(){return this.legend.textAlignment}get width(){return this._width}get height(){return this.font.height}get font(){return this._font||this.legend.defaultFont}set font(t){void 0===t?this._font=void 0:"Font"===t.toString()?this._font=t:this._font=new _(t),this.refresh()}get usingDefaultFont(){return this.font===this.legend.defaultFont}get fontColor(){return this._fontColor||this.legend.defaultFontColor}set fontColor(t){void 0===t?this._fontColor=void 0:"Color"===t.toString()?this._fontColor=t:this._fontColor=new y(t),this.refresh()}get usingDefaultFontColor(){return this.fontColor===this.legend.defaultFontColor}get minArcLength(){return void 0===this._minArcLength?this.legend.defaultMinArcLength:this._minArcLength}set minArcLength(t){this._minArcLength=void 0===t?void 0:o.constrain(Number(t),0,2)}get usingDefaultMinArcLength(){return void 0===this._minArcLength}get drawSwatch(){return this._drawSwatch}set drawSwatch(t){this._drawSwatch=t,this.refresh()}get swatchWidth(){return this.height}get swatchColor(){return this._swatchColor}set swatchColor(t){"Color"===t.toString()?this._swatchColor=t:this._swatchColor.setColor(t),this.refresh()}get decoration(){return this._decoration||"arc"}set decoration(t){o.validate(t,["arc","arrow","none","score"])&&(this._decoration=t)}get color(){return this.swatchColor}set color(t){this.swatchColor=t}get swatchSelected(){return this.legend.selectedSwatchedItem===this}set swatchSelected(t){t?this.legend.selectedSwatchedItem=this:this.legend.selectedSwatchedItem===this&&(this.legend.selectedSwatchedItem=void 0)}get swatchHighlighted(){return this.legend.highlightedSwatchedItem===this}set swatchHighlighted(t){t?this.legend.highlightedSwatchedItem=this:this.legend.highlightedSwatchedItem===this&&(this.legend.highlightedSwatchedItem=void 0)}refresh(){this._initializationComplete&&this.legend.refresh()}textX(){const t=this.box,e=this.legend;return"left"===this.textAlignment?this.drawSwatch?this.swatchX()+this.swatchWidth+e.swatchPadding:t.leftPadded:"right"===this.textAlignment?this.drawSwatch?this.swatchX()-e.swatchPadding:t.rightPadded:void 0}textY(){let t=this.legend.box.topPadded;const e=this.legend.visibleItems();for(let s=0,i=e.length;s<i;s++){const i=e[s];if(i===this)break;t+=1.5*i.height}return t}swatchX(){const t=this.legend.box;return"left"===this.textAlignment?t.leftPadded:"right"===this.textAlignment?t.rightPadded-this.swatchWidth:void 0}swatchY(){return this.textY()}_swatchContainsPoint(t){const e=this.swatchX(),s=this.swatchY();if(t.x>=e&&t.x<=e+this.height&&t.y>=s&&t.y<=s+this.height)return!0}_textContainsPoint(t){const e=this.textX(),s=this.textY();if("right"===this.textAlignment){if(t.x<=e&&t.x>=e-this.width&&t.y>=s&&t.y<=s+this.height)return!0}else if(t.x>=e&&t.x<=e+this.width&&t.y>=s&&t.y<=s+this.height)return!0}highlight(t=this.fontColor){if(!this.visible||!this.legend.visible)return;const e=this.canvas.context("ui");let s=this.textX();"right"===this.textAlignment&&(s-=this.width),e.lineWidth=1,e.strokeStyle=t.rgbaString;const i=this.height/4;e.beginPath(),e.roundRect(s-2,this.textY()-2,this.width+4,this.height+4,[i]),e.stroke()}invertColors(){const t={swatchColor:this.swatchColor.invert().rgbaString};this.usingDefaultFontColor||(t.fontColor=this.fontColor.invert().rgbaString),this.update(t)}remove(){this.legend.removeItems(this)}move(t){const e=this.legend.items().indexOf(this);this.legend.moveItem(e,t)}update(t){this.legend.updateItems(this,t)}features(t){return this.viewer._features.filter((t=>t.legendItem===this)).get(t)}plots(t){return this.viewer._plots.filter((t=>t.legendItem.includes(this))).get(t)}toJSON(t={}){const e={name:this.name,swatchColor:this.swatchColor.rgbaString,decoration:this.decoration};return this.visible&&!t.includeDefaults||(e.visible=this.visible),this.usingDefaultFontColor&&!t.includeDefaults||(e.fontColor=this.fontColor.rgbaString),this.usingDefaultFont&&!t.includeDefaults||(e.font=this.font.string),this.usingDefaultMinArcLength&&!t.includeDefaults||(e.minArcLength=this.minArcLength),Object.keys(this.meta).length>0&&(e.meta=this.meta),e}}class Q extends c{constructor(t,e={},s={}){super(t,e,s),this._items=new n,this.backgroundColor=e.backgroundColor,this.defaultFontColor=o.defaultFor(e.defaultFontColor,"black"),this.textAlignment=o.defaultFor(e.textAlignment,"left"),this.box=new C(t,{position:o.defaultFor(e.position,"top-right"),anchor:o.defaultFor(e.anchor,"middle-center")}),this.defaultFont=o.defaultFor(e.defaultFont,"sans-serif, plain, 14"),this.defaultMinArcLength=o.defaultFor(e.defaultMinArcLength,1),this.viewer.trigger("legend-update",{attributes:this.toJSON({includeDefaults:!0})}),e.items&&this.addItems(e.items),this.refresh()}toString(){return"Legend"}get visible(){return this._visible}set visible(t){this._visible=t,this.viewer.refreshCanvasLayer()}get ctx(){const t="map"===this.on?"foreground":"canvas";return this.canvas.context(t)}get position(){return this.box.position}set position(t){this.clear(),this.box.position=t,this.viewer.refreshCanvasLayer()}get on(){return this.box.on}set on(t){this.clear(),this.box.on=t,this.refresh()}get anchor(){return this.box.anchor}set anchor(t){this.clear(),this.box.anchor=t,this.refresh()}get backgroundColor(){return this._backgroundColor}set backgroundColor(t){void 0===t?this._backgroundColor=this.viewer.settings.backgroundColor:"Color"===t.toString()?this._backgroundColor=t:this._backgroundColor=new y(t),this.refresh()}get defaultFont(){return this._defaultFont}set defaultFont(t){"Font"===t.toString()?this._defaultFont=t:this._defaultFont=new _(t);for(let t=0,e=this._items.length;t<e;t++){const e=this._items[t];e.usingDefaultFont&&e.update({font:void 0})}this.refresh()}get defaultFontColor(){return this._defaultFontColor}set defaultFontColor(t){"Color"===t.toString()?this._defaultFontColor=t:this._defaultFontColor=new y(t);for(let t=0,e=this._items.length;t<e;t++){const e=this._items[t];e.usingDefaultFontColor&&e.update({fontColor:void 0})}this.refresh()}get textAlignment(){return this._textAlignment}set textAlignment(t){o.validate(t,["left","right"])&&(this._textAlignment=t),this.refresh()}get defaultMinArcLength(){return this._defaultMinArcLength}set defaultMinArcLength(t){this._defaultMinArcLength=o.constrain(Number(t),0,2);for(let t=0,e=this._items.length;t<e;t++){const e=this._items[t];e.usingDefaultMinArcLength&&e.update({minArcLength:void 0})}}get selectedSwatchedItem(){return this._selectedSwatchedItem}set selectedSwatchedItem(t){this._selectedSwatchedItem=t}get highlightedSwatchedItem(){return this._highlightedSwatchedItem}set highlightedSwatchedItem(t){this._highlightedSwatchedItem=t}update(t){this.viewer.updateRecords(this,t,{recordClass:"Legend",validKeys:["on","position","anchor","defaultFont","defaultFontColor","defaultMinArcLength","textAlignment","backgroundColor","visible"]}),this.viewer.trigger("legend-update",{attributes:t})}items(t){return this._items.get(t)}visibleItems(t){return this._items.filter((t=>t.visible)).get(t)}addItems(t=[]){const e=(t=n.arrayerize(t)).map((t=>new U(this,t)));return this.viewer.trigger("legendItems-add",e),e}removeItems(t){t=n.arrayerize(t),this._items=this._items.filter((e=>!t.includes(e))),this.viewer.clear("canvas"),this.viewer.refreshCanvasLayer(),t.forEach((t=>t.deleteFromObjects())),this.viewer.trigger("legendItems-remove",t)}updateItems(t,e){const{records:s,updates:i}=this.viewer.updateRecords(t,e,{recordClass:"LegendItem",validKeys:["name","font","fontColor","drawSwatch","swatchColor","decoration","minArcLength","visible"]});this.viewer.trigger("legendItems-update",{items:s,attributes:e,updates:i})}moveItem(t,e){this._items.move(t,e),this.viewer.trigger("legendItems-moved",{oldIndex:t,newIndex:e}),this.refresh()}moveTo(t){this.position.moveTo(t)}refresh(){const t=this.box;if(!t)return;this.clear();let e=0,s=0;const r=this.visibleItems();for(let t=0,i=r.length;t<i;t++){const n=r[t].height;e+=n,t<i-1&&(e+=n/2),n>s&&(s=n)}t.padding=s/2,e+=2*t.padding;const n=r.map((t=>t.font.css)),o=r.map((t=>t.name)),a=_.calculateWidths(this.ctx,n,o);for(let e=0,s=a.length;e<s;e++){const s=r[e];s.drawSwatch&&(a[e]+=s.height+t.padding/2),s._width=a[e]}const h=i.max(a)+2*t.padding;t.resize(h,e),this.draw()}setColorPickerPosition(t){const e=this.box.x,s=this.box.y;let i={x:e-t.width-5,y:s+5};const r=this.box.width;this.box.height,e<t.width&&(i.x=e+r+5),this.viewer.height-s<t.height&&(i.y=this.box.bottom-t.height-5),t.setPosition(i)}get swatchPadding(){return this.box.padding/2}fillBackground(){const t=this.box;this.ctx.fillStyle=this.backgroundColor.rgbaString,this.clear(),this.ctx.fillRect(t.x,t.y,t.width,t.height)}invertColors(){this.update({backgroundColor:this.backgroundColor.invert().rgbaString,defaultFontColor:this.defaultFontColor.invert().rgbaString}),this.items().each(((t,e)=>e.invertColors()))}findLegendItemByName(t){if("string"==typeof t)return this._items.find((e=>t.toLowerCase()===e.name.toLowerCase()))}findLegendItemOrCreate(t="Unknown",e=null,s="arc"){let i=this.findLegendItemByName(t);if(!i){const e=this.viewer.objects(t);e&&"LegendItem"===e.toString()&&(i=e)}if(!i){if(!e){const t=this._items.map((t=>t.swatchColor));e=y.getColor(t).rgbaString}i=this.addItems({name:t,swatchColor:e,decoration:s})[0]}return i}uniqueLegendsItemsFor(t={}){const e=new Set(t.features||[]),s=new Set(t.plots||[]),i=new Set;e.forEach((t=>{i.add(t.legend)})),s.forEach((t=>{i.add(t.legendItemPositive),i.add(t.legendItemNegative)}));const r=new Set;this.viewer.features().each(((t,s)=>{e.has(s)||r.add(s)}));const n=new Set;return this.viewer.plots().each(((t,e)=>{s.has(e)||n.add(e)})),r.forEach((t=>{i.has(t.legend)&&i.delete(t.legend)})),n.forEach((t=>{i.has(t.legendItemPositive)&&i.delete(t.legendItemPositive),i.has(t.legendItemNegative)&&i.delete(t.legendItemNegative)})),Array.from(i)}clear(){this.box.clear(this.ctx)}draw(){if(!this.visible)return;const t=this.ctx;let e;this.box.refresh(),this.fillBackground(),t.lineWidth=1,t.textBaseline="alphabetic";for(let s=0,i=this._items.length;s<i;s++){const i=this._items[s];if(!i.visible)continue;const r=i.textY(),n=i.drawSwatch,o=i.swatchWidth;if(t.font=i.font.css,t.textAlign=i.textAlignment,n){if(i.swatchSelected?t.strokeStyle="black":i.swatchHighlighted&&(t.strokeStyle="grey"),e=i.swatchX(),i.swatchSelected||i.swatchHighlighted){const s=2;t.strokeRect(e-s,r-s,o+2*s,o+2*s)}t.fillStyle=i.swatchColor.rgbaString,t.fillRect(e,r,o,o)}t.fillStyle=i.fontColor.rgbaString,t.fillText(i.name,i.textX(),r+i.height-1)}}toJSON(t={}){const e={name:this.name,position:this.position.toJSON(t),textAlignment:this.textAlignment,defaultFont:this.defaultFont.string,defaultFontColor:this.defaultFontColor.rgbaString,defaultMinArcLength:this.defaultMinArcLength,backgroundColor:this.backgroundColor.rgbaString,items:[]};return this.position.onMap&&(e.anchor=this.anchor.toJSON(t)),this.visible&&!t.includeDefaults||(e.visible=this.visible),this.items().each(((s,i)=>{e.items.push(i.toJSON(t))})),e}}class X{constructor(t){this._viewer=t}get viewer(){return this._viewer}get allowDragAndDrop(){return this._allowDragAndDrop}set allowDragAndDrop(t){this._allowDragAndDrop=t,t&&this.io.initializeDragAndDrop()}formatDate(t){return i.timeFormat("%Y-%m-%d %H:%M:%S")(t)}toJSON(t={}){const e=this.viewer,s=e._jsonInfo||{},i={cgview:{version:r,created:s.created||this.formatDate(new Date),updated:this.formatDate(new Date),id:e.id,name:e.name,format:e.format,settings:e.settings.toJSON(t),backbone:e.backbone.toJSON(t),ruler:e.ruler.toJSON(t),annotation:e.annotation.toJSON(t),dividers:e.dividers.toJSON(t),highlighter:e.highlighter.toJSON(t),captions:[],legend:e.legend.toJSON(t),sequence:e.sequence.toJSON(t),features:[],plots:[],bookmarks:[],tracks:[]}};return e.captions().each(((e,s)=>{i.cgview.captions.push(s.toJSON(t))})),e.features().each(((e,s)=>{(!s.extractedFromSequence||s.tracks().filter((t=>"sequence"!==t.dataMethod)).length>0)&&i.cgview.features.push(s.toJSON(t))})),e.plots().each(((e,s)=>{(!s.extractedFromSequence||s.tracks().filter((t=>"sequence"!==t.dataMethod)).length>0)&&i.cgview.plots.push(s.toJSON(t))})),e.bookmarks().each(((e,s)=>{i.cgview.bookmarks.push(s.toJSON(t))})),e.tracks().each(((e,s)=>{i.cgview.tracks.push(s.toJSON(t))})),e.meta&&Object.keys(e.meta).length>0&&(i.cgview.meta=e.meta),i}loadJSON(t){try{this._loadJSON(t)}catch(t){const e=`Loading Error: ${t}`;console.log(e);const s=this.viewer.canvas;s.clear("debug");s.context("debug").fillText(e,5,15)}}_loadJSON(t){let e=t;if("string"==typeof t&&(e=JSON.parse(t)),console.log(`Loading map JSON version: '${e?.cgview?.version}'`),e=this.updateJSON(e),e=e&&e.cgview,!e)throw new Error("No 'cgview' property found in JSON.");const s=this._viewer;s.clear("all"),s._objects={},s.trigger("cgv-json-load",e),s.update({id:e.id,name:e.name}),s._jsonInfo={version:e.version,created:e.created},s._features=new n,s._tracks=new n,s._plots=new n,s._captions=new n,s._bookmarks=new n,s._loading=!0,s._sequence=new j(s,e.sequence),s._settings=new J(s,e.settings),s._ruler=new Y(s,e.ruler),s._backbone=new S(s,e.backbone),s._annotation=new k(s,e.annotation),s._dividers=new z(s,e.dividers),s._highlighter=new H(s,e.highlighter),e.bookmarks&&s.addBookmarks(e.bookmarks),e.captions&&s.addCaptions(e.captions),s._legend=new Q(s,e.legend),e.features&&s.addFeatures(e.features),e.plots&&s.addPlots(e.plots),e.tracks&&s.addTracks(e.tracks),e.meta&&(s.meta=e.meta),s.annotation.refresh(),s._loading=!1,s.update({dataHasChanged:!1}),s.format=o.defaultFor(e.format,"circular"),s.zoomTo(0,1,{duration:0})}updateJSON(t){if(!(t=t&&t.cgview))throw new Error("No 'cgview' property found in JSON.");function e(t){const e=t.match(/^(\d+)\.(\d+)/);if(e)return{string:t,major:Number(e[1]),minor:Number(e[2])};throw new Error(`Can not read cgview version '${t}'`)}const s=e(t.version),i=e(r);switch(!0){case"0.1"===s.string:return t=this._updateVersion_0_1(t),console.log(`Update JSON version: ${s.string} -> ${t.version}`),this.updateJSON({cgview:t});case"0.2"===s.string:return t=this._updateVersion_0_2(t),console.log(`Update JSON version: ${s.string} -> ${t.version}`),this.updateJSON({cgview:t});case"1.0.0"===s.string:return t=this._updateVersion_1_0(t),console.log(`Update JSON version: ${s.string} -> ${t.version}`),this.updateJSON({cgview:t});case s.major<=1&&s.minor<=4:return t=this._updateVersion_1_4(t),console.log(`Update JSON version: ${s.string} -> ${t.version}`),this.updateJSON({cgview:t});case s.string===i.string:console.log(`JSON at latest version: ${s.string}`);break;case s.major<=i.major&&s.minor<=i.minor:console.log(`Update JSON to latest version: ${s.string} -> 1.6.0`),t.version=r;break;default:throw new Error(`Unknown cgview version '${s.string}'`)}return{cgview:t}}_updateVersion_1_4(t){return t.legend.defaultMinArcLength=t.settings.minArcLength,t.version="1.5.0",t}_updateVersion_1_0(t){const e=t.sequence&&t.sequence.contigs;if(e)for(const t of e)t.name=t.id;return t.version="1.1.0",t}_updateVersion_0_2(t){const e=t.layout&&t.layout.tracks||t.tracks;for(const t of e)"separated"===t.readingFrame?t.separateFeaturesBy="readingFrame":"separated"===t.strand?t.separateFeaturesBy="strand":t.separateFeaturesBy="none",t.dataType=t.contents&&t.contents.type||t.dataType,t.dataMethod=t.contents&&t.contents.from||t.dataMethod,t.dataKeys=t.contents&&t.contents.extract||t.dataKeys;return t.tracks=e,t.version="1.1.0",t}_updateVersion_0_1(t){const e={"lower-left":"bottom-left","lower-center":"bottom-center","lower-right":"bottom-right","upper-left":"top-left","upper-center":"top-center","upper-right":"top-right"},s=t.captions;if(s)for(const t of s)t.position=e[t.position]||t.position,t.font=t.items[0].font||t.font,t.fontColor=t.items[0].fontColor||t.fontColor,t.name=t.items.map((t=>t.name)).join("\n");const i=t.legend;i.position=e[i.position]||i.position,i.defaultFont=i.font;const r=t.layout.tracks||[];for(const t of r)"separated"===t.readingFrame?t.separateFeaturesBy="readingFrame":"separated"===t.strand?t.separateFeaturesBy="strand":t.separateFeaturesBy="none",t.dataType=t.contents.type,t.dataMethod=t.contents.from,t.dataKeys=t.contents.extract;return t.tracks=r,t.annotaion=t.settings.annotaion,t.backbone=t.settings.backbone,t.dividers=t.settings.dividers,t.ruler=t.settings.ruler,t.settings=t.settings.general,t.version="1.1.0",t}downloadImage(t,e,s="image.png"){const r=this._viewer,n=r.canvas;t=t||r.width,e=e||r.height;const o=n._layers,a=r.debug;r.debug=!1;const h=n.layerNames.concat(["export"]),l=n.createLayers(i.select("body"),h,t,e,!1),c=i.min([t,e])/r.minDimension;for(const t of n.layerNames)l[t].ctx.scale(c,c);n._layers=l,r.drawExport(),r.fillBackground(),r.legend.draw();for(let t=0,e=r._captions.length;t<e;t++)r._captions[t].draw();const d=l.export.ctx;d.drawImage(l.background.node,0,0),d.drawImage(l.map.node,0,0),d.drawImage(l.foreground.node,0,0),d.drawImage(l.canvas.node,0,0),l.export.node.toBlob((t=>{this.download(t,s,"image/png")})),n._layers=o,r.debug=a;for(const t of h)i.select(l[t].node).remove()}getSVG(){const t=this.viewer.externals.SVGContext;if(!t)return void console.error("SVGContext is not set. This should be set to svgcanvas.Context from https://github.com/zenozeng/svgcanvas");const e=this._viewer,s=e.canvas,r=e.width,n=e.height,o=s._layers,a=e.debug;e.debug=!1;const h=s.layerNames,l=s.createLayers(i.select("body"),h,r,n,!1);s._layers=l;const c=new t(r,n);l.map.ctx=c,l.foreground.ctx=c,l.canvas.ctx=c,c.clearRect=()=>{},c.fillStyle=e.settings.backgroundColor.rgbaString,c.fillRect(0,0,r,n),e.drawExport(),e.legend.draw();for(let t=0,s=e._captions.length;t<s;t++)e._captions[t].draw();const d=l.map.ctx.getSerializedSvg();s._layers=o,e.debug=a;for(const t of h)i.select(l[t].node).remove();return d}downloadSVG(t="image.svg"){const e=this.getSVG();e&&this.download(e,t,"image/svg+xml")}downloadFasta(t,e="sequence.fa",s={}){const i=this.viewer.sequence.asFasta(t,s);this.download(i,e,"text/plain")}downloadJSON(t="cgview.json",e={}){const s=this.viewer.io.toJSON(e);this.download(JSON.stringify(s),t,"text/json")}download(t,e,s="text/plain"){const i=new Blob([t],{type:s});if(window.navigator.msSaveOrOpenBlob)window.navigator.msSaveOrOpenBlob(i,e);else{const t=document.createElement("a"),s=URL.createObjectURL(i);t.href=s,t.download=e,document.body.appendChild(t),t.click(),setTimeout((function(){document.body.removeChild(t),window.URL.revokeObjectURL(s)}),0)}}initializeDragAndDrop(){const t=this.viewer,e=t.canvas;i.select(e.node("ui")).on("dragleave.dragndrop",(e=>{e.preventDefault(),e.stopPropagation(),t.drawFull()})),i.select(e.node("ui")).on("dragover.dragndrop",(t=>{t.preventDefault(),t.stopPropagation()})),i.select(e.node("ui")).on("drop.dragndrop",(e=>{e.preventDefault(),e.stopPropagation(),t.drawFull();const s=e.dataTransfer.files[0],i=new FileReader;i.onload=function(){const e=i.result;try{const s=JSON.parse(e);t.io.loadJSON(s.cgview),t.drawFull()}catch(t){}},i.readAsText(s)}))}}class Z{constructor(t){this._layout=t}toString(){return"LayoutCircular"}get layout(){return this._layout}get viewer(){return this.layout.viewer}get canvas(){return this.layout.canvas}get backbone(){return this.layout.backbone}get sequence(){return this.layout.sequence}get scale(){return this.layout.scale}get width(){return this.layout.width}get height(){return this.layout.height}get type(){return"circular"}pointForBp(t,e=this.backbone.adjustedCenterOffset){const s=this.scale.bp(t);return{x:this.scale.x(0)+e*Math.cos(s),y:this.scale.y(0)+e*Math.sin(s)}}bpForPoint(t){const e=this.scale.x.invert(t.x),s=this.scale.y.invert(t.y);return Math.round(this.scale.bp.invert(o.angleFromPosition(e,s)))}centerOffsetForPoint(t){const e=this.scale.x.invert(t.x),s=this.scale.y.invert(t.y);return Math.sqrt(e*e+s*s)}domainsFor(t,e=this.viewer.zoomFactor,s=0){const i=this.scale.x.range()[1]/2,r=this.scale.y.range()[1]/2,n=this.backbone.centerOffset*e-s,o=this._mapPointForBp(t,n),a=t?o.x:0,h=t?o.y:0;return[a-i,a+i,h+r,h-r]}adjustBpScaleRange(t=!1){if(t){const t=2*Math.PI/this.sequence.length,e=-.5*Math.PI,s=1.5*Math.PI-t;this.scale.bp.range([e,s])}}visibleRangeForCenterOffset(t,e=0){const s=this._visibleRangesForRadius(t,e);return 2===s.length?new M(this.sequence.mapContig,s[0],s[1]):s.length>2?new M(this.sequence.mapContig,s[0],s[s.length-1]):t-e>this._maximumVisibleRadius()||t+e<this._minimumVisibleRadius()?void 0:new M(this.sequence.mapContig,1,this.sequence.length)}maxMapThickness(){return this.viewer.minDimension*this.layout._maxMapThicknessProportion}pixelsPerBp(t=this.backbone.adjustedCenterOffset){return 2*t*Math.PI/this.sequence.length}clockPositionForBp(t,e=!1){const s=this.scale.bp(t);return o.clockPositionForAngle(e?s+Math.PI:s)}zoomFactorForLength(t){return this.viewer.width/(t/this.sequence.length*Math.PI*2)/this.backbone.centerOffset}initialWorkingSpace(){return this.viewer.minDimension*this.layout._initialMapThicknessProportion}updateInitialBackboneCenterOffset(t,e){const s=.25*this.viewer.minDimension,i=Math.max(s,t+40);this.backbone.centerOffset=i-(e-t)/2}adjustedBackboneCenterOffset(t){return t*this.viewer._zoomFactor}path(t,e,s,i,r=!1,n="moveTo"){const o=this.canvas,a=o.context(t),h=this.scale,l=r?o.sequence.lengthOfRange(i,s):o.sequence.lengthOfRange(s,i);if(l<o.sequence.length/1e3){const t=this.pointForBp(i,e);if("lineTo"===n){const i=this.pointForBp(s,e);a.lineTo(i.x,i.y),a.lineTo(t.x,t.y)}else if("moveTo"===n){const i=this.pointForBp(s,e);a.moveTo(i.x,i.y),a.lineTo(t.x,t.y)}else"noMoveTo"===n&&a.lineTo(t.x,t.y)}else if(l/o.sequence.length>.95){const t=h.bp(s),n=h.bp(i);let o=t+(n-t)/2;(s>i+1&&!r||s<i-1&&r)&&(o+=Math.PI),a.arc(h.x(0),h.y(0),e,t,o,r),a.arc(h.x(0),h.y(0),e,o,n,r)}else a.arc(h.x(0),h.y(0),e,h.bp(s),h.bp(i),r)}centerCaptionPoint(){return this.pointForBp(0,0)}_mapPointForBp(t,e=this.backbone.adjustedCenterOffset){const s=this.scale.bp(t);return{x:e*Math.cos(s),y:-e*Math.sin(s)}}_centerVisible(){const t=this.scale.x(0),e=this.scale.y(0);return t>=0&&t<=this.width&&e>=0&&e<=this.height}_maximumVisibleRadius(){const t=Math.max(Math.abs(this.scale.x.invert(0)),Math.abs(this.scale.x.invert(this.width))),e=Math.max(Math.abs(this.scale.y.invert(0)),Math.abs(this.scale.y.invert(this.height)));return Math.sqrt(t*t+e*e)}_minimumVisibleRadius(){if(this._centerVisible())return 0;if(o.oppositeSigns(this.scale.x.invert(0),this.scale.x.invert(this.width)))return Math.min(Math.abs(this.scale.y.invert(0)),Math.abs(this.scale.y.invert(this.height)));if(o.oppositeSigns(this.scale.y.invert(0),this.scale.y.invert(this.height)))return Math.min(Math.abs(this.scale.x.invert(0)),Math.abs(this.scale.x.invert(this.width)));{const t=Math.min(Math.abs(this.scale.x.invert(0)),Math.abs(this.scale.x.invert(this.width))),e=Math.min(Math.abs(this.scale.y.invert(0)),Math.abs(this.scale.y.invert(this.height)));return Math.sqrt(t*t+e*e)}}_visibleRangesForRadius(t,e=0){return o.circleAnglesFromIntersectingRect(t,this.scale.x.invert(0-e),this.scale.y.invert(0-e),this.width+2*e,this.height+2*e).map((t=>Math.round(this.scale.bp.invert(t))))}}class tt{constructor(t){this._layout=t}toString(){return"LayoutLinear"}get layout(){return this._layout}get viewer(){return this.layout.viewer}get canvas(){return this.layout.canvas}get backbone(){return this.layout.backbone}get sequence(){return this.layout.sequence}get scale(){return this.layout.scale}get width(){return this.layout.width}get height(){return this.layout.height}get type(){return"linear"}pointForBp(t,e=this.backbone.adjustedCenterOffset){return{x:this.scale.x(this.scale.bp(t)),y:this.scale.y(e)}}bpForPoint(t){const e=this.scale.x.invert(t.x);return Math.round(this.scale.bp.invert(e))}centerOffsetForPoint(t){return this.scale.y.invert(t.y)}domainsFor(t,e=this.viewer.zoomFactor,s=0){const i=this.scale.x.range()[1]/2,r=this.scale.y.range()[1]/2,n=this.scale.bp.copy(),o=this.canvas.width*e/2;this.scale.bp.range([-o,o]);const a=this._mapPointForBp(t,this.backbone.centerOffset-s);this.scale.bp=n;const h=t?a.x:0,l=t?a.y:0;return[h-i,h+i,l+r,l-r]}adjustBpScaleRange(){const t=this.canvas.width*this.viewer.zoomFactor/2;this.scale.bp.range([-t,t])}visibleRangeForCenterOffset(t,e=0){const s=this.scale.x.domain(),i=Math.floor(this.scale.bp.invert(s[0]-e)),r=Math.ceil(this.scale.bp.invert(s[1]+e));return new M(this.sequence.mapContig,Math.max(i,1),Math.min(r,this.sequence.length))}maxMapThickness(){return this.viewer.height*this.layout._maxMapThicknessProportion}pixelsPerBp(t=this.backbone.adjustedCenterOffset){const e=this.scale.bp,s=e.range();return(s[1]-s[0])/(e.invert(s[1])-e.invert(s[0]))}clockPositionForBp(t,e=!1){return e?6:12}zoomFactorForLength(t){return this.sequence.length/t}initialWorkingSpace(){return this.viewer.minDimension*this.layout._initialMapThicknessProportion}updateInitialBackboneCenterOffset(t,e){this.backbone.centerOffset=0}adjustedBackboneCenterOffset(t){return t}path(t,e,s,i,r=!1,n="moveTo"){const o=this.canvas.context(t),a=this.pointForBp(i,e);if("lineTo"===n){const t=this.pointForBp(s,e);o.lineTo(t.x,t.y),o.lineTo(a.x,a.y)}else if("moveTo"===n){const t=this.pointForBp(s,e);o.moveTo(t.x,t.y),o.lineTo(a.x,a.y)}else"noMoveTo"===n&&o.lineTo(a.x,a.y)}centerCaptionPoint(){const t=this.sequence.length/2;return this.pointForBp(t,-200)}_mapPointForBp(t,e=this.backbone.adjustedCenterOffset){return{x:this.scale.bp(t),y:e}}}class et{constructor(t){this._viewer=t,this._fastMaxFeatures=1e3,this._minSlotThickness=1,this._maxSlotThickness=50,this._maxMapThicknessProportion=.5,this._initialMapThicknessProportion=.1,this._scale={},this._adjustProportions()}toString(){return"Layout"}get viewer(){return this._viewer}get canvas(){return this.viewer.canvas}get width(){return this.canvas.width}get height(){return this.canvas.height}get sequence(){return this.viewer.sequence}get backbone(){return this.viewer.backbone}get scale(){return this._scale}get delegate(){return this._delegate}get type(){return this.delegate&&this.delegate.type}set type(t){const e=this.delegate&&this.canvas.bpForCanvasCenter(),s=Boolean(this.delegate&&this.type!==t);if("linear"===t)this._delegate=new tt(this);else{if("circular"!==t)throw"Layout type must be one of the following: linear, circular";this._delegate=new Z(this)}this._adjustProportions(),this.updateScales(s,e)}get bbInsideOffset(){return this._bbInsideOffset}get bbOutsideOffset(){return this._bbOutsideOffset}get centerInsideOffset(){return this._bbInsideOffset+this.backbone.adjustedCenterOffset}get centerOutsideOffset(){return this._bbOutsideOffset+this.backbone.adjustedCenterOffset}get slotThicknessRatioStats(){return this._slotThicknessRatioStats}get slotProportionStats(){return this._slotProportionStats}pointForBp(...t){return this.delegate.pointForBp(...t)}bpForPoint(...t){return this.delegate.bpForPoint(...t)}centerOffsetForPoint(...t){return this.delegate.centerOffsetForPoint(...t)}domainsFor(...t){return this.delegate.domainsFor(...t)}adjustBpScaleRange(...t){return this.delegate.adjustBpScaleRange(...t)}visibleRangeForCenterOffset(...t){return this.delegate.visibleRangeForCenterOffset(...t)}maxMapThickness(){return this.delegate.maxMapThickness()}pixelsPerBp(...t){return this.delegate.pixelsPerBp(...t)}clockPositionForBp(...t){return this.delegate.clockPositionForBp(...t)}zoomFactorForLength(...t){return this.delegate.zoomFactorForLength(...t)}initialWorkingSpace(){return this.delegate.initialWorkingSpace()}updateInitialBackboneCenterOffset(...t){this.delegate.updateInitialBackboneCenterOffset(...t)}adjustedBackboneCenterOffset(...t){return this.delegate.adjustedBackboneCenterOffset(...t)}path(...t){this.delegate.path(...t)}centerCaptionPoint(){return this.delegate.centerCaptionPoint()}updateScales(t,e){if(!this.sequence)return;e=e&&this.sequence.constrain(e);const s=this.canvas,r=this.scale;if(r.bp=i.scaleLinear().domain([1,this.sequence.length]),this.adjustBpScaleRange(!0),this.viewer._updateZoomMax(),t){r.x=void 0,r.y=void 0,this._updateScaleForAxis("x",s.width),this._updateScaleForAxis("y",s.height);const t=1.25;this.viewer.zoomFactor>t&&e&&this.viewer.zoomTo(e,this.viewer.zoomFactor,{duration:0})}else this._updateScaleForAxis("x",s.width),this._updateScaleForAxis("y",s.height)}zoom(t,e=this.canvas.bpForCanvasCenter()){const{x:s,y:r}=this.pointForBp(e);t=o.constrain(t,this.viewer.minZoomFactor,this.viewer.maxZoomFactor),i.zoomTransform(this.canvas.node("ui")).k=t,this.viewer._zoomFactor=t,this.adjustBpScaleRange();const{x:n,y:a}=this.pointForBp(e),h=s-n,l=a-r;this.translate(h,-l)}translate(t,e){const s=this.scale.x.domain(),i=this.scale.y.domain();this.scale.x.domain([s[0]-t,s[1]-t]),this.scale.y.domain([i[0]+e,i[1]+e])}_updateSlotThicknessRatioStats(t=this.visibleSlots()){const e=t.map((t=>t.thicknessRatio));this._slotThicknessRatioStats={min:i.min(e),max:i.max(e),sum:i.sum(e)}}_updateSlotProportionStats(t=this.visibleSlots()){const e=t.map((t=>t.proportionOfMap));this._slotProportionStats={min:i.min(e),max:i.max(e),sum:i.sum(e)}}_trackNonSlotSpace(t,e="inside"){const s=this.viewer.dividers,i=t.slots().filter((t=>t.visible&&t[e]));let r=0;if(i.length>0){r+=2*s.track.adjustedSpacing,r+=s.track.adjustedThickness;r+=(i.length-1)*(2*s.slot.adjustedSpacing+s.slot.adjustedThickness)}return r}_nonSlotSpace(t="both"){let e=0;const s=this.tracks().filter((t=>t.visible));for(let i=0,r=s.length;i<r;i++){const r=s[i];"both"===t?(e+=this._trackNonSlotSpace(r,"inside"),e+=this._trackNonSlotSpace(r,"outside")):e+=this._trackNonSlotSpace(r,t)}return"both"===t&&(e+=this.backbone.adjustedThickness),e}_findSpace(t,e="min"){t=t||this.visibleSlots();const s="min"===e,i=this.minSlotThickness,r=this.maxSlotThickness,n=this.slotThicknessRatioStats.min,a=this.slotThicknessRatioStats.max;let h=this._nonSlotSpace();const l=i/n*a>r;for(let e=0,c=t.length;e<c;e++){const c=t[e];h+=l?o.scaleValue(c.thicknessRatio,{min:n,max:a},{min:i,max:r}):s?c.thicknessRatio*i/n:c.thicknessRatio*r/a}return h}_minSpace(t){return this._findSpace(t,"min")}_maxSpace(t){return this._findSpace(t,"max")}_adjustProportions(){const t=this.viewer;if(t.loading)return;const e=this.visibleSlots();this._updateSlotThicknessRatioStats(e),this.initialWorkingSpace(),this._minSpace(e);const s=this.initialWorkingSpace(),i=Math.min(s,this.maxMapThickness()),r=this.slotThicknessRatioStats.sum;let n=this._nonSlotSpace("outside"),o=this._nonSlotSpace("inside");this.visibleSlots().each(((t,e)=>{e.proportionOfMap=e.thicknessRatio/r;const s=i*e.proportionOfMap;e.inside?o+=s:n+=s})),this._updateSlotProportionStats(e),this.updateInitialBackboneCenterOffset(o,n),this._calculateMaxMapThickness(),this.updateLayout(!0),t.zoomFactor>2&&t.moveTo(void 0,void 0,{duration:0})}_calculateMaxMapThickness(){const t=this.viewer,e=t.zoomFactor;t._zoomFactor=1,this.updateLayout(!0),this.bbOutsideOffset,this.bbInsideOffset;let s=0;const i=this.tracks().filter((t=>t.visible));for(let t=0,e=i.length;t<e;t++){const e=i[t].slots().filter((t=>t.visible));if(e.length>0)for(let t=0,i=e.length;t<i;t++){s+=e[t].thickness}}t._zoomFactor=t.maxZoomFactor,this.updateLayout(!0),this.bbOutsideOffset,this.bbInsideOffset;let r=0;for(let t=0,e=i.length;t<e;t++){const e=i[t].slots().filter((t=>t.visible));if(e.length>0)for(let t=0,s=e.length;t<s;t++){r+=e[t].thickness}}this._maxMapThicknessZoomFactor=r/s,t._zoomFactor=e}centerOffsetForMapOffset(t){return t+(t>=0?this.centerOutsideOffset:this.centerInsideOffset)}centerOffsetForBBOffsetPercent(t){const e=this.backbone.adjustedCenterOffset;return 0===t?e:t>0?e+t/100*this.bbOutsideOffset:t<0?e-t/100*this.bbInsideOffset:void 0}tracks(t){return this.viewer.tracks(t)}slots(t){return this.viewer.slots(t)}visibleSlots(t){return this.slots().filter((t=>t.visible&&t.track.visible)).get(t)}slotForCenterOffset(t){const e=this.visibleSlots();let s;for(let i=0,r=e.length;i<r;i++)if(e[i].containsCenterOffset(t)){s=e[i];break}return s}get slotLength(){return this._slotLength||0}get fastMaxFeatures(){return this._fastMaxFeatures}get fastFeaturesPerSlot(){return this._fastFeaturesPerSlot}get maxSlotThickness(){return this._maxSlotThickness}set maxSlotThickness(t){this._maxSlotThickness=Number(t),this._adjustProportions()}get minSlotThickness(){return this._minSlotThickness}set minSlotThickness(t){this._minSlotThickness=Number(t),this._adjustProportions()}get initialMapThicknessProportion(){return this._initialMapThicknessProportion}set initialMapThicknessProportion(t){this._initialMapThicknessProportion=Number(t),this._adjustProportions()}get maxMapThicknessProportion(){return this._maxMapThicknessProportion}set maxMapThicknessProportion(t){this._maxMapThicknessProportion=Number(t),this._adjustProportions()}drawMapWithoutSlots(t){const e=this.viewer,s=e.backbone;this.canvas,e.clear("map"),e.clear("foreground"),e.clear("ui"),e.messenger.visible&&e.messenger.close(),s.draw(),this.updateLayout(),e.dividers.draw();const i=e.dividers.track.adjustedThickness;e.ruler.draw(this.centerInsideOffset-i,this.centerOutsideOffset+i),e.annotation.visible&&e.annotation.draw(this.centerInsideOffset,this.centerOutsideOffset,t);for(let t=0,s=e._captions.length;t<s;t++)e._captions[t].onMap&&e._captions[t].draw();e.legend.position.onMap&&e.legend.draw(),this.drawProgress(),this._slotIndex=0,this._slotTimeoutID&&(clearTimeout(this._slotTimeoutID),this._slotTimeoutID=void 0)}drawFast(){const t=(new Date).getTime();this.drawMapWithoutSlots(!0),this.drawAllSlots(!0),this.viewer.debug&&(this.viewer.debug.data.time.fastDraw=o.elapsedTime(t),this.viewer.debug.draw())}drawFull(){this.drawMapWithoutSlots(),this.drawAllSlots(!0),this._drawFullStartTime=(new Date).getTime(),this.drawSlotWithTimeOut(this)}drawExport(){this.drawMapWithoutSlots(),this.drawAllSlots(!1)}draw(t){t?this.drawFast():this.drawFull()}drawAllSlots(t){let e,s;const i=this.tracks();for(let r=0,n=i.length;r<n;r++)if(e=i[r],e.visible)for(let i=0,r=e._slots.length;i<r;i++)s=e._slots[i],s.visible&&s.draw(this.canvas,t)}drawSlotWithTimeOut(t){const e=t.visibleSlots(),s=e[t._slotIndex];s&&(s.clear(),s.draw(t.canvas),t._slotIndex++,t._slotIndex<e.length?t._slotTimeoutID=setTimeout(t.drawSlotWithTimeOut,0,t):t.viewer.debug&&(t.viewer.debug.data.time.fullDraw=o.elapsedTime(t._drawFullStartTime),t.viewer.debug.draw()))}_updateLayoutFor(t="inside"){const e=this.viewer.dividers,s="outside"===t?1:-1;let i=this.backbone.adjustedThickness/2;const r=2*e.slot.adjustedSpacing+e.slot.adjustedThickness,n=this.tracks().filter((t=>t.visible));for(let o=0,a=n.length;o<a;o++){const a=n[o].slots().filter((e=>e.visible&&e[t]));if(a.length>0){i+=e.track.adjustedSpacing;for(let t=0,n=a.length;t<n;t++){const o=a[t],h=this._calculateSlotThickness(o.proportionOfMap);o._thickness=h,i+=h/2,o._bbOffset=s*i,i+=h/2,t===n-1?(i+=e.track.adjustedSpacing,e.addBbOffset(s*(i+e.track.adjustedThickness/2),"track"),i+=e.track.adjustedThickness):(e.addBbOffset(s*(i+r/2),"slot"),i+=r)}}}return s*i}updateLayout(t){const e=this.viewer;(t||this._savedZoomFactor!==e._zoomFactor)&&(this._savedZoomFactor=e._zoomFactor,e.dividers.clearBbOffsets(),this._fastFeaturesPerSlot=this._fastMaxFeatures/this.visibleSlots().length,this._bbInsideOffset=this._updateLayoutFor("inside"),this._bbOutsideOffset=this._updateLayoutFor("outside"))}_calculateSlotThickness(t){const e=this.viewer,s=this.initialWorkingSpace()*e.zoomFactor,i=Math.min(s,this.maxMapThickness()),r=this.maxSlotThickness/i,n=this.slotProportionStats;if(n.max>r)if(n.min===n.max)t=r;else{const e=this.minSlotThickness/i,s=r/(n.max/n.min),a=s<e?e:s;t=o.scaleValue(t,{min:n.min,max:n.max},{min:a,max:r})}return t*i}_updateScaleForAxis(t,e){const s=this.scale;let r="x"===t?-.5:.5,n="x"===t?.5:-.5;if(s[t]){const e=s[t].domain(),i=Math.abs(e[1]-e[0]);r=e[0]/i,n=e[1]/i}s[t]=i.scaleLinear().domain([e*r,e*n]).range([0,e])}drawProgress(){let t,e,s;this.canvas.clear("background");const i=this.tracks().filter((t=>t.visible));for(let r=0,n=i.length;r<n;r++){t=i[r],s=t.loadProgress;for(let i=0,r=t._slots.length;i<r;i++)e=t._slots[i],e.drawProgress(s)}}}class st{constructor(t,e={}){return this._viewer=t,this._wrapper=t._wrapper.node(),this.fadeTime=o.defaultFor(e.fadeTime,100),this.height=o.defaultFor(e.height,40),this.width=o.defaultFor(e.width,200),this.box=i.select(this._wrapper).append("div").style("display","none").attr("class","cgv-messenger").style("width",this.height).style("height",this.width),this.contents=this.box.append("div").attr("class","cgv-messenger-contents"),this._adjustSize(),this}toString(){return"Messenger"}get viewer(){return this._viewer}get visible(){return"none"!==this.box.style("display")}get fadeTime(){return this._fadeTime}set fadeTime(t){this._fadeTime=t}open(){return this._adjustSize(),this.box.style("display","block"),this.box.style("opacity",1),this}close(t){return t=o.defaultFor(t,this.fadeTime),this.box.transition().duration(t).style("opacity",0).on("end",(function(){i.select(this).style("display","none")})),this}_adjustSize(){const t=this._wrapper.offsetWidth,e=this._wrapper.offsetHeight;let s=this.width,i=this.height;this.height>e-50&&(i=e-50),this.width>t-50&&(s=t-50),this.box.style("width",`${s}px`).style("height",`${i}px`)}flash(t){this.contents.html(t),this.open()}}class it extends c{constructor(t,e={},s={}){super(t,e,s),this.viewer=t,this.name=e.name,this.extractedFromSequence=o.defaultFor(e.extractedFromSequence,!1),this.positions=o.defaultFor(e.positions,[]),this.scores=o.defaultFor(e.scores,[]),this.type=o.defaultFor(e.type,"line"),this.source=o.defaultFor(e.source,""),this.axisMin=o.defaultFor(e.axisMin,i.min([0,this.scoreMin])),this.axisMax=o.defaultFor(e.axisMax,i.max([0,this.scoreMax])),this.baseline=o.defaultFor(e.baseline,0),e.legend&&(this.legendItem=e.legend),e.legendPositive&&(this.legendItemPositive=e.legendPositive),e.legendNegative&&(this.legendItemNegative=e.legendNegative);const r=t.plots().indexOf(this)+1;this.legendItemPositive||this.legendItemNegative?this.legendItemPositive?this.legendItemNegative||(this.legendItemNegative=this.legendItemPositive):this.legendItemPositive=this.legendItemNegative:this.legendItem=`Plot-${r}`}toString(){return"Plot"}get name(){return this._name}set name(t){this._name=t}get type(){return this._type}set type(t){o.validate(t,["line","bar"])&&(this._type=t)}get viewer(){return this._viewer}set viewer(t){this.viewer,this._viewer=t,t._plots.push(this)}get positions(){return this._positions||new n}set positions(t){t&&(this._positions=new n(t))}get score(){return this._score||new n}set score(t){t&&(this._score=new n(t))}get length(){return this.positions.length}get color(){return[this.colorPositive,this.colorNegative]}get colorPositive(){return this.legendItemPositive.color}get colorNegative(){return this.legendItemNegative.color}get legendItem(){return new n([this.legendItemPositive,this.legendItemNegative])}set legendItem(t){this.legendItemPositive=t,this.legendItemNegative=t}get legend(){return this.legendItem}set legend(t){this.legendItem=t}get legendItemPositive(){return this._legendItemPositive}set legendItemPositive(t){this.legendItemPositive&&void 0===t||(t&&"LegendItem"===t.toString()?this._legendItemPositive=t:this._legendItemPositive=this.viewer.legend.findLegendItemOrCreate(t))}get legendItemNegative(){return this._legendItemNegative}set legendItemNegative(t){this.legendItemNegative&&void 0===t||(t&&"LegendItem"===t.toString()?this._legendItemNegative=t:this._legendItemNegative=this.viewer.legend.findLegendItemOrCreate(t))}get legendPositive(){return this.legendItemPositive}set legendPositive(t){this.legendItemPositive=t}get legendNegative(){return this.legendItemNegative}set legendNegative(t){this.legendItemNegative=t}get baseline(){return this._baseline}set baseline(t){t=Number(t);const e=this.axisMin,s=this.axisMax;this._baseline=t>s?s:t<e?e:t}get axisMin(){return this._axisMin}set axisMin(t){t=Number(t);const e=i.min([this.scoreMin,this.baseline]);this._axisMin=t>e?e:t}get axisMax(){return this._axisMax}set axisMax(t){t=Number(t);const e=i.max([this.scoreMax,this.baseline]);this._axisMax=t<e?e:t}get scoreMax(){return i.max(this.scores)}get scoreMin(){return i.min(this.scores)}get scoreMean(){return i.mean(this.scores)}get scoreMedian(){return i.median(this.scores)}get extractedFromSequence(){return this._extractedFromSequence}set extractedFromSequence(t){this._extractedFromSequence=t}highlight(t){this.visible&&(this.canvas.clear("ui"),t&&t.plot===this?t.highlight():this.tracks().each(((t,e)=>e.highlight())))}update(t){this.viewer.updatePlots(this,t)}tracks(t){const e=new n;return this.viewer.tracks().each(((t,s)=>{s.plot===this&&e.push(s)})),e.get(t)}remove(){this.viewer.removePlots(this)}scoreForPosition(t){const e=o.indexOfValue(this.positions,t);return 0===e&&t<this.positions[e]?void 0:this.scores[e]}draw(t,e,s,i,r){this.visible&&(this.colorNegative.rgbaString===this.colorPositive.rgbaString?this._drawPath(t,e,s,i,r,this.colorPositive):(this._drawPath(t,e,s,i,r,this.colorPositive,"positive"),this._drawPath(t,e,s,i,r,this.colorNegative,"negative")))}_drawPath(t,e,s,i,r,n,a){const h=t.context("map"),l=this.positions,c=this.scores,d=this.viewer.sequence.length,g=o.indexOfValue(l,r.start,!1);let u=o.indexOfValue(l,r.stop,!1);0===u&&r.stop<l[u]&&(u=l.length-1);const p=0===g?l[g]:r.start;let f=r.stop,m=c[g];m=this._keepPoint(m,a)?m:this.baseline,h.beginPath();const b=this.axisMax-this.axisMin,v=e-s/2+s*(this.baseline-this.axisMin)/b,w=t.pointForBp(p,v);h.moveTo(w.x,w.y);let _,y,x=v+(m-this.baseline)*s,k=p,S=1;if(i){const t=this.countPositionsFromRange(p,f)/4e3;t>1&&(S=o.base2(t))}this.positionsFromRange(p,f,S,(e=>{0===e&&0!==g&&(t.path("map",x,k,d,!1,"lineTo"),k=1,x=v),_=c[e],y=l[e],t.path("map",x,k,y,!1,"lineTo"),x=this._keepPoint(_,a)?v+(_-this.baseline)/b*s:v,k=y})),u===l.length-1&&f<l[0]&&(f=d),t.path("map",x,k,f,!1,"lineTo");const F=t.pointForBp(f,v);h.lineTo(F.x,F.y),t.path("map",v,f,p,!0,"noMoveTo"),h.fillStyle=n.rgbaString,h.fill()}_keepPoint(t,e){return void 0===e||("positive"===e&&t>this.baseline||"negative"===e&&t<this.baseline)}positionsFromRange(t,e,s,i){const r=this.positions;let n=o.indexOfValue(r,t,!0);const a=o.indexOfValue(r,e,!1);if(n>0&&s>1&&(n+=s-n%s),e>=t){if(r[n]>e||r[a]<t)return;for(let t=n;t<=a;t+=s)i.call(r[t],t,r[t])}else{if(r[n]>=t)for(let t=n,e=r.length;t<e;t+=s)i.call(r[t],t,r[t]);if(r[a]<=e)for(let t=0;t<=a;t+=s)i.call(r[t],t,r[t])}return r}countPositionsFromRange(t,e){const s=this.positions;let i=o.indexOfValue(s,t,!0),r=o.indexOfValue(s,e,!1);return t>s[s.length-1]&&i++,e<s[0]&&r--,e>=t?r-i+1:s.length-i+r+1}toJSON(t={}){const e={name:this.name,type:this.type,baseline:this.baseline,source:this.source};return this.legendPositive===this.legendNegative?e.legend=this.legendPositive.name:(e.legendPositive=this.legendPositive.name,e.legendNegative=this.legendNegative.name),(this.axisMin!==this.scoreMin||t.includeDefaults)&&(e.axisMin=this.axisMin),(this.axisMax!==this.scoreMax||t.includeDefaults)&&(e.axisMax=this.axisMax),t.excludeData||(e.positions=this.positions,e.scores=this.scores),this.visible&&!t.includeDefaults||(e.visible=this.visible),(this.favorite||t.includeDefaults)&&(e.favorite=this.favorite),e}}class rt extends c{constructor(t,e={},s={}){super(t.viewer,e,s),this.track=t,this._strand=o.defaultFor(e.strand,"direct"),this._features=new n,this._plot,this.refresh()}toString(){return"Slot"}get track(){return this._track}set track(t){this.track,this._track=t,t._slots.push(this)}get type(){return this.track.type}get layout(){return this.track.layout}get position(){return"both"===this.track.position?this.isDirect()?"outside":"inside":this.track.position}get drawOrder(){return this._track.drawOrder}get drawByScore(){return"score"===this.drawOrder}get inside(){return"inside"===this.position}get outside(){return"outside"===this.position}get proportionOfMap(){return this._proportionOfMap}set proportionOfMap(t){this._proportionOfMap=t}get thicknessRatio(){return this.track.thicknessRatio}get bbOffset(){return this._bbOffset}get centerOffset(){return this.bbOffset+this.viewer.backbone.adjustedCenterOffset}get thickness(){return this._thickness}get strand(){return this._strand}isDirect(){return"direct"===this.strand}isReverse(){return"reverse"===this.strand}get hasFeatures(){return this._features.length>0}get hasPlot(){return this._plot}features(t){return this._features.get(t)}replaceFeatures(t){this._features=t,this.refresh()}pixelsPerBp(){return this.layout.pixelsPerBp(this.centerOffset)}refresh(){this._featureNCList=new x(this._features,{circularLength:this.sequence.length,startProperty:"mapStart",stopProperty:"mapStop"})}get visibleRange(){return this._visibleRange}containsCenterOffset(t){const e=this.thickness/2;return t>=this.centerOffset-e&&t<=this.centerOffset+e}findFeaturesForBp(t){return this._featureNCList.find(t)}findLargestFeatureLength(){let t,e=0;for(let s=0,i=this._features.length;s<i;s++)t=this._features[s].length,t>e&&(e=t);return e}clear(){const t=this._visibleRange;if(t){const e=this.centerOffset,s=this.thickness,i=this.canvas.context("map");i.globalCompositeOperation="destination-out",this.canvas.drawElement("map",t.start,t.stop,e,"white",s),i.globalCompositeOperation="source-over"}}highlight(t="#FFB"){const e=this._visibleRange;if(e&&this.visible){const s=this.centerOffset,i=this.thickness;this.canvas.drawElement("background",e.start,e.stop,s,t,i)}}draw(t,e){const s=this.centerOffset,i=this.thickness,r=t.visibleRangeForCenterOffset(s,i);if(this._visibleRange=r,r){const n=r.start,a=r.stop;if(this.hasFeatures){let t=this._features.length;r.isMapLength()||(t=this._featureNCList.count(n,a));let h=1;if(e&&t>this.layout.fastFeaturesPerSlot){const e=Math.ceil(t/this.layout.fastFeaturesPerSlot);h=o.base2(e)}const l=!e&&void 0;if(this.viewer.settings.showShading&&this.isDirect()&&(h*=-1),this.drawByScore){const t=this._featureNCList.find(n,a,h).sort(((t,e)=>t.score-e.score||t.length-e.length));for(const e of t)e.draw("map",s,i,r,{showShading:l})}else this._featureNCList.run(n,a,h,(t=>{t.draw("map",s,i,r,{showShading:l})}));if(this.viewer.debug&&this.viewer.debug.data.n){const e=this.viewer.slots().indexOf(this);this.viewer.debug.data.n[`slot_${e}`]=t}}else this.hasPlot&&this._plot.draw(t,s,i,e,r)}}drawProgress(t){const e=this.canvas,s=this.centerOffset,i=this.thickness,r=this._visibleRange;if(t>0&&t<100&&r){const n=i*t/100;e.drawElement("background",r.start,r.stop,s,"#EAEAEE",n,"arc",!1)}}removeFeatures(t){t="CGArray"===t.toString()?t:new n(t),this._features=this._features.filter((e=>!t.includes(e))),this.refresh()}removePlot(){this._plot=void 0,this.refresh()}}class nt extends c{constructor(t,e={},s={}){super(t,e,s),this.viewer=t,this._plot,this._features=new n,this._slots=new n,this.name=o.defaultFor(e.name,"Unknown"),this.separateFeaturesBy=o.defaultFor(e.separateFeaturesBy,"strand"),this.position=o.defaultFor(e.position,"both"),this.drawOrder=o.defaultFor(e.drawOrder,"position"),this.dataType=o.defaultFor(e.dataType,"feature"),this.dataMethod=o.defaultFor(e.dataMethod,"source"),this.dataKeys=e.dataKeys,this.dataOptions=e.dataOptions||{},this._thicknessRatio=o.defaultFor(e.thicknessRatio,1),this._loadProgress=0,this.refresh()}toString(){return"Track"}get viewer(){return this._viewer}set viewer(t){this.viewer,this._viewer=t,t._tracks.push(this)}set visible(t){this._visible=t,this.layout&&this.layout._adjustProportions()}get visible(){return this._visible}get id(){return this.name}get name(){return this._name}set name(t){this._name=t}get layout(){return this.viewer.layout}get drawOrder(){return this._drawOrder}set drawOrder(t){o.validate(t,["position","score"])&&(this._drawOrder=t)}get dataType(){return this._dataType}set dataType(t){o.validate(t,["feature","plot"])&&(this._dataType=t)}get type(){return this.dataType}get dataMethod(){return this._dataMethod}set dataMethod(t){o.validate(t,["source","type","tag","sequence"])&&(this._dataMethod=t)}get dataKeys(){return this._dataKeys}set dataKeys(t){this._dataKeys=void 0===t?new n:new n(t)}get dataOptions(){return this._dataOptions}set dataOptions(t){this._dataOptions=t}get separateFeaturesBy(){return this._separateFeaturesBy}set separateFeaturesBy(t){o.validate(t,["none","strand","readingFrame"])&&(this._separateFeaturesBy=t,this.updateSlots())}get position(){return this._position}set position(t){o.validate(t,["inside","outside","both"])&&(this._position=t,this.updateSlots())}get plot(){return this._plot}get loadProgress(){return this._loadProgress}set loadProgress(t){this._loadProgress=t}get itemCount(){return"plot"===this.type?this.plot?this.plot.length:0:"feature"===this.type?this.features().length:0}get thicknessRatio(){return this._thicknessRatio}set thicknessRatio(t){this._thicknessRatio=Number(t),this.layout._adjustProportions()}update(t){this.viewer.updateTracks(this,t)}remove(){this.viewer.removeTracks(this)}move(t){const e=this.viewer.tracks().indexOf(this);this.viewer.moveTrack(e,t)}features(t){return this._features.get(t)}slots(t){return this._slots.get(t)}uniqueFeatures(t){const e=new n;for(let t=0,s=this._features.length;t<s;t++)1===this._features[t].tracks().length&&e.push(this._features[t]);return e.get(t)}removeFeatures(t){t="CGArray"===t.toString()?t:new n(t),this._features=this._features.filter((e=>!t.includes(e))),this.slots().each(((e,s)=>{s.removeFeatures(t)})),this.viewer.trigger("track-update",this)}removePlot(){this._plot=void 0,this.slots().each(((t,e)=>{e.removePlot()})),this.viewer.trigger("track-update",this)}refresh(){const t=this._plot,e=this._features;this._features=new n,this._plot=void 0,"sequence"===this.dataMethod?(t?.remove(),this.viewer.removeFeatures(e),this.extractFromSequence()):"feature"===this.type?this.updateFeatures():"plot"===this.type&&this.updatePlot(),this.updateSlots()}extractFromSequence(){const t=this.viewer.sequence.sequenceExtractor;t?t.extractTrackData(this,this.dataKeys[0],this.dataOptions):console.error("No sequence is available to extract features/plots from")}updateFeatures(){"source"===this.dataMethod||"type"===this.dataMethod?this.viewer.features().each(((t,e)=>{this.dataKeys.includes(e[this.dataMethod])&&e.contig.visible&&this._features.push(e)})):"tag"===this.dataMethod&&this.viewer.features().each(((t,e)=>{this.dataKeys.some((t=>e.tags.includes(t)))&&e.contig.visible&&this._features.push(e)}))}updatePlot(){"source"===this.dataMethod&&this.viewer.plots().find((t=>{t.source===this.dataKeys[0]&&(this._plot=t)}))}updateSlots(){"feature"===this.type?this.updateFeatureSlots():"plot"===this.type&&this.updatePlotSlot(),this.layout._adjustProportions()}updateFeatureSlots(){if(this._slots=new n,"readingFrame"===this.separateFeaturesBy){const t=this.sequence.featuresByReadingFrame(this.features());for(const e of[1,2,3]){new rt(this,{strand:"direct"}).replaceFeatures(t[`rfPlus${e}`])}for(const e of[1,2,3]){new rt(this,{strand:"reverse"}).replaceFeatures(t[`rfMinus${e}`])}}else if("strand"===this.separateFeaturesBy){const t=this.featuresByStrand();let e=new rt(this,{strand:"direct"});e.replaceFeatures(t.direct),e=new rt(this,{strand:"reverse"}),e.replaceFeatures(t.reverse)}else{new rt(this,{strand:"direct"}).replaceFeatures(this.features())}}triggerUpdate(){this.viewer.updateTracks(this)}featuresByStrand(){const t={};return t.direct=new n,t.reverse=new n,this.features().each(((e,s)=>{-1===s.strand?t.reverse.push(s):t.direct.push(s)})),t}updatePlotSlot(){this._slots=new n;new rt(this,{type:"plot"})._plot=this._plot}highlight(t="#FFB"){this.visible&&this.slots().each(((e,s)=>{s.highlight(t)}))}toJSON(t={}){const e={name:this.name,separateFeaturesBy:this.separateFeaturesBy,position:this.position,thicknessRatio:this.thicknessRatio,dataType:this.dataType,dataMethod:this.dataMethod};return e.dataKeys=1===this.dataKeys.length?this.dataKeys[0]:[...this.dataKeys],this.dataOptions&&Object.keys(this.dataOptions).length>0&&(e.dataOptions=this.dataOptions),this.visible&&!t.includeDefaults||(e.visible=this.visible),"position"!=this.drawOrder&&(e.drawOrder=this.drawOrder),t.includeDefaults&&(e.loadProgress=this.loadProgress),e}}console.log("CGView.js Version: 1.6.0");class ot{constructor(t,e={}){this.containerId=t.replace("#",""),this._container=i.select(`#${this.containerId}`),this._width=o.defaultFor(e.width,600),this._height=o.defaultFor(e.height,600),this._wrapper=this._container.append("div").attr("class","cgv-wrapper").style("position","relative").style("width",`${this.width}px`).style("height",`${this.height}px`),this._id=o.randomHexString(40),this._objects={},this._features=new n,this._tracks=new n,this._plots=new n,this._captions=new n,this._bookmarks=new n,this._loading=!0,this.canvas=new P(this,this._wrapper,{width:this.width,height:this.height}),this._layout=new et(this,e.layout),this.format=o.defaultFor(e.format,"circular"),this._zoomFactor=1,this._minZoomFactor=.5,this.io=new X(this),this.allowDragAndDrop=o.defaultFor(e.allowDragAndDrop,!0),this._events=new f,this._sequence=new j(this,e.sequence),this._backbone=new S(this,e.backbone),function(t){const e=t.backbone.maxZoomFactor();t._zoom=i.zoom().scaleExtent([1,e]).on("start",(function(){t.trigger("zoom-start"),t.highlighter.hidePopoverBox()})).on("zoom",(function(e){const i=(new Date).getTime();let n;if(e?.sourceEvent?.offsetX){const s=e.sourceEvent;n=t.canvas.bpForPoint({x:s.offsetX,y:s.offsetY})}else if(e?.sourceEvent?.touches?.length){const s=o.getOffset(t.canvas.node("map")),i=e.sourceEvent.pageX-s.left,r=e.sourceEvent.pageY-s.top;n=t.canvas.bpForPoint({x:i,y:r})}else n=t.canvas.bpForMouse();const a=e.transform.x-s,h=e.transform.y-r;s=e.transform.x,r=e.transform.y,t.zoomFactor===e.transform.k&&t.layout.translate(a,h),t.layout.zoom(e.transform.k,n),t.drawFast(),t.trigger("zoom"),t.debug&&(t.debug.data.time&&(t.debug.data.time.zoom=o.elapsedTime(i)),t.debug.data.zoom&&(t.debug.data.zoom.scale=o.round(t._zoomFactor,1)))})).on("end",(function(){t.trigger("zoom-end"),t.drawFull()})),i.select(t.canvas.node("ui")).call(t._zoom).on("dblclick.zoom",null);let s=0,r=0}(this),this.eventMonitor=new G(this),this.messenger=new st(this,e.messenger),this._settings=new J(this,e.settings),this._legend=new Q(this,e.legend),this._dividers=new z(this,e.dividers),this._annotation=new k(this,e.annotation),this._ruler=new Y(this,e.ruler),this._highlighter=new H(this,e.highlighter),this.codonTables=new O,this.debug=o.defaultFor(e.debug,!1),this.layout.updateScales(),this.externals={},this.externals.SVGContext=e.SVGContext,e.features&&this.addFeatures(e.features),this.shiftSet=!1;const s=t=>{t.shiftKey&&console.log(t)};this._wrapper.on("mouseover",(()=>{this.shiftSet||(document.addEventListener("keydown",s),this.shiftSet=!0)})).on("mouseout",(()=>{this.shiftSet&&(document.removeEventListener("keydown",s),this.shiftSet=!1)})),this._loading=!1,this.draw()}static get debugSections(){return["time","zoom","position","n"]}get version(){return r}get id(){return this._id}set id(t){this._id=t}get format(){return this.layout.type}set format(t){this.layout.type=t}get layout(){return this._layout}get legend(){return this._legend}get annotation(){return this._annotation}get dividers(){return this._dividers}get ruler(){return this._ruler}get settings(){return this._settings}get sequence(){return this._sequence}get backbone(){return this._backbone}get highlighter(){return this._highlighter}get name(){return this._name}set name(t){this._name=t}get geneticCode(){return this.settings.geneticCode}set geneticCode(t){this.settings.geneticCode=t}get width(){return this._width}set width(t){this.resize(t)}get height(){return this._height}set height(t){this.resize(null,t)}get minDimension(){return Math.min(this.height,this.width)}get maxDimension(){return Math.max(this.height,this.width)}get zoomFactor(){return this._zoomFactor}set zoomFactor(t){this.layout.zoom(Number(t))}get bp(){return this.canvas.bpForCanvasCenter()}get bbOffset(){const t=this.scale.x.range()[1]/2,e=this.scale.y.range()[1]/2,s=this.layout.centerOffsetForPoint({x:t,y:e});return this.backbone.adjustedCenterOffset-s}get minZoomFactor(){return this._minZoomFactor}get maxZoomFactor(){return this.backbone.maxZoomFactor()}get scale(){return this.layout.scale}get colorPicker(){if(void 0===this._colorPicker){const t=`${this.containerId}-color-picker`;this._wrapper.append("div").attr("id",`${this.containerId}-color-picker`),this._colorPicker=new I(t)}return this._colorPicker}get debug(){return this._debug}set debug(t){t?(!0===t&&((t={}).sections=ot.debugSections),this._debug=new $(this,t)):this._debug=void 0}get loading(){return this._loading}get dataHasChanged(){return this._dataHasChanged}set dataHasChanged(t){this._dataHasChanged=t}get events(){return this._events}get mouse(){return this.eventMonitor.mouse}get isAnimating(){return Boolean(this._animateTimeoutID)}resize(t,e,s=!0,i){this._width=t||this.width,this._height=e||this.height,this._wrapper.style("width",`${this.width}px`).style("height",`${this.height}px`),this.canvas.resize(this.width,this.height),this.refreshCanvasLayer(),this.colorPicker.close(),this.layout._adjustProportions(),this.draw(i)}objects(t){if(void 0===t)return this._objects;if("string"==typeof t)return this._objects[t];if(Array.isArray(t)){const e=new n;for(let s=0,i=t.length;s<i;s++)e.push(this._objects[t[s]]);return e}return new n}slots(t){let e=new n;for(let t=0,s=this._tracks.length;t<s;t++)e=e.concat(this._tracks[t]._slots);return e.get(t)}features(t){return this._features.get(t)}contigs(t){return this.sequence.contigs(t)}update(t){let e=Object.keys(t);if(o.validate(e,["name","id","width","height","dataHasChanged","meta"])){e.includes("width")&&e.includes("height")&&(this.resize(t.width,t.height),e=e.filter((t=>"width"!==t&&"height"!==t))),e.length>0&&!e.includes("dataHasChanged")&&(t.dataHasChanged=!0);for(let s=0;s<e.length;s++)this[e[s]]=t[e[s]];this.trigger("viewer-update",{attributes:t})}}tracks(t){return this._tracks.get(t)}addTracks(t=[]){const e=(t=n.arrayerize(t)).map((t=>new nt(this,t)));return this.backbone.visibleRange&&this.backbone.visibleRange.overHalfMapLength()||this.recenterTracks(),this.annotation.refresh(),this.dirty=!0,this.trigger("tracks-add",e),e}removeTracks(t){t=n.arrayerize(t),this._tracks=this._tracks.filter((e=>!t.includes(e))),this.layout._adjustProportions(),t.forEach((t=>t.deleteFromObjects())),this.trigger("tracks-remove",t)}updateTracks(t,e){const{records:s,updates:i}=this.updateRecords(t,e,{recordClass:"Track",validKeys:["name","position","separateFeaturesBy","dataType","dataMethod","dataKeys","dataOptions","favorite","visible","loadProgress","thicknessRatio","drawOrder"]});let r=[];if(i){const t=Object.keys(i);for(let e of t){const t=i[e],s=this.objects(e),n=Object.keys(t);(n.includes("dataMethod")||n.includes("dataType")||n.includes("dataKeys"))&&(r.includes(s)||r.push(s)),n.includes("visible")&&this.annotation.refresh()}}else if(e){const t=Object.keys(e);(t.includes("dataMethod")||t.includes("dataType")||t.includes("dataKeys"))&&(r=s),t.includes("visible")&&this.annotation.refresh()}for(const t of r)t.refresh();this.trigger("tracks-update",{tracks:s,attributes:e,updates:i})}moveTrack(t,e){this._tracks.move(t,e),this.layout._adjustProportions(),this.trigger("tracks-moved",{oldIndex:t,newIndex:e})}captions(t){return this._captions.get(t)}visibleCaptions(t){return this._captions.filter((t=>t.visible)).get(t)}addCaptions(t=[]){const e=(t=n.arrayerize(t)).map((t=>new L(this,t)));return this.trigger("captions-add",e),e}updateCaptions(t,e){const{records:s,updates:i}=this.updateRecords(t,e,{recordClass:"Caption",validKeys:["name","on","anchor","position","font","visible","fontColor","textAlignment","backgroundColor"]});this.trigger("captions-update",{captions:s,attributes:e,updates:i})}removeCaptions(t){t=n.arrayerize(t),this._captions=this._captions.filter((e=>!t.includes(e))),this.clear("canvas"),this.refreshCanvasLayer(),t.forEach((t=>t.deleteFromObjects())),this.trigger("captions-remove",t)}moveCaption(t,e){this._captions.move(t,e),this.refreshCanvasLayer(),this.trigger("captions-moved",{oldIndex:t,newIndex:e})}plots(t){return this._plots.get(t)}sources(t){const e=this._features.map((t=>t.source)),s=this._plots.map((t=>t.source)),i=this.tracks().filter((t=>"source"===t.dataMethod)).map((t=>t.dataKeys)).flat(),r=e.concat(s).concat(i);return new n([...new Set(r)]).get(t)}tags(t){const e=this._features.map((t=>t.tags)),s=this.tracks().filter((t=>"tag"===t.dataMethod)).map((t=>t.dataKeys)),i=e.concat(s).flat();return new n([...new Set(i)]).get(t)}updateRecordsWithAttributes(t,e,s={}){const i=s.validKeys,r=s.recordClass,a=Object.keys(e);if(!i||o.validate(a,i)){if(t=n.arrayerize(t),!r||!t.some((t=>t.toString()!==r)))return t.attr(e),t;console.error(`The following records were not of the Class '${r}':`,t.filter((t=>t.toString()!=r)))}}updateRecordsIndividually(t,e={}){const s=e.validKeys,i=e.recordClass;if(s){let e=[];const i=Object.values(t);for(const t of i)e=e.concat(Object.keys(t));const r=[...new Set(e)];if(!o.validate(r,s))return}const r=new n(Object.keys(t)).map((t=>this.objects(t)));if(!i||!r.some((t=>t.toString()!==i))){for(const e of r){const s=Object.keys(t[e.cgvID]);for(const i of s)e[i]=t[e.cgvID][i]}return r}console.error(`The following records were not of the Class '${i}':`,r.filter((t=>t.toString()!=i)))}updateRecords(t=[],e={},s={}){let i,r;return"[object Object]"===t.toString()?(r=t,i=this.updateRecordsIndividually(r,s)):i=this.updateRecordsWithAttributes(t,e,s),{records:i,updates:r,attributes:e}}recordsWithChangedAttributes(t,e,s={},i){e=n.arrayerize(e);let r=new n;t=n.arrayerize(t);const o=Object.keys(s);if(o.length>0){for(const s of t)if(o.includes(s))return e}else if(i)for(const s of e)for(const e of t)Object.keys(i[s.cgvID]).includes(e)&&r.push(s);return r}addFeatures(t=[]){const e=(t=n.arrayerize(t)).map((t=>new V(this,t)));return this.annotation.refresh(),this.trigger("features-add",e),e}removeFeatures(t){t=n.arrayerize(t),this._features=this._features.filter((e=>!t.includes(e)));const e=t.map((t=>t.label));this.annotation.removeLabels(e),this.tracks().each(((e,s)=>{s.removeFeatures(t)})),this.annotation.refresh(),D.removeFeatures(t),t.forEach((t=>t.deleteFromObjects())),this.trigger("features-remove",t)}updateFeatures(t,e){const{records:s,updates:i}=this.updateRecords(t,e,{recordClass:"Feature",validKeys:["name","type","contig","legendItem","source","tags","favorite","visible","strand","start","stop","score","mapStart","mapStop"]});let r,n;if(i){const t=Object.values(i);for(let e of t)r=Object.keys(t).some((t=>["source","type","tags"].includes(t)))}else e&&(r=Object.keys(e).some((t=>["source","type","tags"].includes(t))));if(r)for(let t of cgv.tracks())t.refresh();if(i){const t=Object.values(i);for(let e of t)(Object.keys(e).includes("start")||Object.keys(e).includes("stop")||Object.keys(e).includes("visible"))&&(n=!0)}else n=e&&(Object.keys(e).includes("start")||Object.keys(e).includes("stop")||Object.keys(e).includes("visible"));n&&this.annotation.refresh(),this.trigger("features-update",{features:s,attributes:e,updates:i})}addPlots(t=[]){const e=(t=n.arrayerize(t)).map((t=>new it(this,t)));return this.annotation.refresh(),this.trigger("plots-add",e),e}removePlots(t){t=n.arrayerize(t),this._plots=this._plots.filter((e=>!t.includes(e))),t.each(((t,e)=>{e.tracks().each(((t,e)=>{e.removePlot()}))})),t.forEach((t=>t.deleteFromObjects())),this.trigger("plots-remove",t)}updatePlots(t,e){const{records:s,updates:i}=this.updateRecords(t,e,{recordClass:"Plot",validKeys:["name","type","legend","legendPositive","legendNegative","source","favorite","visible","baseline","axisMin","axisMax"]});this.trigger("plots-update",{plots:s,attributes:e,updates:i})}bookmarks(t){return this._bookmarks.get(t)}addBookmarks(t=[]){const e=(t=n.arrayerize(t)).map((t=>new F(this,t)));return this.trigger("bookmarks-add",e),e}removeBookmarks(t){t=n.arrayerize(t),this._bookmarks=this._bookmarks.filter((e=>!t.includes(e))),t.forEach((t=>t.deleteFromObjects())),this.trigger("bookmarks-remove",t)}bookmarkByShortcut(t){return this.bookmarks().find((e=>e.shortcut&&e.shortcut===`${t}`))}updateBookmarks(t,e){const{records:s,updates:i}=this.updateRecords(t,e,{recordClass:"Bookmark",validKeys:["name","bp","zoom","format","favorite","shortcut","bbOffset"]});this.trigger("bookmarks-update",{bookmarks:s,attributes:e,updates:i})}clear(t="map"){this.canvas.clear(t)}flash(t){this.messenger.flash(t)}fillBackground(){this.clear("background")}drawFull(){this.layout.drawFull()}drawFast(){this.layout.drawFast()}drawExport(){this.layout.drawExport()}draw(t){this.layout.draw(t)}featureTypes(t){return this._features.map((t=>t.type)).unique().get(t)}featuresByType(t){return this._features.filter((e=>e.type===t))}featuresBySource(t){return this._features.filter((e=>e.source===t))}refreshCanvasLayer(){for(let t=0,e=this._captions.length;t<e;t++)this._captions[t].visible&&this._captions[t].refresh();this.legend&&this.legend.refresh()}animate(t=5,e={},s=0,i=!1,r=!0){const n=e.noReset,a=e.resetPosition,h=o.defaultFor(e.resetDuration,3e3),l=o.defaultFor(e.resetPause,1e3),c=o.defaultFor(e.elementDuration,3e3),d=o.defaultFor(e.elementPause,1e3);if(r&&this.stopAnimate(),Number.isInteger(t)){const e=this.features();if(!(e.length>0))return void console.error("No features to animate");{let s=[];for(let i=0;i<t;i++){const t=e[Math.floor(Math.random()*e.length)];s.push(t)}t=s}}const g=i&&!n,u=g?h+l:c+d;g?a?a.moveTo(h):this.reset(h):(t[s].moveTo(c),s=s>=t.length-1?0:s+1),this._animateTimeoutID=setTimeout((()=>{this.animate(t,e,s,!i,!1)}),u)}stopAnimate(){clearTimeout(this._animateTimeoutID),this._animateTimeoutID=void 0,i.select(this.canvas.node("ui")).interrupt()}moveTo(t,e,s={}){if(e){const i=this.sequence.lengthOfRange(t,e),r=this.sequence.addBp(t,i/2),n=this.layout.zoomFactorForLength(i);this.zoomTo(r,n,s)}else this._moveTo(t,s)}_moveTo(t,e={}){const s=this,r=this.layout,{bbOffset:n=o.defaultFor(e.bbOffset,0),duration:a=o.defaultFor(e.duration,1e3),ease:h=o.defaultFor(e.ease,i.easeCubic),callback:l}=e,{startProps:c,endProps:d}=this._moveProps(t,void 0,n),g="circular"===this.settings.format;i.select(this.canvas.node("ui")).transition().duration(a).ease(h).tween("move",(function(){const t=i.interpolateObject(c,d);return function(e){if(g&&c.zoomFactor>3&&d.zoomFactor>3){const i=r.domainsFor(t(e).bp,t(e).zoomFactor,t(e).bbOffset);s.scale.x.domain([i[0],i[1]]),s.scale.y.domain([i[2],i[3]])}else s.scale.x.domain([t(e).domainX0,t(e).domainX1]),s.scale.y.domain([t(e).domainY0,t(e).domainY1]);s.trigger("zoom"),s.drawFast()}})).on("end",(function(){l?l.call():s.drawFull()}))}_moveLeftRight(t=.5,e,s={}){const i=this.canvas.bpForCanvasCenter();let r=this.sequence.length*t/this.zoomFactor;"right"!==e&&(r*=-1);let n=i+r;"linear"===this.format&&(n=o.constrain(i+r,1,this.sequence.length)),this.moveTo(n,null,s)}moveLeft(t,e={}){this._moveLeftRight(t,"left",e)}moveRight(t,e={}){this._moveLeftRight(t,"right",e)}_moveProps(t=this.bp,e=this.zoomFactor,s=this.bbOffset){const i=this.scale.x.domain(),r=this.scale.y.domain();let n=this.bp,o=t;if("circular"===this.settings.format){Math.abs(o-n)>this.sequence.length/2&&(o>n?o-=this.sequence.length:n-=this.sequence.length)}const a=this.layout.domainsFor(t,e,s);return{startProps:{bp:n,zoomFactor:this.zoomFactor,bbOffset:this.bbOffset,domainX0:i[0],domainX1:i[1],domainY0:r[0],domainY1:r[1]},endProps:{bp:o,zoomFactor:e,bbOffset:s,domainX0:a[0],domainX1:a[1],domainY0:a[2],domainY1:a[3]}}}zoomTo(t,e,s={}){const r=this,n=this.layout,{bbOffset:a=o.defaultFor(s.bbOffset,0),duration:h=o.defaultFor(s.duration,1e3),ease:l=o.defaultFor(s.ease,i.easeCubic),callback:c}=s,d=r._zoom.scaleExtent();e=o.constrain(e,d[0],d[1]);const{startProps:g,endProps:u}=this._moveProps(t,e,a),p="circular"===this.settings.format;i.select(this.canvas.node("ui")).transition().duration(h).ease(l).tween("move",(function(){const t=i.interpolateObject(g,u);return function(e){if(p&&g.zoomFactor>3&&u.zoomFactor>3){const s=n.domainsFor(t(e).bp,t(e).zoomFactor,t(e).bbOffset);r.scale.x.domain([s[0],s[1]]),r.scale.y.domain([s[2],s[3]])}else r.scale.x.domain([t(e).domainX0,t(e).domainX1]),r.scale.y.domain([t(e).domainY0,t(e).domainY1]);r._zoomFactor=t(e).zoomFactor,i.zoomTransform(r.canvas.node("ui")).k=t(e).zoomFactor,r.layout.adjustBpScaleRange(),r.trigger("zoom"),r.drawFast()}})).on("start",(function(){r.trigger("zoom-start")})).on("end",(function(){r.trigger("zoom-end"),c?c.call():r.drawFull()}))}zoomIn(t=2,e){const s=o.constrain(this.canvas.bpForCanvasCenter(),1,this.sequence.length);this.zoomTo(s,this.zoomFactor*t,e)}zoomOut(t=2,e){const s=o.constrain(this.canvas.bpForCanvasCenter(),1,this.sequence.length);this.zoomTo(s,this.zoomFactor/t,e)}reset(t=1e3,e){this.zoomTo(0,1,{duration:t,ease:e})}recenterTracks(t=0){this.moveTo(this.bp,void 0,{duration:t})}_updateZoomMax(){this._zoom&&this._zoom.scaleExtent([this.minZoomFactor,this.maxZoomFactor])}invertColors(){this.settings.update({backgroundColor:this.settings.backgroundColor.invert().rgbaString}),this.legend.invertColors(),this.captions().each(((t,e)=>e.invertColors())),this.refreshCanvasLayer(),this.ruler.invertColors(),this.dividers.invertColors(),this.backbone.invertColors(),this.sequence.invertColors(),this.annotation.invertColors(),this.draw()}on(t,e){this.events.on(t,e)}off(t,e){this.events.off(t,e)}trigger(t,e){this.events.trigger(t,e);if(!this.loading&&!["viewer-update","cgv-json-load","bookmarks-shortcut","zoom-start","zoom","zoom-end"].includes(t)){const s=e&&e.attributes&&Object.keys(e.attributes);if(s&&1===s.length&&"loadProgress"===s[0])return;if("plots-add"===t){if(e.every((t=>t.extractedFromSequence)))return}if("features-add"===t){if(e.every((t=>t.extractedFromSequence)))return}if("tracks-update"===t){if(void 0===(e&&e.attributes))return}this.update({dataHasChanged:!0})}}}return t.Anchor=h,t.Annotation=k,t.Backbone=S,t.Bookmark=F,t.Box=C,t.CGArray=n,t.CGObject=c,t.CGRange=M,t.Canvas=P,t.Caption=L,t.CodonTable=T,t.CodonTables=O,t.Color=y,t.ColorPicker=I,t.Contig=D,t.Debug=$,t.Divider=E,t.Dividers=z,t.EventMonitor=G,t.Events=f,t.Feature=V,t.Font=_,t.Highlighter=H,t.HighlighterElement=K,t.IO=X,t.Label=W,t.Layout=et,t.LayoutCircular=Z,t.LayoutLinear=tt,t.Legend=Q,t.LegendItem=U,t.Messenger=st,t.NCList=x,t.Plot=it,t.Position=a,t.Rect=d,t.Ruler=Y,t.Sequence=j,t.SequenceExtractor=q,t.Settings=J,t.Slot=rt,t.Track=nt,t.Viewer=ot,t.utils=o,t.version=r,Object.defineProperty(t,"__esModule",{value:!0}),t}({},d3);
